#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<string>
#include<vector>
#include<sstream>
#include<iostream>
#include<algorithm>
#include<map>

using namespace std;

#define VI vector < int >
#define VS vector < string >
#define pb push_back
#define sz size()
#define cs c_str()
#define ALL(a) (a).begin(),(a).end()
/////////////////////////

struct point 
  {int x,y;
  point(){x=y=0;}
  point(int a,int b){x=a;y=b;}};
struct line 
  {point a,b;
  line(){a=b=point(0,0);}
  line(point aa,point bb){a=aa;b=bb;}};
  
int det22(int a,int b,int c,int d)
  {return a*d-b*c;}
int det2(point a,point b,point c)
  {return det22(b.x-a.x,b.y-a.y,c.x-a.x,c.y-a.y);}

int operator*(line a,line b)
  {int c1,c2,c3,c4;
  c1=det2(a.a,a.b,b.a);
  c2=det2(a.a,a.b,b.b);
  c3=det2(b.a,b.b,a.a);
  c4=det2(b.a,b.b,a.b);
  if(c1*c2<0 && c3*c4<0)return 1;
  return 0;}

int mm[8][2]={{1,2},{2,1},{-1,2},{2,-1},{-2,1},{1,-2},{-1,-2},{-2,-1}};

vector < point > bp,wp;
vector < VI > bl,wl;
vector < line > b,w;
VI vis;
vector < VI > mp;

int ans,q1,q2,q3,q4,c1,c2,c3,c4,c5,c,m,x2,y2;
point p1,p2,p3,l1,l2,l3;

int dfs(int a,vector < VI > & nei)
  {int q1;
  vis[a]=1;
  for(q1=0;q1<nei[a].sz;q1++)if(!vis[nei[a][q1]])
    dfs(nei[a][q1],nei);
  return 0;}

int clear()
  {
  ans=q1=q2=q3=q4=c1=c2=c3=c4=c=m=0;
  bp.clear();
  wp.clear();
  bl.clear();
  wl.clear();
  vis.clear();
  mp.clear();
  b.clear();
  w.clear();
  return 0;}
int main()
  {
  while(1)
    {
    clear();
    
    scanf("%d %d",&c,&m);
    if(c==0 && m==0)break;
    
    mp.resize(c+1,VI(c+1,2*m));
    
    vector < point > all;
    
    for(q1=0;q1<m;q1++)
      {scanf("%d %d",&c1,&c2);
      all.pb(point(c1,c2));}
    
    for(q1=0;q1<m;q1++)
      {
      if(q1%2==0)
        {
        bl.resize(bl.sz+1);
        bp.pb(all[q1]);
        mp[all[q1].x][all[q1].y]=bp.sz-1;
        for(q2=0;q2<8;q2++)
          {x2=all[q1].x+mm[q2][0];
          y2=all[q1].y+mm[q2][1];
          if(x2<0||y2<0||x2>c||y2>c)continue;
          if(mp[x2][y2]==2*m || mp[x2][y2]>=m)continue;
          
          line l1=line(all[q1],point(x2,y2));
          for(q3=0;q3<b.sz;q3++)if(l1*b[q3])break;
          if(q3!=b.sz)continue;
          for(q3=0;q3<w.sz;q3++)if(l1*w[q3])break;
          if(q3!=w.sz)continue;
          
          bl[q1/2].pb(mp[x2][y2]);
          bl[mp[x2][y2]].pb(q1/2);
          
          b.pb(l1);
          }
        }
      else
        {
        wl.resize(wl.sz+1);
        wp.pb(all[q1]);
        mp[all[q1].x][all[q1].y]=wp.sz-1+m;
        for(q2=0;q2<8;q2++)
          {x2=all[q1].x+mm[q2][0];
          y2=all[q1].y+mm[q2][1];
          if(x2<0||y2<0||x2>c||y2>c)continue;
          if(mp[x2][y2]==2*m || mp[x2][y2]<m)continue;
          
          line l1=line(all[q1],point(x2,y2));
          for(q3=0;q3<b.sz;q3++)if(l1*b[q3])break;
          if(q3!=b.sz)continue;
          for(q3=0;q3<w.sz;q3++)if(l1*w[q3])break;
          if(q3!=w.sz)continue;
          
          wl[q1/2].pb(mp[x2][y2]-m);
          wl[mp[x2][y2]-m].pb(q1/2);
          
          w.pb(l1);
          }
        }
        
      ans=0;
      vis.clear();
      vis.resize(bl.sz);
      if(q1%2==0)
        {
        for(q2=0;q2<=c;q2++)
          if(mp[0][q2]!=2*m)if(mp[0][q2]<m)if(!vis[mp[0][q2]])
            dfs(mp[0][q2],bl);
        for(q2=0;q2<=c;q2++)
          if(mp[c][q2]!=2*m)if(mp[c][q2]<m)if(vis[mp[c][q2]])break;
        
        if(q2!=c+1)
          {
          if(q1==m-1)ans=1;
          else ans=0;
          break;
          }
        }
      vis.clear();
      vis.resize(wl.sz);
      if(q1%2==1)
        {
        for(q2=0;q2<=c;q2++)
          if(mp[q2][0]!=2*m)if(mp[q2][0]>=m)if(!vis[mp[q2][0]-m])dfs(mp[q2][0]-m,wl);
        for(q2=0;q2<=c;q2++)
          if(mp[q2][c]!=2*m)if(mp[q2][c]>=m)if(vis[mp[q2][c]-m])break;
        
        if(q2!=c+1)
          {
          ans=0;
          break;
          }
        }
      }
    if(ans==0)printf("no\n");
    else printf("yes\n");
    }
  return 0;}