#include<stdio.h>
#include"module.h"
#include<stdlib.h>
#define mx 8
#define states 524288
#define maxmoves 64
#define ABS(a) ((a)<0?-(a):(a))
#define in fopen("c:\\tp\\tests\\chess\\chess.in","r")
int mc[maxmoves][2],moves;
int mcc[mx*2][mx*2];
int mk[8][2]={{1,-1},{-1,0},{-1,1},{0,-1},{0,1},{-1,-1},{1,0},{1,1}};
FILE*fn;
typedef struct{int x[3],y[3],m;} state;
typedef struct{int who;char col;int row;}mm;
int encode(state a)
  {int c1=a.x[0];
  c1=c1*mx+a.y[0];
  c1=c1*mx+a.x[1];
  c1=c1*mx+a.y[1];
  c1=c1*mx+a.x[2];
  c1=c1*mx+a.y[2];
  c1=c1*2+a.m;
  return c1;}
state decode(int a)
  {state e1;
  e1.m=a%2;a/=2;
  e1.y[2]=a%mx;a/=mx;
  e1.x[2]=a%mx;a/=mx;
  e1.y[1]=a%mx;a/=mx;
  e1.x[1]=a%mx;a/=mx;
  e1.y[0]=a%mx;a/=mx;
  e1.x[0]=a%mx;a/=mx;
  return e1;}
///////////GAME////////////////
int win[states];
int len[states];
int ns[states];
int dns[states];
int wns[states];
int dwns[states];
int st[states],stc;
int to[states];
int ok[states];

int calcI(void)
  {int q1;
  state e1;
  for(q1=0;q1<states;q1++)
    {e1=decode(q1);
    if(e1.x[0]==e1.x[1]&&e1.y[0]==e1.y[1])win[q1]=3;
    if(e1.x[0]==e1.x[2]&&e1.y[0]==e1.y[2])win[q1]=3;
    if(e1.x[2]==e1.x[1]&&e1.y[2]==e1.y[1])win[q1]=3;

    if(win[q1]==3&&q1%1000==0)
      q1=q1*2-q1;
    }
  return 0;}
int calcPN(void)
  {int q1,c1,c2,q2;
  state e1;
  for(q1=0;q1<states;q1++)if(win[q1]==0)
    {e1=decode(q1);
    if(e1.m==1)continue;
    c1=ABS(e1.x[0]-e1.x[2]);
    c2=ABS(e1.y[0]-e1.y[2]);
          if(e1.x[1]==e1.x[2])
        q1=q1*2-q1;
    if(c1<=1&&c2<=1)
      {win[q1]=1;
      len[q1]=1;
      st[stc++]=q1;
      to[q1]=-1;
      continue;}
    for(q2=0;q2<moves;q2++)if(mc[q2][0]+e1.x[1]==e1.x[2]&&mc[q2][1]+e1.y[1]==e1.y[2])
      {win[q1]=1;
      len[q1]=1;
      st[stc++]=q1;
      to[q1]=-1;
      continue;}}
  for(q1=0;q1<states;q1++)if(win[q1]==0)
    {e1=decode(q1);
    if(e1.m==0)continue;
    c1=ABS(e1.x[0]-e1.x[2]);
    c2=ABS(e1.y[0]-e1.y[2]);
    if(c1<=1&&c2<=1)
      {win[q1]=2;
      len[q1]=1;
      st[stc++]=q1;
      to[q1]=-1;
      continue;}
    c1=ABS(e1.x[1]-e1.x[2]);
    c2=ABS(e1.y[1]-e1.y[2]);
    if(c1<=1&&c2<=1)
      {c1=ABS(e1.x[0]-e1.x[1]);
      c2=ABS(e1.y[0]-e1.y[1]);
      if(c1<=1&&c2<=1);
      else
        {win[q1]=2;
        len[q1]=1;
        st[stc++]=q1;
        to[q1]=-1;
        continue;}}}
  return 0;}
int valid(state*a)
  {if(a->x[0]<0||a->x[0]>=mx)return 0;
  if(a->x[1]<0||a->x[1]>=mx)return 0;
  if(a->x[2]<0||a->x[2]>=mx)return 0;
  if(a->y[0]<0||a->y[0]>=mx)return 0;
  if(a->y[1]<0||a->y[1]>=mx)return 0;
  if(a->y[2]<0||a->y[2]>=mx)return 0;
  if(win[encode(*a)]==3)return 0;
  return 1;}
int move(state a,int b)
  {if(a.m==1)if(b>=8)return -1;
  
  if(a.m==0)
    {if(b<8)
      {a.x[0]+=mk[b][0];
      a.y[0]+=mk[b][1];}
    else
      {b-=8;
      a.x[1]+=mc[b][0];
      a.y[1]+=mc[b][1];}}
  else
    {a.x[2]+=mk[b][0];
    a.y[2]+=mk[b][1];}
  if(!valid(&a))return -1;
  a.m=1-a.m;
  return encode(a);}
int backmove(state a,int b)
  {a.m=1-a.m;
  if(a.m==1)if(b>=8)return -1;

  if(a.m==0)
    {if(b<8)
      {a.x[0]+=mk[b][0];
      a.y[0]+=mk[b][1];}
    else
      {b-=8;
      a.x[1]-=mc[b][0];
      a.y[1]-=mc[b][1];}}
  else
    {a.x[2]+=mk[b][0];
    a.y[2]+=mk[b][1];}
  if(!valid(&a))return -1;

  return encode(a);}
int calcmoves(void)
  {int q1,q2,c1,c2;
  state e1;
  for(q1=0;q1<states;q1++)if(win[q1]==0)
    {e1=decode(q1);
    for(q2=0;q2<moves+8;q2++)
      {c1=move(e1,q2);
      if(c1==-1)continue;
      ns[q1]++;}}
  return 0;}
int print(state e1)
  {
//printf("%d %d %d %d %d %d %d\n",e1.x[0],e1.y[0],e1.x[1],e1.y[1],e1.x[2],e1.y[2],e1.m);
  return 0;}
int calcgame(void)
  {state e1,e2,e3;
  int q1,q2,q3,c1,c2,c3,c4,c5;

  for(q3=0;q3<stc;q3++)
//while(stc)
    {c1=st[q3];
//c1=st[--stc];
    e1=decode(c1);
    for(q1=0;q1<moves+8;q1++)if((c2=backmove(e1,q1))!=-1)
      {if(c2>=524288)printf("BIG ERROR\n");
      e2=decode(c2);
      if(win[c2])continue;
      dns[c2]++;
      if(win[c1]==1)wns[c2]++;
      if(e2.m==1)if(win[c1]==2)
        {win[c2]=2;
        st[stc++]=c2;
        print(e2);
        len[c2]=len[c1]+1;to[c2]=c1;
        continue;}
      if(e2.m==1)if(dns[c2]==ns[c2])
        {win[c2]=1;
        st[stc++]=c2;
        print(e2);
        len[c2]=len[c1]+1;to[c2]=c1;
        continue;}
      if(e2.m==0)if(win[c1]==1)
        {win[c2]=1;
        st[stc++]=c2;
        print(e2);
        len[c2]=len[c1]+1;to[c2]=c1;
        continue;}
      if(e2.m==0)if(dns[c2]==ns[c2])
        {win[c2]=2;
        st[stc++]=c2;
        print(e2);
        len[c2]=len[c1]+1;to[c2]=c1;
        continue;}}}

  return 0;}
  
int calcgame3(void)
  {int q1,q2,c1,c2,c3,c4;
  state e1,e2,e3;
  for(q1=0;q1<states;q1++)if(to[q1]==-1){st[stc++]=q1;ok[q1]=1;}
  for(q1=0;q1<states;q1++)if(to[q1]!=-1)if(win[q1]!=3)
    {if((win[q1]==1&&decode(q1).m==0)||(decode(q1).m==1&&win[q1]==2))
      len[q1]=states;
    else
      len[q1]=0;}
  for(q1=0;q1<states;q1++)dns[q1]=0;
      
  while(stc)
    {c1=st[--stc];
    if(stc==2200)
      c1=c1*2-c1;
    e1=decode(c1);
    if(len[c1]>100)
      c1=c1*2-c1;
    for(q1=0;q1<moves+8;q1++)if((c2=backmove(e1,q1))!=-1)
      {e2=decode(c2);
      if(ok[c2])continue;
      dns[c2]++;
      if(win[c1]==1)dwns[c2]++;
      
      if(win[c2]==1&&e2.m==0&&win[c1]==1)
        {if(len[c1]+1<len[c2])
          {len[c2]=len[c1]+1;
          to[c2]=c1;}}
          
      if(win[c2]==2&&e2.m==0&&win[c1]==2)
        {if(len[c1]+1>len[c2])
          {len[c2]=len[c1]+1;
          to[c2]=c1;}}

      if(win[c2]==1&&e2.m==1&&win[c1]==1)
        {if(len[c1]+1>len[c2])
          {len[c2]=len[c1]+1;
          to[c2]=c1;}}
          
      if(win[c2]==2&&e2.m==1&&win[c1]==2)
        {if(len[c1]+1<len[c2])
          {len[c2]=len[c1]+1;
          to[c2]=c1;}}
          
      if(e2.m==0)if((win[c2]==1&&dwns[c2]==wns[c2])||(win[c2]==2&&dns[c2]==ns[c2]))
        {st[stc++]=c2;
        ok[c2]=1;}
      if(e2.m==1)if((win[c2]==2&&dns[c2]-dwns[c2]==ns[c2]-wns[c2])||(win[c2]==1&&dns[c2]==ns[c2]))
        {st[stc++]=c2;
        ok[c2]=1;}

      }
    }
  for(q1=0;q1<states;q1++)if(win[q1]!=3)if(len[q1]<1||len[q1]>10000)
    printf("%d\n",q1);
  for(q1=0;q1<states;q1++)
    {ok[q1]--;
    if(win[q1]!=3)ok[len[q1]]++;}
//  for(q1=0;q1<states;q1++)
//   printf("%d - %d\n",q1,ok[q1]);
//  for(q1=0;q1<50;q1++)printf("%d -%d\n",q1,ok[q1]);
  return 0;}
mm getmove(int a)
  {mm e1;
  state e2,e3;
  int q1,c1,c2;
  e3=decode(a);
  if(to[a]!=-1)
    {e2=decode(to[a]);
    for(q1=0;q1<3;q1++)
      if(!(e2.x[q1]==e3.x[q1]&&e2.y[q1]==e3.y[q1]))
        break;
    e1.who=q1;
    e1.col=e2.x[q1]+'a';
    e1.row=e2.y[q1]+1;
    return e1;}

  if(e3.m==0)
    {c1=ABS(e3.x[0]-e3.x[2]);
    c2=ABS(e3.y[0]-e3.y[2]);
    if(c1<=1&&c2<=1)
      {e1.who=0;
      e1.col=e3.x[2]+'a';
      e1.row=e3.y[2]+1;
      return e1;}
    c1=e3.x[2]-e3.x[1];
    c2=e3.y[2]-e3.y[1];
    if(mcc[c1+mx][c2+mx])
      {e1.who=1;
      e1.col=e3.x[2]+'a';
      e1.row=e3.y[2]+1;
      return e1;}}

  c1=ABS(e3.x[0]-e3.x[2]);
  c2=ABS(e3.y[0]-e3.y[2]);
  if(c1<=1&&c2<=1)
    {e1.who=2;
    e1.col=e3.x[0]+'a';
    e1.row=e3.y[0]+1;
    return e1;}

  c1=ABS(e3.x[1]-e3.x[2]);
  c2=ABS(e3.y[1]-e3.y[2]);
  if(c1<=1&&c2<=1)
    {e1.who=2;
    e1.col=e3.x[1]+'a';
    e1.row=e3.y[1]+1;
    return e1;}

  return e1;}
int domove(int a,mm move,int*ww)
  {state e1;
  e1=decode(a);
 // move.col-='a';
 // move.row--;
  e1.x[move.who]=move.col;
  e1.y[move.who]=move.row;
  *ww=0;
  if(e1.m==0)
    if(to[a]==-1)*ww=1;
  if(e1.m==1)
    if(to[a]==-1)*ww=2;
  e1.m=1-e1.m;
  return encode(e1);}
///////JURY////////////////////
state ccur;
/*int moveKing(char a,int b)
  {mm move1;
  int c1;
  move1.who=0;
  move1.col=a-'a';
  move1.row=b-1;
  ccur=decode(domove(encode(ccur),move1,&c1));
  if(c1==1)printf("WIN\n");
  return 0;}
int moveColonel(char a,int b)
  {mm move1;
  int c1;
  move1.who=1;
  move1.col=a-'a';
  move1.row=b-1;
  ccur=decode(domove(encode(ccur),move1,&c1));
  if(c1==1)printf("WIN\n");
  return 0;}
int getKing(char*a,int*b)
  {mm move,m1;
  int c1;
  move=getmove(encode(ccur));
  *a=move.col;
  *b=move.row;
  m1=move;
  m1.col-='a';
  m1.row--;
  ccur=decode(domove(encode(ccur),m1,&c1));
  if(c1==2)printf("LOSE\n");
  return 0;} */
///////////////////////////////
state read(void)
  {state e1;
  int q1,c1;
  char a;
  fn=in;
  for(q1=0;q1<3;q1++)
    {fscanf(fn,"%c%d ",&a,&c1);
    a-='a';
    c1--;
    e1.x[q1]=a;
    e1.y[q1]=c1;
    }
  fscanf(fn,"%d",&moves);
  for(q1=0;q1<moves;q1++)
    fscanf(fn,"%d %d",&mc[q1][0],&mc[q1][1]);
  for(q1=0;q1<moves;q1++)mcc[mc[q1][0]+mx][mc[q1][1]+mx]=1;
  fclose(fn);
  e1.m=0;
  return e1;}

  int g[4];
state init(void)
  {int q1,q2,c1,c2;
  state e1,e2;
  calcI();
  e2=read();
  calcPN();

  for(q2=0;q2<stc;q2++)
    {q1=st[q2];
    e1=decode(q1);
   // printf("%d %d %d %d %d %d %d\n",e1.x[0],e1.y[0],e1.x[1],e1.y[1],e1.x[2],e1.y[2],e1.m);
    }


  calcmoves();
  calcgame();

//  calcgame3();

  for(q1=0;q1<states;q1++)
    {e1=decode(q1);
    if(q1==encode(e2))printf("%d %d %d %d %d %d %d - %d %d %d\n",e1.x[0],e1.y[0],e1.x[1],e1.y[1],e1.x[2],e1.y[2],e1.m,win[q1],ns[q1],len[q1]);
}
  
//  exit(0);
  return e2;}

state start,cur,e1,e2;
mm move1,move2;
int c1,c2,c3;
int main()
  {start=init();
  ccur=start;
  cur=start;
//  printf("gfgf\n");
  while(1)
    {
    move1=getmove(encode(cur));

    if(move1.who==0)moveKing(move1.col,(long)move1.row);
    if(move1.who==1)moveColonel(move1.col,(long)move1.row);

    move2.who=move1.who;
    move2.col=move1.col-'a';
    move2.row=move1.row-1;
    c1=domove(encode(cur),move2,&c2);
    if(c2)break;
    cur=decode(c1);
    move1.who=2;

    getKing(&move1.col,(long*)&move1.row);

    move2.who=move1.who;
    move2.col=move1.col-'a';
    move2.row=move1.row-1;
    c1=domove(encode(cur),move2,&c2);
    if(c2)break;
    cur=decode(c1);
    }
  printf("moi krai\n");
  return 0;}
