#include<stdio.h>
#include<time.h>
#define mx 105
#define mm 100000
#define base 10
//while multiplying L*L base*base*mx*2 must be < MAXINT
#define in stdin;//fopen("c:\\tp\\tests\\cub.in","r")
FILE*fn;
struct L
{int ss[mx];
L(){for(int q1=0;q1<mx;q1++)ss[q1]=0;}
L(int a){for(int q1=mx-1,c1=a;q1>=0;q1--){ss[q1]=c1%base;c1/=base;}};
};
int dif(const L&a,const L&b)
  {int q1;
  for(q1=0;q1<mx;q1++)if(a.ss[q1]!=b.ss[q1])break;
  if(q1==mx)return 0;
  return a.ss[q1]-b.ss[q1];}
int operator<(const L&a,const L&b){int c1=dif(a,b);return c1<0;}
int operator>(const L&a,const L&b){int c1=dif(a,b);return c1>0;}
int operator==(const L&a,const L&b){int c1=dif(a,b);return c1==0;}
int operator!=(const L&a,const L&b){int c1=dif(a,b);return c1!=0;}
int operator<=(const L&a,const L&b){int c1=dif(a,b);return c1<=0;}
int operator>=(const L&a,const L&b){int c1=dif(a,b);return c1>=0;}
L operator+(const L&a,const L&b)
  {L c;
  for(int q1=mx-1,c1=0;q1>=0;q1--)
    {c1+=a.ss[q1]+b.ss[q1];
    c.ss[q1]=c1%base;
    c1/=base;}
  return c;}
L operator-(const L&a,const L&b)
  {L c;
  if(b>a)return b-a;
  for(int q1=mx-1,c1=0,c2=0;q1>=0;q1--)
    {c1=a.ss[q1]-b.ss[q1]-c2;
    c2=0;
    if(c1<0){c1+=base;c2=1;}
    c.ss[q1]=c1;}
  return c;}
L operator*(const L&a,int b)
  {L c;
  for(int q1=mx-1,c1=0;q1>=0;q1--)
    {c1+=a.ss[q1]*b;
    c.ss[q1]=c1%base;
    c1/=base;}
  return c;}
L operator/(const L&a,int b)
  {L c;
  for(int q1=0,c1=0;q1<mx;q1++)
    {c1+=a.ss[q1];
    c.ss[q1]=c1/b;
    c1=(c1%b)*base;}
  return c;}
L operator%(const L&a,int b)
  {L c;
  int c1=0;
  for(int q1=0;q1<mx;q1++)
    {c1+=a.ss[q1];
    c.ss[q1]=c1/b;
    c1=(c1%b)*base;}
  return c1/base;}
L operator*(const L&a,const L&b)
  {L c;
  for(int q1=mx-1;q1>=0;q1--)for(int q2=mx-1;q2>=0;q2--)if(q1+q2-mx+1>=0)
    c.ss[q1+q2-mx+1]+=a.ss[q1]*b.ss[q2];
  c=c*1;
  return c;}
L operator^(L a,L b)
  {L d=1,c;
  while(a%2==0&&b%2==0)
    {a=a/2;
    b=b/2;
    d=d*2;}
  while(a>0)
    {if(a%2==0)a=a/2;
    else if(b%2==0)b=b/2;
    else
      {c=(a-b)/2;
      if(a<b)b=c;else a=c;}}
  return d*b;}
int len(const L a)
  {int q1;
  for(q1=0;q1<mx;q1++)if(a.ss[q1]!=0)break;
  return mx-q1;}
L pw(const L&a,int b)
  {L c=1;
  for(int q1=0;q1<b;q1++)c=c*a;
  return c;}
L read(void)
  {int q1,c1;
  char d[mx];
  L c;
  fscanf(fn,"%s",d);
  for(q1=0;d[q1];q1++);
  c1=q1;
  for(q1=0;q1<c1;q1++)c.ss[mx-c1+q1]=d[q1]-48;
  return c;}
int write(L a)
  {int q1;
  for(q1=0;q1<mx&&a.ss[q1]==0;q1++);
  if(q1==mx)q1--;
  for(;q1<mx;q1++)printf("%d",a.ss[q1]);
  printf("\n");
  return 0;}
int operator!(const L&rem)
  {int c1=0;
  for(int q1=0;q1<mx;q1++)
    c1=c1*10+rem.ss[q1];
  return c1;}

int d[mm][6];
int p[mm][6];

int solve(int n,L&ans,L*ss)
  {L rem,l,r,m,res,m3;
  int q1,q2,c1,c2,c3;

  rem=pw(10,n/3)-1;
  while(len(rem*rem*rem)!=n)rem=rem*2;
  ans=rem;
  rem=rem*rem*rem;

  for(q1=0;q1<n-5;q1++)
    {l=pw(10,len(rem)/3-1)*2-1;
    r=pw(10,len(rem)/3+1)/2-1;

    while(l+1<r)
      {m=(l+r)/2;
      m3=m*m*m;
  //    printf("here - ");write(m);
      if(m3>rem){r=m;continue;}
      res=rem-m3;
      if(len(res)<n-q1-1)r=m;
      else if(len(res)>n-q1-1)l=m;
      else {l=r=m;break;}
      }

    res=rem-l*l*l;
    if(len(res)==n-1-q1)m=l;
    res=rem-r*r*r;
    if(len(res)==n-1-q1)m=r;

    rem=rem-m*m*m;
    ss[q1]=m;

    rem=rem;}

  m=rem;

  c1=!rem;


  if(d[c1][5]==0)
    {//printf("error %d\n",n);
    c1=-1;
    l=ss[n-6];
    while(d[!rem][5]==0)
      {if(len(rem)>5)break;
      rem=rem+ss[n-6]*ss[n-6]*ss[n-6];
      ss[n-6]=ss[n-6]-1;
      rem=rem-ss[n-6]*ss[n-6]*ss[n-6];
      }
    if(d[!rem][5])
      {c1=!rem;
      goto ok;}
    else
      ss[n-6]=l;

    c1=-1;
    l=ss[n-6];
    while(d[!rem][5]==0)
      {if(len(rem)<5)break;
      rem=rem+ss[n-6]*ss[n-6]*ss[n-6];
      ss[n-6]=ss[n-6]+1;
      rem=rem-ss[n-6]*ss[n-6]*ss[n-6];
      }
    if(d[!rem][5])
      {c1=!rem;
      goto ok;}
    else
      ss[n-6]=l;

    printf("not found\n");
    return 0;}

  ok:
  q1=n-5;
  c2=0;
  while(q1<n)
    {ss[q1++]=p[c1][5-c2];
    c1-=p[c1][5-c2]*p[c1][5-c2]*p[c1][5-c2];
    c2++;}

  return 0;}



L n;
L ss[mx];
int t,c1;

int init();
int tttt;
int main()
  {clock();
fn=in;

  init();

  fscanf(fn,"%d",&tttt);

  for(;tttt;tttt--)
    {fscanf(fn,"%d",&c1);
    if(c1<5)
      {if(c1==1||c1==2)printf("NO\n");
      else if(c1==3)printf("9\n8\n6\n1\n");
      else if(c1==4)printf("13\n10\n9\n7\n5\n");
      continue;}

    solve(c1,n,ss);

    write(n);
    for(int q1=0;q1<c1;q1++)write(ss[q1]);

    L ans1,ans2;
    ans1=n*n*n;
    for(int q1=0;q1<c1;q1++)ans2=ans2+ss[q1]*ss[q1]*ss[q1];

    if(ans1!=ans2)printf("ERROR\n");
    }





  fclose(fn);

//  printf("%lf\n",(double)clock()/CLOCKS_PER_SEC);
  return 0;}
int init(void)
  {int q1,q2,q3;
  d[0][0]=1;
  for(q2=1;q2*q2*q2<mm;q2++)
  for(q3=5;q3>=1;q3--)
  for(q1=mm-1;q1>=q2*q2*q2;q1--)
    if(d[q1-q2*q2*q2][q3-1])
      {d[q1][q3]=1;
      p[q1][q3]=q2;}
  return 0;}

