#include<stdio.h>
#include<time.h>
#include<stdlib.h>
#define mx 131072
#define maxx 131072
#define in stdin;//fopen("c:\\tp\\tests\\cut.in","r")
FILE*fn;
//////////TREE//////////////////////
typedef struct {int a,l,r;}node;
typedef struct {int size;node*ss;}tree;
int maketree(tree*a,int size)
  {int q1,c1,c2,q2;
  size--;
  c1=1,c2=0;
  while(size){size/=2;c1*=2;c2++;}
  c2++;
  c1*=2;
  a->size=c1*2;
  a->ss=(node*)malloc(a->size*sizeof(node));
  for(q1=0;q1<a->size;q1++)a->ss[q1].a=-1;
  for(q1=0;q1<=c2;q1++)
    for(q2=(1<<q1);q2<(2<<q1);q2++)
      {a->ss[q2].l=(q2-(1<<q1))*(1<<(c2-q1));
      a->ss[q2].r=a->ss[q2].l+(1<<(c2-q1))-1;}
  return 0;}
int update(tree*a,int where,int l,int r,int n)
  {//printf("%d %d %d %d\n",where,l,r,n);
  if(a->ss[where].l==l&&a->ss[where].r==r)
    {a->ss[where].a=n;
    return 0;}
  if(r<=(a->ss[where].l+a->ss[where].r)/2)update(a,where*2,l,r,n);
  else if(l>(a->ss[where].l+a->ss[where].r)/2)update(a,where*2+1,l,r,n);
  else
    {update(a,where*2,l,(a->ss[where].l+a->ss[where].r)/2,n);
    update(a,where*2+1,(a->ss[where].l+a->ss[where].r)/2+1,r,n);}
  return 0;}
int ask(tree*a,int b)
  {b+=a->size/2;
  while(b!=1&&a->ss[b].a==-1)
    b/=2;
  return a->ss[b].a;}
////////////////////////////////////
typedef struct {int x,y,i,p;}point;
typedef struct _cut{int x1,y1,x2,y2,f1,f2;struct _cut*id;}cut;
int cmphp(const void*a,const void*b)
  {if(((point*)a)->x==((point*)b)->x)return ((point*)a)->y-((point*)b)->y;
  return ((point*)a)->x-((point*)b)->x;}
int cmpvp(const void*a,const void*b)
  {if(((point*)a)->y==((point*)b)->y)return ((point*)a)->x-((point*)b)->x;
  return ((point*)a)->y-((point*)b)->y;}
int cmphc(const void*a,const void*b)
  {if(((cut*)a)->y1==((cut*)b)->y1)return ((cut*)a)->x1-((cut*)b)->x1;
  return ((cut*)a)->y1-((cut*)b)->y1;}
int cmpvc(const void*a,const void*b)
  {if(((cut*)a)->x1==((cut*)b)->x1)return ((cut*)a)->y1-((cut*)b)->y1;
  return ((cut*)a)->x1-((cut*)b)->x1;}

////////////////end sort functions//
cut heap[mx];
int hccc;
int cmp(int a,int b)
  {if(heap[a].x1<heap[b].x1)return 1;
  else if(heap[a].x1==heap[b].x1)
    if(heap[a].y1<heap[b].y1)return 1;
  return 0;}
int swap(int a,int b)
  {cut e1;
  e1=heap[a];heap[a]=heap[b];heap[b]=e1;
  return 0;}
int ins(cut a)
  {int b;
  heap[++hccc]=a;
  b=hccc;
  while(b>1)
    {if(cmp(b,b/2))
      {swap(b,b/2);
      b/=2;}
    else break;}
  return 0;}
cut ex(void)
  {int c1,c2,c3,b;
  cut e1;
  e1=heap[1];
  heap[1]=heap[hccc];
  hccc--;
  b=1;
  while(b*2<=hccc)
    {c1=b*2;
    c2=c1;
    if(c2+1<=hccc)c2++;
    c3=b;
    if(cmp(c1,c3))c3=c1;
    if(cmp(c2,c3))c3=c2;
    if(c3==b)break;
    swap(c3,b);
    b=c3;}
  return e1;}

//////////////////END HEAP//////////
point hp[mx*4];
point vp[mx*4];
cut vc[mx*2];
cut hc[mx*2];
tree ht[mx];
tree vt[mx];
int hpc,vpc,hcc,vcc,htc,vtc;
int c;

cut box;


int updateh(int q1)
  {point e1,e2;
  point*ee1,*ee2;
  e1.i=e1.p=0;e2=e1;
  e1.x=hc[q1].x1;e1.y=hc[q1].y1;
  ee1=(point*)bsearch(&e1,vp,vpc,sizeof(vp[0]),cmpvp);
  e2.x=hc[q1].x2;e2.y=hc[q1].y2;
  ee2=(point*)bsearch(&e2,vp,vpc,sizeof(vp[0]),cmpvp);
  update(&ht[ee1->i],1,ee1->p,ee2->p,q1);
  return 0;}
int updatev(int q1)
  {point e1,e2;
  point*ee1,*ee2;
  e1.x=vc[q1].x1;e1.y=vc[q1].y1;
  ee1=(point*)bsearch(&e1,hp,hpc,sizeof(hp[0]),cmphp);
  e2.x=vc[q1].x2;e2.y=vc[q1].y2;
  ee2=(point*)bsearch(&e2,hp,hpc,sizeof(hp[0]),cmphp);
  update(&vt[ee1->i],1,ee1->p,ee2->p,q1);
  return 0;}
int init(void)
  {int q1,q2,c1,c2,c3,c4,c5,c6;
  cut cc1,cc2;
  point e1,e2;
  point*ee1,*ee2;
  fn=in;
  box.x1=maxx;
  box.x2=-maxx;
  box.y1=maxx;
  box.y2=-maxx;
  e1.i=e1.p=0;
  cc1.f1=cc1.f2=0;
  cc1.id=NULL;

  fscanf(fn,"%d",&c);
  for(q1=0;q1<c;q1++)
    {fscanf(fn,"%d %d %d %d",&cc1.x1,&cc1.y1,&cc1.x2,&cc1.y2);
    if(box.x2<cc1.x2)box.x2=cc1.x2;
    if(box.x1>cc1.x1)box.x1=cc1.x1;
    if(box.y2<cc1.y2)box.y2=cc1.y2;
    if(box.y1>cc1.y1)box.y1=cc1.y1;
    e1.x=cc1.x1;e1.y=cc1.y1;hp[hpc++]=e1;
    e1.x=cc1.x2;e1.y=cc1.y1;hp[hpc++]=e1;
    e1.x=cc1.x1;e1.y=cc1.y2;hp[hpc++]=e1;
    e1.x=cc1.x2;e1.y=cc1.y2;hp[hpc++]=e1;
    cc2=cc1;cc2.x2=cc1.x1;vc[hcc++]=cc2;
    cc2=cc1;cc2.x1=cc1.x2;vc[hcc++]=cc2;
    cc2=cc1;cc2.y2=cc1.y1;hc[vcc++]=cc2;
    cc2=cc1;cc2.y1=cc1.y2;hc[vcc++]=cc2;}

  for(q1=0;q1<hpc;q1++)vp[q1]=hp[q1];
  vpc=hpc;
  qsort(hp,hpc,sizeof(hp[0]),cmphp);
  qsort(vp,vpc,sizeof(vp[0]),cmpvp);
  qsort(hc,hcc,sizeof(hc[0]),cmphc);
  qsort(vc,vcc,sizeof(vc[0]),cmpvc);

  for(c1=q1=1;q1<hpc;q1++)if(hp[q1].x==hp[q1-1].x&&hp[q1].y==hp[q1-1].y);else hp[c1++]=hp[q1];hpc=c1;
  for(c1=q1=1;q1<vpc;q1++)if(vp[q1].x==vp[q1-1].x&&vp[q1].y==vp[q1-1].y);else vp[c1++]=vp[q1];vpc=c1;
  for(c1=q1=1;q1<vcc;q1++)if(vc[q1].x2==vc[q1-1].x2&&vc[q1].y2==vc[q1-1].y2&&vc[q1].x1==vc[q1-1].x1&&vc[q1].y1==vc[q1-1].y1);else vc[c1++]=vc[q1];vcc=c1;
  for(c1=q1=1;q1<hcc;q1++)if(hc[q1].x2==hc[q1-1].x2&&hc[q1].y2==hc[q1-1].y2&&hc[q1].x1==hc[q1-1].x1&&hc[q1].y1==hc[q1-1].y1);else hc[c1++]=hc[q1];hcc=c1;

  hp[0].i=hp[0].p=0;
  for(q1=1;q1<hpc;q1++)
    {if(hp[q1].x==hp[q1-1].x)
      {hp[q1].i=hp[q1-1].i;
      hp[q1].p=hp[q1-1].p+1;}
    else
      {maketree(vt+hp[q1-1].i,hp[q1-1].p+1);vtc++;
      hp[q1].i=hp[q1-1].i+1;
      hp[q1].p=0;}}

  maketree(vt+hp[q1-1].i,hp[q1-1].p+1);vtc++;

  vp[0].i=vp[0].p=0;
  for(q1=1;q1<vpc;q1++)
    {if(vp[q1].y==vp[q1-1].y)
      {vp[q1].i=vp[q1-1].i;
      vp[q1].p=vp[q1-1].p+1;}
    else
      {maketree(ht+vp[q1-1].i,vp[q1-1].p+1);htc++;
      vp[q1].i=vp[q1-1].i+1;
      vp[q1].p=0;}}

  maketree(ht+vp[q1-1].i,vp[q1-1].p+1);htc++;

  for(c1=q1=1;q1<hcc;q1++)
    if(hc[q1].x1<=hc[c1-1].x2&&hc[q1].y1==hc[c1-1].y1)
      if(hc[c1-1].x2<hc[q1].x2)
        hc[c1-1].x2=hc[q1].x2;
      else continue;
    else hc[c1++]=hc[q1];
  hcc=c1;

  for(c1=q1=1;q1<vcc;q1++)
    if(vc[q1].y1<=vc[c1-1].y2&&vc[q1].x1==vc[c1-1].x1)
      if(vc[c1-1].y2<vc[q1].y2)
        vc[c1-1].y2=vc[q1].y2;
      else continue;
    else vc[c1++]=vc[q1];
  vcc=c1;

  for(q1=0;q1<hcc;q1++)hc[q1].id=&hc[q1];
  for(q1=0;q1<vcc;q1++)vc[q1].id=&vc[q1];

  for(q1=0;q1<hcc;q1++)updateh(q1);

  for(q1=0;q1<vcc;q1++)updatev(q1);

  for(q1=1;q1<hcc-1;q1++)
    {if(hc[q1].x1==box.x1)
      hc[q1].f1=1;
    if(hc[q1].x2==box.x2)
      hc[q1].f2=1;

    if(hc[q1].f1)if(hc[q1].f2)
      ins(hc[q1]);}

  for(q1=1;q1<vcc-1;q1++)
    {if(vc[q1].y1==box.y1)
      vc[q1].f1=1;
    if(vc[q1].y2==box.y2)
      vc[q1].f2=1;

    if(vc[q1].f1)if(vc[q1].f2)
      ins(vc[q1]);}
  fclose(fn);
  return 0;}
//////////////////////////////////////////////////
int print(cut a)
  {printf("%d %d %d %d\n",a.x1,a.y1,a.x2,a.y2);
  return 0;}


cut e1,e2,e3,e4;
point p1,p2,p3,p4;
point*pp1,*pp2,*pp3,*pp4;
int c1,c2,c3,c4,q1,q2,q3;
int main()
  {clock();
  init(); 
  printf("%d\n",c-1);
  while(hccc)
    {e1=ex();
    if(!(e1.id->x1==e1.x1&&e1.id->x2==e1.x2&&e1.id->y1==e1.y1&&e1.id->y2==e1.y2))continue;
    print(e1);
    if(e1.x1!=e1.x2)goto horizontal;

    p1.x=e1.x1;p1.y=e1.y1;
    pp1=(point*)bsearch(&p1,hp,hpc,sizeof(hp[0]),cmphp);
    p1.x=e1.x2;p1.y=e1.y2;
    pp2=(point*)bsearch(&p1,hp,hpc,sizeof(hp[0]),cmphp);

    for(pp3=pp1+1;pp3!=pp2;pp3++)
      {
      pp4=(point*)bsearch(pp3,vp,vpc,sizeof(vp[0]),cmpvp);
      c1=ask(&ht[pp4->i],pp4->p);

      if(hc[c1].x1==e1.x1)hc[c1].f1=1;
      if(hc[c1].x2==e1.x1)hc[c1].f2=1;

      if(hc[c1].f1==1&&hc[c1].f2==1)ins(hc[c1]);

      if(hc[c1].x1==e1.x1||hc[c1].x2==e1.x1)continue;

      hc[hcc]=hc[c1];
      hc[hcc].f2=hc[c1].f2;
      hc[c1].f2=1;
      hc[hcc].f1=1;
      hc[hcc].x1=e1.x1;
      hc[c1].x2=e1.x1;

      hc[c1].id=&hc[c1];
      hc[hcc].id=&hc[hcc];

      updateh(c1);
      updateh(hcc);

      if(hc[c1].f1==1&&hc[c1].f2==1)ins(hc[c1]);
      if(hc[hcc].f1==1&&hc[hcc].f2==1)ins(hc[hcc]);
      hcc++;}

    continue;
    horizontal:

    p1.x=e1.x1;p1.y=e1.y1;
    pp1=(point*)bsearch(&p1,vp,vpc,sizeof(vp[0]),cmpvp);
    p1.x=e1.x2;p1.y=e1.y2;
    pp2=(point*)bsearch(&p1,vp,vpc,sizeof(vp[0]),cmpvp);

    for(pp3=pp1+1;pp3!=pp2;pp3++)
      {
      pp4=(point*)bsearch(pp3,hp,hpc,sizeof(hp[0]),cmphp);
      c1=ask(&vt[pp4->i],pp4->p);

      if(vc[c1].y1==e1.y1)vc[c1].f1=1;
      if(vc[c1].y2==e1.y1)vc[c1].f2=1;

      if(vc[c1].f1==1&&vc[c1].f2==1)ins(vc[c1]);

      if(vc[c1].y1==e1.y1||vc[c1].y2==e1.y1)continue;

      vc[vcc]=vc[c1];
      vc[vcc].f2=vc[c1].f2;
      vc[c1].f2=1;
      vc[vcc].f1=1;
      vc[vcc].y1=e1.y1;
      vc[c1].y2=e1.y1;

      vc[c1].id=&vc[c1];
      vc[vcc].id=&vc[vcc];


      updatev(c1);
      updatev(vcc);

      if(vc[c1].f1==1&&vc[c1].f2==1)ins(vc[c1]);
      if(vc[vcc].f1==1&&vc[vcc].f2==1)ins(vc[vcc]);
      vcc++;}

    }
  printf("%lf\n",(double)clock()/CLOCKS_PER_SEC);
  return 0;}
