#include<stdio.h>
#include<stdlib.h>
#define mxx 1024
#define maxx 1048576
#define in stdin;//fopen("c:\\tp\\tests\\skymap\\skymap.01.in","r")
FILE*fn;

#define type long long
typedef struct { int x1,x2,y1,y2,mx,my; type area,b;int a;} node;

int max(int a,int b){return a>b?a:b;}


type ss[mxx][mxx];
node h[mxx*mxx*2];

int build(int where,int x1,int x2,int y1,int y2)
  {h[where].x1=x1;
  h[where].x2=x2;
  h[where].y1=y1;
  h[where].y2=y2;
  h[where].mx=(x1+x2)/2;
  h[where].my=(y1+y2)/2;
  h[where].a=h[where].b=0;
  if(x1==x2)return h[where].area=ss[x1][y1];
  h[where].area=0;
  h[where].area+=build(where*4+1,x1,h[where].mx,y1,h[where].my);
  h[where].area+=build(where*4+2,x1,h[where].mx,h[where].my+1,y2);
  h[where].area+=build(where*4+3,h[where].mx+1,x2,y1,h[where].my);
  h[where].area+=build(where*4+4,h[where].mx+1,x2,h[where].my+1,y2);
  
  return h[where].area;}

int update(int where,int x1,int x2,int y1,int y2,int n)
  {
  if(x1==h[where].x1&&x2==h[where].x2&&y1==h[where].y1&&y2==h[where].y2)return h[where].a+=n;
  
       if(x2<=h[where].mx&&y2<=h[where].my)update(where*4+1,x1,x2,y1,y2,n);
  else if(x2<=h[where].mx&&y1 >h[where].my)update(where*4+2,x1,x2,y1,y2,n);  
  else if(x1 >h[where].mx&&y2<=h[where].my)update(where*4+3,x1,x2,y1,y2,n);
  else if(x1 >h[where].mx&&y1 >h[where].my)update(where*4+4,x1,x2,y1,y2,n);
  else if(x2<=h[where].mx)
    update(where*4+1,x1,x2,y1,h[where].my,n),
    update(where*4+2,x1,x2,h[where].my+1,y2,n);
  else if(x1 >h[where].mx)
    update(where*4+3,x1,x2,y1,h[where].my,n),
    update(where*4+4,x1,x2,h[where].my+1,y2,n);
  else if(y2<=h[where].my)
    update(where*4+1,x1,h[where].mx,y1,y2,n),
    update(where*4+3,h[where].mx+1,x2,y1,y2,n);
  else if(y1 >h[where].my)
    update(where*4+2,x1,h[where].mx,y1,y2,n),
    update(where*4+4,h[where].mx+1,x2,y1,y2,n);
  else 
    update(where*4+1,x1,h[where].mx,y1,h[where].my,n),
    update(where*4+2,x1,h[where].mx,h[where].my+1,y2,n),
    update(where*4+3,h[where].mx+1,x2,y1,h[where].my,n),
    update(where*4+4,h[where].mx+1,x2,h[where].my+1,y2,n);
  
  h[where].b=0;
  for(int q1=1;q1<=4;q1++)
    if(h[where*4+q1].a)h[where].b+=h[where*4+q1].area;else h[where].b+=h[where*4+q1].b;
  
  return 0;}

typedef struct { int x1,y1,z1,x2,y2,z2;} B;

int c,q1,q2,q3,c1,c2,c3,c4;
int x1,y1,x2,y2,z1,z2;
int x[mxx],xx;
int y[mxx],yy;
int z[mxx],zz;
B all[mxx];

type res;

int cmp(const void*a,const void*b)
  {return *((int*)a)-*((int*)b);}

int cmp1(const void*a,const void*b)
  {return ((B*)a)->x1==((B*)b)->x1 ? ((B*)b)->x2-((B*)a)->x2:((B*)a)->x1-((B*)b)->x1;}

int main()
  {fn=in;
  fscanf(fn,"%d",&c);
  for(q1=0;q1<c;q1++)
    {fscanf(fn,"%d %d %d %d %d %d",&all[q1].x1,&all[q1].y1,&all[q1].z1,&all[q1].x2,&all[q1].y2,&all[q1].z2);
    if(all[q1].x1>all[q1].x2)all[q1].x1^=all[q1].x2^=all[q1].x1^=all[q1].x2;
    if(all[q1].y1>all[q1].y2)all[q1].y1^=all[q1].y2^=all[q1].y1^=all[q1].y2;
    if(all[q1].z1>all[q1].z2)all[q1].z1^=all[q1].z2^=all[q1].z1^=all[q1].z2;
    if(all[q1].x1==all[q1].x2||all[q1].y1==all[q1].y2||all[q1].z1==all[q1].z2)q1--,c--;}
  fclose(fn);
  xx=yy=zz=1;
  for(q1=0;q1<c;q1++)
    {x[xx++]=all[q1].x1;
    x[xx++]=all[q1].x2;
    y[yy++]=all[q1].y1;
    y[yy++]=all[q1].y2;
    z[zz++]=all[q1].z1;
    z[zz++]=all[q1].z2;
    all[q1+c]=all[q1];
    all[q1+c].x1=all[q1].x2;
    all[q1].x2=0;
    all[q1+c].x2=1;}
  qsort(x,xx,sizeof(x[0]),cmp);
  qsort(y,yy,sizeof(y[0]),cmp);
  qsort(z,zz,sizeof(z[0]),cmp);
  qsort(all,c*2,sizeof(all[0]),cmp1);
  
  for(q1=c1=1;q1<xx;q1++)if(x[q1]!=x[c1-1])x[c1++]=x[q1];xx=c1;
  for(q1=c1=1;q1<yy;q1++)if(y[q1]!=y[c1-1])y[c1++]=y[q1];yy=c1;
  for(q1=c1=1;q1<zz;q1++)if(z[q1]!=z[c1-1])z[c1++]=z[q1];zz=c1;
  
  for(q1=xx;q1<mxx;q1++)x[q1]=x[q1-1]+1;
  for(q1=yy;q1<mxx;q1++)y[q1]=y[q1-1]+1;
  for(q1=zz;q1<mxx;q1++)z[q1]=z[q1-1]+1;
  xx=yy=zz=mxx;
  
  for(q1=0;q1<yy-1;q1++)for(q2=0;q2<zz-1;q2++)ss[q1][q2]=(type)(y[q1+1]-y[q1])*(type)(z[q2+1]-z[q2]);
  
  build(0,0,mxx-1,0,mxx-1);    
  
  for(q1=0;q1<2*c;q1++)
    {//for(q2=0;q2<xx;q2++)if(all[q1].x1==x[q2])all[q1].x1=q2;
    for(q2=0;q2<yy;q2++)if(all[q1].y1==y[q2])all[q1].y1=q2;
    for(q2=0;q2<yy;q2++)if(all[q1].y2==y[q2])all[q1].y2=q2;
    for(q2=0;q2<zz;q2++)if(all[q1].z1==z[q2])all[q1].z1=q2;
    for(q2=0;q2<zz;q2++)if(all[q1].z2==z[q2])all[q1].z2=q2;}
  
  for(q1=0;q1<c*2;q1++)
    {
    if(q1)res+=(type)(all[q1].x1-all[q1-1].x1)*h[0].b;
    update(0,all[q1].y1,all[q1].y2-1,all[q1].z1,all[q1].z2-1,-(all[q1].x2*2-1));
    }
  printf("%lld\n",res);
  return 0;}
