#include<stdio.h>
#include<math.h>
#define mx 1000000
FILE*fn;
double x[mx];
double y[mx];
int c,q1,q2,q3;
double r,xx,yy;
double dist2(double x1,double y1,double x2,double y2)
  {return sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));}
double det2(double a,double b,double c,double d)
  {return a*d-b*c;}
int ifin(int a,double xx,double yy,double r)
  {if(dist2(x[a],y[a],xx,yy)>r)return 0;
  return 1;}
int krag2(int a,int b,double*xx,double*yy,double*r)
  {*r=dist2(x[a],y[a],x[b],y[b])/2;
  *xx=(x[a]+x[b])/2;
  *yy=(y[a]+y[b])/2;
  return 0;}
int krag3(int a,int b,int c,double*xx,double*yy,double*r)
  {double a1,a2,b1,b2,c1,c2;
  double d,x1,y1,x2,y2,x3,y3;
  x1=(x[a]+x[b])/2;
  y1=(y[a]+y[b])/2;
  x2=x[b];y2=y[b];
  x3=y2-y1+x1;
  y3=x1-x2+y1;
  x2=x3;y2=y3;
  a1=det2(y1,1,y2,1);
  b1=det2(x2,1,x1,1);
  c1=det2(x1,y1,x2,y2);

  x1=(x[b]+x[c])/2;
  y1=(y[b]+y[c])/2;
  x2=x[c];y2=y[c];
  x3=y2-y1+x1;
  y3=x1-x2+y1;
  x2=x3;y2=y3;
  a2=det2(y1,1,y2,1);
  b2=det2(x2,1,x1,1);
  c2=det2(x1,y1,x2,y2);
  if(a1*b2!=a2*b1)
    {y3=(c1*a2-c2*a1)/(a1*b2-a2*b1);
    x3=(c1*b2-c2*b1)/(b1*a2-b2*a1);
    d=dist2(x3,y3,x[a],y[a]);
    d=dist2(x3,y3,x[b],y[b]);
    d=dist2(x3,y3,x[c],y[c]);}
  *xx=x3;
  *yy=y3;
  *r=d;
  return 0;}
int main()
  {fn=fopen("zad4.in","r");
  fscanf(fn,"%d",&c);
  for(q1=0;q1<c;q1++)fscanf(fn,"%lf %lf",x+q1,y+q1);
  fclose(fn);
  for(q1=0;q1<c;q1++)
    {q2=rand()%c;
    r=x[q1];x[q1]=x[q2];x[q2]=r;
    r=y[q1];y[q1]=y[q2];y[q2]=r;}
  krag2(0,1,&xx,&yy,&r);
  for(q1=2;q1<c;q1++)
    {if(ifin(q1,xx,yy,r))continue;
    else
      {krag2(0,q1,&xx,&yy,&r);
      for(q2=1;q2<q1;q2++)
	{if(ifin(q2,xx,yy,r))continue;
	else
	  {krag2(q1,q2,&xx,&yy,&r);
	  for(q3=0;q3<q2;q3++)
	    {if(ifin(q3,xx,yy,r))continue;
	    else
	      krag3(q1,q2,q3,&xx,&yy,&r);}}}}}
  printf("%.10lf\n%.10lf %.10lf\n",r,xx,yy);
  return 0;}
