#include<cstdio>
#include<cmath>
using namespace std;

#define len 32
#define base 1000000000
#define bigtype long long   //should hold  base*base*2
#define lb 9
     
struct L
  {
  int ss[len];
  L(){for(int q1=0;q1<len;q1++)ss[q1]=0;};
  L(bigtype a){for(int q1=len-1;q1>=0;q1--){ss[q1]=a%base;a/=base;}}
  };

L operator*(const L&a,int b)
  {L c;
  bigtype c1=0;
  for(int q1=len-1;q1>=0;q1--)
    {c1+=(bigtype)a.ss[q1]*(bigtype)b;
    c.ss[q1]=c1%base;
    c1/=base;}
  return c;}
int print(const L&a)
  {int q1;
  for(q1=0;q1<len;q1++)if(a.ss[q1])break;
  if(q1==len)q1--;
  printf("%d",a.ss[q1]);
  for(q1++;q1<len;q1++)printf("%0*d",lb,a.ss[q1]);
  return 0;}
L scan(void)
  {int q1,q2,c1,c2;
  char d[len*lb];
  for(q1=0;q1<len*lb;q1++)d[q1]='0';
  scanf("%s",d);
  for(q1=0;d[q1];q1++);
  c1=q1;
  for(q1=0;q1<c1/2;q1++)
    {c2=d[q1];
    d[q1]=d[c1-1-q1];
    d[c1-1-q1]=c2;}
  d[c1]='0';
  L e1;
  for(q1=0;q1<len;q1++)
    {c2=0;
    for(q2=0;q2<lb;q2++)c2=c2*10+d[q1*lb+lb-1-q2]-48;
    e1.ss[len-q1-1]=c2;
    }
  return e1;}
  
int dif(const L&a,const L&b)
  {int q1;
  for(q1=0;q1<len;q1++)if(a.ss[q1]!=b.ss[q1])break;
  if(q1==len)return 0;
  return a.ss[q1]-b.ss[q1];}
int operator<(const L&a,const L&b){int c1=dif(a,b);return c1<0;}
int operator>(const L&a,const L&b){int c1=dif(a,b);return c1>0;}
int operator==(const L&a,const L&b){int c1=dif(a,b);return c1==0;}
int operator<=(const L&a,const L&b){int c1=dif(a,b);return c1<=0;}
int operator>=(const L&a,const L&b){int c1=dif(a,b);return c1>=0;}
                                                                 
///////////////////////////////////////////////////////////////////////////////////


L pw(int a,int b)
  {int q1;
  L e1=1;
  
  for(q1=0;q1<b;q1++)
    e1=e1*a;
  
  return e1;}

int q1,q2,c1,c2,c3,l,m,r;
L e1,e2;

int main()
  {
  /*
  while(scanf("%d",&c1)==1)
    {
    e1=scan();
    
    l=1;
    r=1059399999;
    
    while(l!=r)
      {
      m=(l+r)/2;
      e2=pw(m,c1);
      if(e2>=e1)r=m;
      else l=m+1;
      }
    printf("%d\n",l);
    }
  double a,b,c;
*/  
  while(scanf("%lf",&a)==1)
    {
    scanf("%lf",&b);
    
    c=log(b)/a;
    
    c=exp(c);
    
    printf("%.0lf\n",c+0.3);
    }
  return 0;}