#include<cstdio>
#include<ctime>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<string>
#include<vector>
#include<sstream>
#include<iostream>
#include<queue>
#include<algorithm>

using namespace std;

#define VI vector < int >
#define VS vector < string >
#define pb push_back
#define sz size()
#define cs c_str()
#define ALL(a) (a).begin(),(a).end()
/////////////////////////
int MOD=((((1<<30)-1)*2)+1);
//int poww1=777777777;int poww2=777777777;
int poww1=553401197;int poww2=501268093;
vector < VI > ss;
vector < VI > left1,right1,l,r,fake;
int x,y;

VI sl(VI&ss,int a,int poww)
  {VI left;
  long long c1,q2,q1;
  vector < long long > pw;
  pw.reserve(a+1);
  pw.pb(1);
  for(q1=1;q1<=a;q1++)pw.pb((pw.back()*poww)%MOD);
  left.resize(ss.sz);
  c1=0;
  for(q2=0;q2<a-1&&q2<ss.sz;q2++)
    {c1=c1*(long long)poww+ss[q2];
    c1=c1%MOD;
    left[q2]=-1;}
  for(q2=a-1;q2<ss.sz;q2++)
    {c1=c1*(long long)poww+ss[q2];
    c1=c1%MOD;
    if(q2>=a)
      {c1-=pw[a]*ss[q2-a];
      c1=(c1%MOD+MOD)%MOD;}
    left[q2]=c1;;}
  return left;}

int hash(vector < VI > & ss,int a,vector < VI > & left,vector < VI > & right,int pww,int which)
  {left.clear();
  right.clear();
  long long q1,q2,q3,c1,c2,c3;

  left.reserve(ss.sz);
  right.reserve(ss.sz);

  for(q1=0;q1<ss.sz;q1++)
    {
    VI e1=ss[q1];
    VI e2;

    if(which&1)
      {e2=sl(e1,a,pww);
      left.pb(e2);}

    if(which&2)
      {reverse(ALL(e1));
      e2=sl(e1,a,pww);
      reverse(ALL(e2));
      right.pb(e2);}

    }
  return 0;}

vector < VI > trans(vector < VI > a)
  {
  vector < VI > b(a[0].sz,VI(a.sz,0));;
  int q1,q2;
  
  for(q1=0;q1<a.sz;q1++)for(q2=0;q2<a[0].sz;q2++) 
    b[q2][q1]=a[q1][q2];
  
  return b;}

vector < VI > rot(vector < VI > a)
  {
  vector < VI > b(a[0].sz,VI(a.sz,0));;
  int q1,q2;
  
  for(q1=0;q1<a.sz;q1++)for(q2=0;q2<a[0].sz;q2++) 
    b[a[0].sz-1-q2][q1]=a[q1][q2];
  
  return b;}

int total;

int check(int x1,int y1,int a)
  {
  total++;
  vector <VI> e1,e2;
  int q1,q2;
  
  for(q1=0;q1<a;q1++)
    {
    VI e3;
    for(q2=0;q2<a;q2++)e3.pb(ss[x1+q1][y1+q2]);
    e1.pb(e3);
    }
  e2=rot(rot(e1));
  if(e1!=e2)return 0;
  return 1;}

int test(int a)
  {
  hash(ss,a,left1,right1,poww1,3);
  left1=trans(left1);
  hash(left1,a,l,fake,poww2,1);
//  l=trans(l);
//  left1=trans(left1);
  right1=trans(right1);
  hash(right1,a,fake,r,poww2,2);
//  r=trans(r);
//  right1=trans(right1);
  
  int q1,q2;
  for(q1=a-1;q1<x;q1++)for(q2=a-1;q2<y;q2++)if(l[q2][q1]==r[q2-a+1][q1-a+1])
    if(check(q1-a+1,q2-a+1,a))
      return 1;
      
  return 0;}

int main()
  {
  clock();
  scanf("%d %d",&x,&y);
  ss.resize(x,VI(y,0));
  int q1,q2;
  for(q1=0;q1<x;q1++)
    {
    char d[1000];
    scanf("%s",d);
    for(q2=0;q2<y;q2++)if(d[q2]=='0')ss[q1][q2]=0;else ss[q1][q2]=1;
    }
  
  int ll=0,rr=(min(x,y)/2),mm;
  int b1,b2,c1,c2,c3;
  
  while(ll!=rr)
    {
    mm=(ll+rr+1)/2;
    if(test(2*mm))
      ll=mm;
    else rr=mm-1;
    }
  b1=ll*2;
  
  ll=0;rr=(min(x,y)-1)/2;
  
  while(ll!=rr)
    {
    mm=(ll+rr+1)/2;
    if(test(2*mm+1))
      ll=mm;
    else rr=mm-1;
    }
  b2=ll*2+1;
  
  c1=max(b1,b2);
  if(c1==1)c1-=2;
  printf("%d\n",c1);
  printf("%lf\n",(double)clock()/CLOCKS_PER_SEC);
  printf("%d\n",total);
  return 0;}
