#include<cstdio>
#include<algorithm>
#include<map>
#include<set>
using namespace std;
#define mx 8192
#define maxx 1000000
#define type long long
#define in stdin
FILE*fn;
struct point
  {type x,y,z;
  point() : x(0),y(0),z(0) {};
  point(type a,type b,type c) : x(a),y(b),z(c) {};
  };
struct sortpointZ : public binary_function<point&,point&,bool>
  {bool operator()(const point&a,const point&b){return a.z<b.z;}};
struct cube
  {type x,y,area;
  cube() : x(0),y(0),area(0) {};
  cube(type a,type b,type c) : x(a),y(b),area(c) {};
  };
bool operator<(const cube&a,const cube&b)
  {if(a.area==b.area)if(a.x==b.x)return a.y<b.y;else return a.x<b.x;else return a.area>b.area;}

point ss[mx];
map<type,type> s;

typedef typeof(s.begin()) it;

multiset<cube> w;

it eras(it a)
  {it a1,a2;
  a1=a2=a;
  a1--;
  a2++;
  cube c1,c2;
  c1.area=a2->first*a2->second;
  c1=cube(a->first,a1->second,a1->second*a->first);
  c2=cube(a2->first,a->second,a->second*a2->first);
  w.erase(w.find(c1));
  w.erase(w.find(c2));
  s.erase(a);
  c1=cube(a2->first,a1->second,a1->second*a2->first);
  w.insert(c1);
  return a2;}
  
type inser(point b)
  {it a1,a2,a;
  cube c1,c2;
  s[b.x]=b.y;
  a1=a2=a=s.find(b.x);
  a1--;
  a2++;
  c1=cube(a2->first,a1->second,a2->first*a1->second);
  w.erase(w.find(c1));
  
  c1=cube(a->first,a1->second,a1->second*a->first);
  c2=cube(a2->first,a->second,a->second*a2->first);
  w.insert(c1);
  w.insert(c2);
  return 0;}

type c,q1,q2,q3,best,bx,by,bz;
cube c1;
int main()
  {fn=in;
  fscanf(fn,"%lld",&c);
  for(q1=0;q1<c;q1++)fscanf(fn,"%lld %lld %lld",&ss[q1].x,&ss[q1].y,&ss[q1].z);
  fclose(fn);
  ss[c++]=point(1,1,maxx);
  sort(&ss[0],&ss[c],sortpointZ());
  s[0]=(type)maxx;
  s[(type)maxx]=0;
  w.insert(cube((type)maxx,(type)maxx,(type)maxx*(type)maxx));

  for(q1=0;q1<c;q1++)
    {cube c1=*w.begin();
    if(best<c1.area*ss[q1].z)
      {best=c1.area*ss[q1].z;
      bx=c1.x;
      by=c1.y;
      bz=ss[q1].z;}

    it e1=s.lower_bound(ss[q1].x);
    if(e1->first!=ss[q1].x)e1--;

    if(e1->second<=ss[q1].y)continue;
    
    if(e1->first!=ss[q1].x)e1++;
    while(e1->second>=ss[q1].y)
      e1=eras(e1);

    inser(ss[q1]);
    }
  printf("%lld\n%lld %lld %lld\n",best,bx,by,bz);
  return 0;}
