#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#define eps 0.000001
#define ABS(a) ((a)<0.0?-(a):(a))
#define MIN(a,b) ((a)<(b)?(a):(b))
#define in stdin;//fopen("c:\\tp\\tests\\a.in","r")
FILE*fn;
typedef struct{double x,y;} point;
double r1,r2,a1,b1,g1,g2,d1,d2,a2,b2,ans;
point p1,p2,p3,p4,p5,p6,p7,p8,p9;
int ss[2][2];
double c1,c2,c3,c4,c5,c6;
int eq(double a,double b)
  {double c1;
//  printf("%.5lf\n",a-b);
  c1=a-b;
  if(c1<0.0)c1=-c1;
  if(c1<eps)return 1;else return 0;}
double dist(double a,double b,double c,double d)
  {return sqrt((a-c)*(a-c)+(b-d)*(b-d));}
double dist2(point e1,point e2)
  {return dist(e1.x,e1.y,e2.x,e2.y);}
point res(point st,point end,double leng)
  {point e1;
  double c1,c2;
  c1=dist2(st,end);
  c2=end.x-st.x;
  c2=c2/c1*leng;
  e1.x=c2;
  c2=end.y-st.y;
  c2=c2/c1*leng;
  e1.y=c2;
  e1.x+=st.x;
  e1.y+=st.y;
  return e1;}
point rot(point e1,point e2)
  {point e3,e4;
  e3.x=e2.x-e1.x;
  e3.y=e2.y-e1.y;
  e4.x=-e3.y;
  e4.y=e3.x;
  e4.x+=e1.x;
  e4.y+=e1.y;
  return e4;}
double heron(double a,double b,double c)
  {double d=(a+b+c)/2.0;
  return sqrt(d*(d-a)*(d-b)*(d-c));}
double polar(point p,point w)
  {return atan2(p.x-w.x,p.y-w.y);}
double dp(double p1,double p2,point e1,double r)
  {double c1,c2;
  c1=p1-p2;
  if(c1<0.0)c1=-c1;
  if(c1>M_PI)c1=2.0*M_PI-c1;
  c2=c1*r;
  return c2;}
int nosol(void)
  {double c1,c2,c3,c4,ans=9999.0,pol1,pol2;
  c1=dist2(p1,p3);
  c2=dist2(p2,p3);
  c3=dist2(p1,p4);
  c4=dist2(p2,p4);
  if(eq(c1,c3)&&eq(c1,r1))
    {pol1=polar(p3,p1);
    pol2=polar(p4,p1);
    ans=dp(pol1,pol2,p1,r1);}
  if(eq(c2,c4)&&eq(c2,r2))
    {pol1=polar(p3,p2);
    pol2=polar(p4,p2);
    ans=dp(pol1,pol2,p2,r2);}
  if(eq(ans,9999.0))printf("-1\n");
  else printf("%.10lf\n",ans);
  exit(0);
  return 0;}
int main()
  {fn=in;
  fscanf(fn,"%lf %lf %lf %lf %lf %lf %lf %lf %lf %lf",&p1.x,&p1.y,&r1,&p2.x,&p2.y,&r2,&p3.x,&p3.y,&p4.x,&p4.y);
  fclose(fn);
  c1=dist2(p1,p2);
  if(c1+r1<r2-eps||c1+r2<r1-eps||c1>r1+r2)nosol();
  c2=heron(r1,r2,c1);
  c2=(2.0*c2)/c1;
  c3=sqrt(r1*r1-c2*c2);
  p5=res(p1,p2,c3);
  p9=res(p1,p2,1000.0);
  p6=rot(p5,p9);
  p7=res(p5,p6,c2);
  p8=rot(p5,p7);
  p8=rot(p5,p8);
  a1=polar(p3,p1);
  a2=polar(p3,p2);
  b2=polar(p4,p2);
  b1=polar(p4,p1);
  g1=polar(p7,p1);
  g2=polar(p7,p2);
  d1=polar(p8,p1);
  d2=polar(p8,p2);

  c1=dist2(p1,p3);
  c2=dist2(p2,p3);
  c3=dist2(p1,p4);
  c4=dist2(p2,p4);

  if(eq(c1,r1))ss[0][0]=1;
  if(eq(c2,r2))ss[0][1]=1;
  if(eq(c3,r1))ss[1][0]=1;
  if(eq(c4,r2))ss[1][1]=1;
  ans=99999.0;
  if(ss[0][0]&&ss[1][0])
    {c1=dp(a1,b1,p1,r1);
    ans=MIN(ans,c1);
    c1=dp(a1,d1,p1,r1);
    c1+=dp(d2,g2,p2,r2);
    c1+=dp(g1,b1,p1,r1);
    ans=MIN(ans,c1);
    c1=dp(a1,g1,p1,r1);
    c1+=dp(g2,d2,p2,r2);
    c1+=dp(d1,b1,p1,r1);
    ans=MIN(ans,c1);}
  if(ss[0][1]&&ss[1][1])
    {c1=dp(a2,b2,p2,r2);
    ans=MIN(ans,c1);
    c1=dp(a2,d2,p2,r2);
    c1+=dp(d1,g1,p1,r1);
    c1+=dp(g2,b2,p2,r2);
    ans=MIN(ans,c1);
    c1=dp(a2,g2,p2,r2);
    c1+=dp(g1,d1,p1,r1);
    c1+=dp(d2,b2,p2,r2);
    ans=MIN(ans,c1);}
  if(ss[0][0]&&ss[1][1])
    {c1=dp(a1,d1,p1,r1);
    c1+=dp(d2,b2,p2,r2);
    ans=MIN(ans,c1);
    c1=dp(a1,g1,p1,r1);
    c1+=dp(g2,b2,p2,r2);
    ans=MIN(ans,c1);}
  if(ss[0][1]&&ss[1][0])
    {c1=dp(a2,d2,p2,r2);
    c1+=dp(d1,b1,p1,r1);
    ans=MIN(ans,c1);
    c1=dp(a2,g2,p2,r2);
    c1+=dp(g1,b1,p1,r1);
    ans=MIN(ans,c1);}
  printf("%.10lf\n",ans);
  return 0;}
