//lesno se zabeliazva che reshenieto sa vsystnost chislata na fibonaci.
//Za da gi namerim triabva da se izpolzvat dylgi chisla tui kato otgovoryt
//mozhe da e do 10 000 cifri dylyg.
//izpolzvam standartnia metdo za presmiatane na chislata na fibonaci - koito 
//iziskva N sybirania za namiraneto na otgovora. Tova dovezhda do slozhnost
//N^2 tui kato dylzhinata na otgovora e proporciaonlna na N. Izpolzvaneto na 
//po dobri algoritmi za namirane na chislata na fibonaci e ili trudno prilozhimo 
//ili bezmisleno. Systestuvva algoritym za namirane na N-toto chislo na fibonaci
//koeto izvyrshva logaritmichen broi aritmetichni operacii. NO te sa umnozhenie
//a umnozhenieto e proporcionalno na N^2 => vodi do vloshavane na skorostta na 
//algorityma. Systestvuvat po dobri no tiahnata realizacia e obemna.
#include<cstdio>
#define len 1166
#define base 1000000000
#define bigtype long long   //should hold  base*base*2
#define lb 9
     
struct L
  {
  int ss[len];
  L(){for(int q1=0;q1<len;q1++)ss[q1]=0;};
  L(bigtype a){for(int q1=len-1;q1>=0;q1--){ss[q1]=a%base;a/=base;};}
  };

int lim=0;
int add(const L&a,const L&b,L&c)
  {for(int q1=len-1,c1=0;q1>=lim;q1--)
    {c1+=a.ss[q1]+b.ss[q1];
    c.ss[q1]=c1%base;
    c1/=base;}
  return 0;}
  
int print(const L&a)
  {int q1;
  for(q1=0;q1<len;q1++)if(a.ss[q1])break;
  if(q1==len)q1--;
  printf("%d",a.ss[q1]);
  for(q1++;q1<len;q1++)printf("%0*d",lb,a.ss[q1]);
  printf("\n");
  return 0;}


int main()
  {
  L e1,e2,e3;
  L*u1,*u2,*u3,*u4;
  int q1,c1,c2,c;
  e1=e2=1;
  
  scanf("%d",&c);
  
  u1=&e1;
  u2=&e2;
  u3=&e3;
  double lenn=len-2.0;
  for(q1=1;q1<c;q1++)
    {
    add(*u1,*u2,*u3);
    u4=u1;
    u1=u2;
    u2=u3;
    u3=u4;
    lenn-=0.023220848916665;
    lim=(int)lenn;
    if(lim<0)lim=0;
    }
  print(*u2);
  return 0;}