/*
Tova e reshenieto na 3-tata zadacha

Ako razgledame broia na nachinite da se stigne do
niakakva tochka otdalechena na niakakvo razstoia nie
vuv vseki edin moment ste poluchim slednata tablica

V nachaloto choveka e v tochka 0

razstoianie: -6 -5 -4 -3 -2 -1  0  1  2  3  4  5  6
vreme:	0                       1
	1                    1     1
	2                 1     2     1
	3              1     3     3     1
	4           1     4     6     4     1
	5        1     5     10    10    5     1
	6     1     6     15    20    15    6     1

Praznte mesta sa 0
Ako t(n,k) e broia na nachinite da se stigne do tochka k za vreme n
to togava t(n,k)=t(n-1,k-1)+t(n-1,k+1)
t.e sbora na dvete kletki po diagonal nagore.

susto taka zabeliazvame che tovasa binomnite koeficienti
taka che moshem samo da si smetnem tozi koito ni triabva
ako sa dadeni n,k to triabva da namerim C(n,(n-k)/2)

s pomoshta na formulata za C(n,k) n*(n-1)*....*(n-k+1)/k/.../4/3/2
mogat da se poluchat mnogo golemi chisla pri umbnoshenieto koito posle
da se namaliat pri delenieto zatova purvo gi razlagame na prosti mnogiteli
i posle umnoshavame samo tiah

Susto taka sum napisal i dulgi chisla za da se pobirat golemite otgovori

Zabeleshka:
      1) k=abs(k)
      2) ako k>n answer=0
      3) ako k i n sa ot razlichna chetnost answer=0
ochakvana sloshnost

 kato prenebregna smiataneto s resheto na Eratosten prostite chisla
 poneshe tazi skorost e konstantna sloshnostta na algorityma stava

 k*sqrt(n)/lg(n)   - tova e skorostta na razlaganeto

 na umnoshenieto e (log1000000(answer))^2

 a za resheto na eratosten sloshnostta e 1000000*C - C e niakakva konstanta


Svetoslav Kolev

ELS "Geo Milev" - Rousse
*/
#include<stdio.h>
#include<math.h>
#define mx 1048576
#define smx 1024
#define base 1000000
long long ss[mx];
long long pr[mx];
double dd;
long long div2[mx];
long long dva[mx];
long long num[mx];
long long ld[mx];
long long q1,q2;
long long pc;
long long n,k;
long long c1,c2,c3;
long long mul(long long a,long long b)
  {long long q1,c1=0;
  for(q1=0;q1<=b+10;q1++)
    {c1+=ld[q1]*a;
    ld[q1]=c1%base;
    c1/=base;}
  return 0;}
long long fact(long long a)
  {long long q1=0,q2,c1=0;
  while(pr[q1]*pr[q1]<=a)if(a%pr[q1]==0)
    {div2[c1++]=pr[q1];
    for(q2=0;a%pr[q1]==0;q2++)a/=pr[q1];
    num[c1-1]=q2;
    q1++;}
  else q1++;
  if(a>1)
    {div2[c1]=a;
    num[c1++]=1;}
  return c1;}
int main()
  {scanf("%lld %lld",&n,&k);
  k=k<0?-k:k;
  if(n%2!=k%2){printf("0\n");return 0;}
  k=(n-k)/2;
  if(k<0){printf("0\n");return 0;}
  if(k>n/2)k=n-k;
  for(q1=2;q1<mx;q1++)ss[q1]=1;
  for(q1=1;q1<smx;q1++)if(ss[q1])
    for(q2=q1*q1;q2<mx;q2+=q1)
      ss[q2]=0;
  for(q1=0;q1<mx;q1++)if(ss[q1])pr[pc++]=q1;
  ld[0]=1;
  for(q1=n;q1>n-k;q1--)
    {c1=fact(q1);
    for(q2=0;q2<c1;q2++)
      dva[div2[q2]]+=num[q2];}
  for(q1=2;q1<=k;q1++)
    {c1=fact(q1);
    for(q2=0;q2<c1;q2++)
      dva[div2[q2]]-=num[q2];}
  c1=1;
  dd=1;
  for(q1=0;q1<mx;q1++)for(q2=0;q2<dva[q1];q2++)
    {c1*=q1;
    if(c1>base)
      {mul(c1,(long long)dd);
      dd+=log10((double)c1)/log10((double)base);
      c1=1;}}
  mul(c1,dd+10);
  for(q1=mx-1;q1>=0;q1--)if(ld[q1]!=0)break;
  printf("%lld",ld[q1]);
  for(q1--;q1>=0;q1--)
    {if(ld[q1]==0)
      c1=(long long)log10((double)base)-1;
    else
      c1=(long long)log10((double)base)-(long long)log10((double)ld[q1])-1;
    for(q2=0;q2<c1;q2++)printf("0");
    printf("%lld",ld[q1]);}
  printf("\n");
  return 0;}
