#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#define ui unsigned int
#define ul unsigned long long
#define is 32
#define randstart 1999999999
#define maxsize 142199
#define chararray 1000000
#define printfield 200

typedef union {struct {ui x,y;};ul n;}pos;
typedef struct {ui c;pos*ss;}state;

int stay[16],die[16],born[16];


#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))

////////////////////////// hash table
int pr[maxsize];
int hashsize;
pos*h;
ui*br;
ui*al;

int initialize_hash(void)
  {
  int q1,q2;
  for(q1=0;q1<maxsize;q1++)pr[q1]=1;
  pr[0]=pr[1]=0;
  for(q1=2;q1*q1<maxsize;q1++)if(pr[q1])for(q2=q1*q1;q2<maxsize;q2+=q1)pr[q2]=0;
  return 0;}

int make_hash(int n)
  {
  int c1,c2,c3,c4;
  c1=23*n+27;
  c2=37*n+73;
  c3=c2-c1+1;
  c4=4;
  if(c2<maxsize){while(!pr[c4])c4=rand()%c3+c1;}
  else c4=(c1+c2)/2;
  h=(pos*)malloc(sizeof(pos)*c4);
  memset(h,0,sizeof(pos)*c4);
  br=(ui*)malloc(sizeof(ui)*c4);
  memset(br,0,sizeof(ui)*c4);
  al=(ui*)malloc(sizeof(ui)*c4);
  memset(al,0,sizeof(ui)*c4);
  hashsize=c4;
  return 0;}
int free_hash()
  {free(h);
  free(br);
  free(al);
  return 0;}

ui hash(pos*a)
  {ul c1=a->n;
  ul c2=(c1<<is)+(c1>>is);
  c2<<=is/2;
  return ((ui)(c1^c2))%hashsize;}

int add(pos*a,ui b,ui c)
  {
  ui w=hash(a);
  while(h[w].n!=0)if(h[w].n==a->n)break;else w=(w+1)%hashsize;
  h[w]=*a;
  br[w]+=b;
  al[w]+=c;
  return 0;
  }
//////////////////////////////////////end  hash
state nil;

int sdel(state*a)
  {
  a->ss=0;
  a->c=0;
  if(a->ss)free(a->ss);
  return 0;}
int scpy(state*a,state*b)
  {
  sdel(b);
  b->c=a->c;
  b->ss=(pos*)malloc(sizeof(pos)*a->c);
  memcpy(b->ss,a->ss,sizeof(pos)*a->c);
  return 0;}
int nextstate(state*a,state*b)
  {
  int q1,q2,q3,c1,c2;
  pos e1;
  make_hash(a->c);
  for(q1=0;q1<a->c;q1++)
    {
    for(q2=-1;q2<=1;q2++)for(q3=-1;q3<=1;q3++)if(!(q2==0 && q3==0))
      {
      e1=a->ss[q1];
      e1.x+=q2;
      e1.y+=q3;
      add(&e1,1,0);
      }
    add(&(a->ss[q1]),0,1);
    }
  b->c=0;
  for(q1=0;q1<hashsize;q1++)if(h[q1].n)
    {
    c1=br[q1];
    c2=al[q1];
    if(c2==0)if(born[c1])b->c++;
    if(c2==1)if(stay[c1])b->c++;
    }
  b->ss=(pos*)malloc(b->c*sizeof(pos));
  b->c=0;
  for(q1=0;q1<hashsize;q1++)if(h[q1].n)
    {
    c1=br[q1];
    c2=al[q1];
    if(c2==0)if(born[c1])b->ss[b->c++]=h[q1];
    if(c2==1)if(stay[c1])b->ss[b->c++]=h[q1];
    }
  free_hash();
  return 0;
  }  

int print(state*a,int b)
  {
  ui q1,q2,x1,y1,x2,y2;
  //printf("%d\n",a->c);
  //for(q1=0;q1<a->c;q1++)printf("%u %u\n",a->ss[q1].x,a->ss[q1].y);
  
  system("cls");
  printf("%d  %d\n",b,hashsize);
  int ss[printfield][printfield];
  y1=x1=randstart;
  x1*=2;
  y1*=2;
  for(q1=0;q1<a->c;q1++)
    {
    x1=min(x1,a->ss[q1].x);
    y1=min(y1,a->ss[q1].y);
    }
  memset(ss,0,sizeof(ss));
  for(q1=0;q1<a->c;q1++)ss[a->ss[q1].x-x1][a->ss[q1].y-y1]=1;
  y2=x2=0;
  for(q1=0;q1<a->c;q1++)
    {
    x2=max(x2,a->ss[q1].x);
    y2=max(y2,a->ss[q1].y);
    }
  for(q1=0;q1<x2-x1+1;q1++)
    {
    for(q2=0;q2<y2-y1+1;q2++)printf("%d",ss[q1][q2]);
    printf("\n");
    }
  printf("\n");
  return 0;}

int process(state*a,int b)
  {
  if(b%10==0){print(a,b);system("pause");}
  return 0;
  }

int simulate(int n,state*a)
  {
  int q1;
  state e1=nil,e2=nil;
  state*p1,*p2,*p3;
  scpy(a,&e1);
  p1=&e1;
  p2=&e2;
  sdel(p2);
  process(p1,0);
  for(q1=1;q1<=n;q1++)
    {
    nextstate(p1,p2);
    sdel(p1);
    p3=p1;
    p1=p2;
    p2=p3;
    process(p1,q1);
    }
  return 0;}
/////////////////////////////

state start;
int n;
char inpfile[1000];


char d[chararray];
int initialize1(void)
  {
  strcpy(inpfile,"c:\\edu\\02\\in.txt");
  int x,y;
  FILE*fn;
  fn=fopen(inpfile,"r");
  fscanf(fn,"%d %d\n",&x,&y);
  int q1,q2,c1=0;
  for(q1=0;q1<x;q1++)
    {
    fgets(d,chararray,fn);
    for(q2=0;d[q2];q2++)if(d[q2]=='1')c1++;
    }
  fclose(fn);
  start.c=c1;
  start.ss=(pos*)malloc(sizeof(pos)*c1);
  fn=fopen(inpfile,"r");
  fscanf(fn,"%d %d\n",&x,&y);
  c1=0;
  for(q1=0;q1<x;q1++)
    {
    fgets(d,chararray,fn);
    for(q2=0;d[q2];q2++)if(d[q2]=='1')
      {
      start.ss[c1].x=q1+randstart;
      start.ss[c1++].y=q2+randstart;
      }
    }
  fclose(fn);
  born[3]=1;
  stay[2]=stay[3]=1;
  n=4400;
  return 0;}

int main()
  {
  initialize_hash();
  initialize1();
  simulate(n,&start);
  
  return 0;}