; these are all the excercises from chapter 3.1
(define balance11 100)

(define (withdraw11 amount)
  (if (>= balance11 amount)
      (begin (set! balance11 (- balance11 amount))
             balance11)
      (error "Insufficient funds")))

(define withdraw
  (let ((balance 100))
    (lambda (x)
      (if (> x balance)
          (error "not enougn money")
          (begin (set! balance (- balance x))
                 balance)))))

(define (macc balance)
  (define (withdraw money)
    (if (> money balance) "not enough money"
        (begin (set! balance (- balance money))
               balance)))
  (define (deposit money)
    (set! balance (+ balance money))
    balance)
  (define (dispatch1 action par)
    (cond ((equal? action 'withdraw) (withdraw par))
          ((equal? action 'deposit) (deposit par))
          (else (error "command not recognized"))))
  (define (dispatch action)
    (cond ((equal? action 'withdraw) withdraw)
          ((equal? action 'deposit) deposit)
          (else (error "command not recognized"))))
  dispatch1)

(define acc (macc 100))

(define (maccu init)
  (define (add x)
    (set! init (+ init x))
    init)
  add)

(define (monitor f)
  (define (mon f n)
    (define (doit . g)
      (if (and (= 1 (length g)) (equal? (car g) 'times))
          (begin (set! n (+ n 1)) n)
          (apply f g)))
    doit)
  (mon f 0))

(define (maccp balance pass)
  (define (maccp2 balance pass times timeso)
    (define (withdraw money)
      (if (> money balance) "not enough money"
          (begin (set! balance (- balance money))
                 balance)))
    (define (deposit money)
      (set! balance (+ balance money))
      balance)
    (define (dispatch action psw)
      (if (equal? psw pass)
          (begin
            (set! times timeso)
            (cond ((equal? action 'withdraw) withdraw)
                  ((equal? action 'deposit) deposit)
                  ((equal? action 'pcheck) 'ok)
                  (else "command not recognized")))
          (begin 
            (set! times (- times 1))
            (if (= 0 times) 
                'callthecops
                '(wrong password)))))
    dispatch)
  (maccp2 balance pass 2 2))

(define ac (maccp 100 's))

(define random-limit 2147483647)
(define random-init 46767)
(define (random-update x)
  (remainder (* x 8191) random-limit))
(define rand
  (let ((x random-init))
    (lambda mes
      (if (and (not (null? mes)) (equal? (car mes) 'reset))
          (lambda (y)
            (set! x y))
          (begin (set! x (random-update x))
                 x)))))
          
(define (cpi tries)
  (sqrt (/ 6 (monte-carlo tries cesaro-test))))

(define (cesaro-test) 
  (= 1 (gcd (rand) (rand))))

(define (monte-carlo tries exp)
  (define (iter rem pass)
    (if (= rem 0) 
        (/ pass tries)
        (iter (- rem 1) (+ pass (if (exp) 1 0)))))
  (iter tries 0))

(define (cpi2 tries)
  (sqrt (/ 6 (random-gcd-test tries random-init))))

(define (random-gcd-test tries initialx)
  (define (iter rem pass x)
    (let ((x1 (random-update x)))
      (let ((x2 (random-update x1)))
        (if (= rem 0) 
            (/ pass tries)
            (iter (- rem 1) (+ pass (if (= 1 (gcd x1 x2)) 1 0)) x2)))))
  (iter tries 0 initialx))

(define (integ x1 y1 x2 y2 tries p)
  (define (rir a b)
    (+ a (* (/ (rand) random-limit) (- b a))))
  (define (test)
    (let ((x (rir x1 x2))
          (y (rir y1 y2)))
      (p x y)))
  (* (- x2 x1) (- y2 y1) (monte-carlo tries test)))

(define (joint acc p1 p2)
  (define (joint1 acc p1 p2 times timeso)
    (define (access action psw)
      (if (equal? psw p2)
          (begin
            (set! times timeso)
            (acc action p1))
          (begin 
            (set! times (- times 1))
            (if (= 0 times) 
                'callthecops
                '(wrong password)))))
    (if (equal? (acc 'pcheck p1) 'ok)
        access
        '(wrong password)))
  (joint1 acc p1 p2 2 2))

(define ac2 (joint ac 's 'ss))

(define f
  (let ((x 1))
    (lambda (t)
      (begin
        (set! x (* x t))
        x))))

(+ (f 1) (f 0))

(define f
  (let ((x 1))
    (lambda (t)
      (begin
        (set! x (* x t))
        x))))

(+ (f 0) (f 1))
