(define vr vector-ref)
(define vs vector-set!)
(define vl vector-length)

(define (sort1 v)
  (define (bubble a b)
    (begin 
      (if (> (vr v (- b 1)) (vr v b))
          (let ((t (vr v (- b 1))))
            (vs v (- b 1) (vr v b))
            (vs v b t)))
      (cond ((= a (- (vl v) 1)) 'okay)
            ((= b (- (vl v) 1)) (bubble (+ a 1) (+ a 1)))
            (else (bubble a (+ b 1))))))
  (if (> (vl v) 1)
      (bubble 1 1)))

(define vv #(2 7 8 3 4))

(sort1 vv)


(define (reverse v)
  (define (iter n)
    (if (>= n (floor (/ (vl v) 2))) 'okay
        (begin 
          (let ((t (vr v (- (vl v) 1 n))))
            (vs v (- (vl v) 1 n) (vr v n))
            (vs v n t))
          (iter (+ n 1)))))
  (iter 0))

(reverse vv)

