PROGRAM AlphaCentauri;
LABEL
  First;
CONST
  filinp='c:\tp\tests\alpha.inp';
  filout='c:\tp\tests\alpha.out';
  maxreqs=600;
  maxrobs=250;
  maxdocks=180;
TYPE
  req=RECORD time,from,too,weight:LONGINT;END;
VAR
  tit,tot:TEXT;
  ss,reqlist:ARRAY[1..maxreqs+1]OF req;
  reqready:ARRAY[1..maxreqs]OF RECORD beg,endd:LONGINT;END;
  srobs:ARRAY[0..maxrobs]OF RECORD wei,pos:LONGINT;idle:BOOLEAN;END;
  robtask:ARRAY[1..maxrobs]OF RECORD task:req;cargo:BOOLEAN;wait:LONGINT;END;
  docklist:ARRAY[1..maxdocks]OF SET OF 1..maxrobs;
  sim,robs,docks,q1,reqs,time,gets,ukaz,q2,taskready,overwork,av,qq:LONGINT;
  aw,ow:REAL;
  emptyreq:req;
FUNCTION WhoGetsTheTask(a:req):LONGINT;
VAR
  q,q2,init:LONGINT;
BEGIN
  init:=0;
  FOR q:=a.from DOWNTO a.from-docks+1DO
    BEGIN
    IF q>=1THEN
      BEGIN
        FOR q2:=1TO robs DO IF q2 IN docklist[q]THEN IF srobs[q2].idle THEN
        IF srobs[q2].wei>=a.weight THEN IF srobs[q2].wei<srobs[init].wei THEN init:=q2;
      END
    ELSE
      BEGIN
        FOR q2:=1TO robs DO IF q2 IN docklist[q+docks]THEN IF srobs[q2].idle THEN
        IF srobs[q2].wei>=a.weight THEN IF srobs[q2].wei<srobs[init].wei THEN init:=q2;
      END;
    IF init<>0THEN BREAK;
    END;
  WhoGetsTheTask:=init;
END;
BEGIN
  qq:=0;
  ASSIGN(tit,filinp);
  ASSIGN(tot,filout);
  RESET(tit);
  REWRITE(tot);
  READLN(tit,docks,robs);
  First:
  qq:=qq+1;
  emptyreq.time:=0;emptyreq.from:=0;emptyreq.too:=0;emptyreq.weight:=0;
  FOR q1:=1TO robs DO READLN(tit,srobs[q1].wei);
  q1:=0;
  REPEAT
    INC(q1);
    READLN(tit,ss[q1].time,ss[q1].from,ss[q1].too,ss[q1].weight);
  UNTIL ss[q1].time=-1;
  taskready:=0;
  reqs:=q1-1;
  srobs[0].wei:=MAXLONGINT;
  FOR q1:=1TO robs DO BEGIN srobs[q1].idle:=TRUE;srobs[q1].pos:=1;END;
  docklist[1]:=[1..robs];
  ukaz:=1;
  time:=0;
  overwork:=0;
  ss[reqs+1].time:=MAXINT;
  WHILE taskready<reqs DO
    BEGIN
      time:=time+1;
      FOR q1:=1TO reqs DO IF reqlist[q1].time<>0THEN
        BEGIN
          gets:=WhoGetsTheTask(reqlist[q1]);
          IF gets<>0THEN
            BEGIN
              srobs[gets].idle:=FALSE;
              robtask[gets].cargo:=FALSE;
              robtask[gets].wait:=-1;
              robtask[gets].task:=reqlist[q1];
              reqlist[q1]:=emptyreq;
              IF srobs[gets].pos=robtask[gets].task.from THEN robtask[gets].wait:=5;
            END;
        END;
      WHILE ss[ukaz].time<=time DO
        BEGIN
          gets:=WhoGetsTheTask(ss[ukaz]);
          IF gets<>0THEN
            BEGIN
              srobs[gets].idle:=FALSE;
              robtask[gets].cargo:=FALSE;
              robtask[gets].wait:=-1;
              robtask[gets].task:=ss[ukaz];
              reqready[ukaz].beg:=time;
              IF srobs[gets].pos=robtask[gets].task.from THEN robtask[gets].wait:=5;
              ukaz:=ukaz+1;
            END
          ELSE BEGIN reqready[ukaz].beg:=time;reqlist[ukaz]:=ss[ukaz];ukaz:=ukaz+1;END;
        END;
      FOR q2:=1TO robs DO IF srobs[q2].idle=FALSE THEN overwork:=overwork+1;
      FOR q1:=1TO robs DO IF srobs[q1].idle=FALSE THEN
        BEGIN
          IF NOT robtask[q1].cargo THEN
            IF srobs[q1].pos<>robtask[q1].task.from THEN
              BEGIN
                docklist[srobs[q1].pos]:=docklist[srobs[q1].pos]-[q1];
                IF srobs[q1].pos<>docks THEN INC(srobs[q1].pos)ELSE srobs[q1].pos:=1;
                IF srobs[q1].pos=robtask[q1].task.from THEN robtask[q1].wait:=5;
                docklist[srobs[q1].pos]:=docklist[srobs[q1].pos]+[q1];
              END
            ELSE IF robtask[q1].wait<>0THEN DEC(robtask[q1].wait)
            ELSE
              BEGIN
                DEC(robtask[q1].wait);
                robtask[q1].cargo:=TRUE;
                docklist[srobs[q1].pos]:=docklist[srobs[q1].pos]-[q1];
                IF srobs[q1].pos<>docks THEN INC(srobs[q1].pos)ELSE srobs[q1].pos:=1;
                IF srobs[q1].pos=robtask[q1].task.too THEN robtask[q1].wait:=5;
                docklist[srobs[q1].pos]:=docklist[srobs[q1].pos]+[q1];
              END
          ELSE
            IF srobs[q1].pos<>robtask[q1].task.too THEN
              BEGIN
                docklist[srobs[q1].pos]:=docklist[srobs[q1].pos]-[q1];
                IF srobs[q1].pos<>docks THEN INC(srobs[q1].pos)ELSE srobs[q1].pos:=1;
                IF srobs[q1].pos=robtask[q1].task.too THEN robtask[q1].wait:=5;
                docklist[srobs[q1].pos]:=docklist[srobs[q1].pos]+[q1];
              END
            ELSE IF robtask[q1].wait<>1THEN DEC(robtask[q1].wait)
            ELSE
              BEGIN
                DEC(robtask[q1].wait);
                DEC(robtask[q1].wait);
                robtask[q1].cargo:=FALSE;
                srobs[q1].idle:=TRUE;
                FOR q2:=1TO reqs DO IF(robtask[q1].task.time=ss[q2].time)AND(robtask[q1].task.weight=ss[q2].weight)THEN
                  reqready[q2].endd:=time;
                taskready:=taskready+1;
                robtask[q1].task:=emptyreq;
              END;
        END;
    END;
  av:=0;
  ow:=0;
  FOR q1:=1TO reqs DO av:=av+reqready[q1].endd-reqready[q1].beg;
  IF time<>0THEN ow:=overwork/time;
  IF robs<>0THEN ow:=ow/robs;
  aw:=av/reqs;
  WRITELN(tot,'SIMULATION            ',qq);
  WRITELN(tot,'Average Wait Time        :',aw:0:3);
  WRITELN(tot,'Average Utilization      :',ow*100:0:3);
  READLN(tit,docks,robs);
  IF docks<>0THEN GOTO First;
  CLOSE(tot);
  CLOSE(tit);
END.