PROGRAM MST;
CONST
  filinp='lan.inp';
  filout='lan.out';
  a=801;
TYPE
  Rec=RECORD a,b,c:INTEGER;END;
VAR
  tit,tot:TEXT;
  ss:ARRAY[1..a*(a+1)DIV 2]OF Rec;
  s:ARRAY[1..a]OF LONGINT;
  q1,q2,q3,q4,c,c2,min:LONGINT;
FUNCTION Find(a:INTEGER):INTEGER;
VAR
  b,c:INTEGER;
BEGIN
  b:=a;
  WHILE b<>0 DO BEGIN c:=b;b:=s[b];END;
  IF c<>a THEN s[a]:=c;
  Find:=c;
END;
PROCEDURE Union(a,b:INTEGER);
BEGIN
  s[b]:=a;
END;
FUNCTION KRUS:LONGINT;
VAR
  c1,fa,fb,cc:INTEGER;
  min1:LONGINT;
BEGIN
  min1:=0;
  cc:=0;
  FOR q1:=1 TO c DO
    BEGIN
      fa:=Find(ss[q1].a);
      fb:=Find(ss[q1].b);
      IF fa<>fb THEN
        BEGIN
          UNION(fa,fb);
          min1:=min1+ss[q1].c;
          INC(cc);
        END;
      IF cc=q4-1 THEN BREAK;
    END;
  KRUS:=min1;
END;
PROCEDURE QS(left,right:LONGINT);
VAR
  i,j:LONGINT;
  x:LONGINT;
  y:Rec;
BEGIN
  i:=left;
  j:=right;
  x:=ss[(left+right)DIV 2].c;
  REPEAT
    WHILE(ss[i].c<x)AND(i<right)DO INC(i);
    WHILE(ss[j].c>x)AND(j>left)DO DEC(j);
    IF i<=j THEN
      BEGIN
        y:=ss[i];
        ss[i]:=ss[j];
        ss[j]:=y;
        INC(i);
        DEC(j);
      END;
  UNTIL NOT(i<=j);
  IF left<j THEN QS(left,j);
  IF i<right THEN QS(i,right);
END;
PROCEDURE QSort;
BEGIN
  QS(1,c);
END;
FUNCTION Count:INTEGER;
VAR
  sss:ARRAY[1..a]OF BOOLEAN;
  qqq,ccc:INTEGER;
BEGIN
  FOR qqq:=1 TO a DO sss[qqq]:=FALSE;
  FOR qqq:=1 TO q2+1 DO sss[Find(qqq)]:=TRUE;
  ccc:=0;
  FOR qqq:=1 TO q2+1 DO IF sss[qqq] THEN INC(ccc);
  Count:=ccc;
END;
BEGIN
  ASSIGN(tit,filinp);
  ASSIGN(tot,filout);
  RESET(tit);
  REWRITE(tot);
  FOR q1:=1 TO a DO s[q1]:=0;
  q1:=0;
  q2:=0;
  q3:=0;
  WHILE NOT EOF(tit)DO
    BEGIN
      q1:=0;
      INC(q2);
      WHILE NOT EOLN(tit)DO
        BEGIN
          INC(q1);
          READ(tit,c2);
          IF c2>0 THEN
            BEGIN
              INC(q3);
              ss[q3].a:=q2;
              ss[q3].b:=q2+q1;
              ss[q3].c:=c2;
            END
          ELSE IF Find(q2)<>Find(q2+q1)THEN Union(Find(q2),Find(q2+q1));
        END;
      READLN(tit);
    END;
  q4:=Count;
  c:=q3;
  QSort;
  min:=KRUS;
  WRITELN(tot,min);
  CLOSE(tit);
  CLOSE(tot);
END.
