PROGRAM Recurses;
TYPE
  Arsys=ARRAY[1..31]OF LONGINT;
VAR
  a,b,c1,c2:LONGINT;

FUNCTION Prod(a:LONGINT):LONGINT;
VAR
  b,q:LONGINT;
BEGIN
  b:=1;
  FOR q:=2TO a DO b:=b*q;
  Prod:=b;
END;

FUNCTION SumN(a:LONGINT):LONGINT;
VAR
  q,b:LONGINT;
BEGIN
  q:=0;b:=0;
  FOR q:=1TO a DO b:=b+q;
  SumN:=b;
END;

PROCEDURE Systems(a,b:LONGINT);
BEGIN
  IF a<b THEN WRITE(a)ELSE BEGIN Systems(a DIV b,b);WRITE(a MOD b);END;
END;

FUNCTION NOD(a,b:LONGINT):LONGINT;
BEGIN
  IF b=0THEN NOD:=a ELSE NOD:=NOD(b,a MOD b);
END;

FUNCTION NOK(a,b:LONGINT):LONGINT;
BEGIN
  NOK:=a*b DIV NOD(a,b);
END;

FUNCTION NMD(a:LONGINT):LONGINT;
VAR
  b,q:LONGINT;
  z:BOOLEAN;
BEGIN
  b:=TRUNC(SQRT(a));
  z:=FALSE;
  FOR q:=2TO b DO IF a MOD q=0THEN BEGIN z:=TRUE;NMD:=q;BREAK;END;
  IF NOT z THEN NMD:=a;
END;

PROCEDURE Fact(a:LONGINT);
VAR
  q:LONGINT;
BEGIN
  WRITELN;
  WHILE a<>1DO
    BEGIN
      q:=NMD(a);
      WRITELN(q);
      a:=a DIV q;
    END;
END;

FUNCTION Fibonacci(a:LONGINT):LONGINT;
VAR
  q1,q2,q,t:LONGINT;
BEGIN
  q1:=1;q2:=1;t:=0;
  FOR q:=3TO a DO BEGIN t:=q1+q2;q2:=q1;q1:=t;END;
  Fibonacci:=t;
  IF a=1THEN Fibonacci:=1;
  IF a=2THEN Fibonacci:=1;
END;

FUNCTION Realpow(a:REAL;b:LONGINT):REAL;
VAR
  c:LONGINT;
  cc:REAL;
BEGIN
  cc:=1;
  FOR c:=1TO b DO cc:=cc*a;
  Realpow:=cc;
END;

FUNCTION Pow(a,b:LONGINT):LONGINT;
BEGIN
  IF b=0THEN Pow:=1 ELSE Pow:=a*Pow(a,b-1);
END;

FUNCTION Fastpow(a,b:LONGINT):LONGINT;
BEGIN
  IF b=0THEN Fastpow:=1 ELSE IF b MOD 2=1THEN Fastpow:=a*Fastpow(a,b-1)ELSE Fastpow:=SQR(Fastpow(a,b DIV 2));
END;

FUNCTION FibonacciFast(a:LONGINT):LONGINT;
VAR
  c1,c2,c3,c4,c5:REAL;
BEGIN
  c1:=1/SQRT(5);
  c2:=(1+SQRT(5))/2;
  c3:=(1-SQRT(5))/2;
  c4:=Realpow(c2,a);
  c5:=Realpow(c3,a);
  FibonacciFast:=TRUNC(c1*(c4-c5));
END;

FUNCTION Combs(n,k:LONGINT):LONGINT;
CONST
  max=60;
VAR
  q,q1:LONGINT;
  ss:ARRAY[1..max,1..max]OF LONGINT;
BEGIN
  FOR q1:=1TO max DO FOR q:=1TO max DO ss[q1,q]:=0;
  ss[1,1]:=1;
  FOR q1:=2TO n+1 DO
    FOR q:=1TO q1 DO
      IF(q=1)OR(q=q1)THEN ss[q1,q]:=1
      ELSE ss[q1,q]:=ss[q1-1,q-1]+ss[q1-1,q];
  Combs:=ss[n+1,k+1];
END;

FUNCTION Combs2(n,k:LONGINT):LONGINT;
BEGIN
  Combs2:=Prod(n)DIV Prod(k)DIV Prod(n-k);
END;

FUNCTION Stirling(n,k:LONGINT):LONGINT;
CONST
  max=40;
VAR
  q,q1:LONGINT;
  ss:ARRAY[0..max,0..max]OF LONGINT;
BEGIN
  FOR q:=0TO max DO FOR q1:=1TO max DO ss[q,q1]:=0;
  ss[0,0]:=1;
  FOR q:=1TO n DO FOR q1:=0TO n DO IF q1=0THEN ss[q,q1]:=0 ELSE ss[q,q1]:=ss[q-1,q1-1]+q1*ss[q-1,q1];
  Stirling:=ss[n,k];
END;

FUNCTION Bel(a:LONGINT):LONGINT;
VAR
  q,cc:LONGINT;
BEGIN
  cc:=0;
  FOR q:=0TO a DO cc:=cc+Stirling(a,q);
  Bel:=cc;
END;

PROCEDURE Rzb(a:LONGINT);
VAR
  c:LONGINT;
  ss:ARRAY[0..100]OF LONGINT;
PROCEDURE Print;VAR q1:LONGINT;BEGIN FOR q1:=1TO c DO WRITE(ss[q1],' ');WRITELN;END;
PROCEDURE Razb(a:LONGINT);
VAR
  q1:LONGINT;
BEGIN
  IF a=0THEN Print
  ELSE FOR q1:=ss[c]DOWNTO 1DO IF q1<=a THEN
    BEGIN INC(c);ss[c]:=q1;Razb(a-q1);DEC(c);END;
END;
BEGIN
  c:=0;ss[0]:=a;
  Razb(a);
END;

FUNCTION braz(a:LONGINT):LONGINT;
VAR
  ss:ARRAY[1..50,1..50]OF LONGINT;
  q1,q2:LONGINT;
BEGIN
  FOR q1:=1TO a DO FOR q2:=1TO a DO
    IF q1=1THEN ss[q1,q2]:=1
    ELSE IF q2=1THEN ss[q1,q2]:=1
    ELSE IF q2>q1 THEN ss[q1,q2]:=ss[q1,q1]
    ELSE IF q2=q1 THEN ss[q1,q2]:=ss[q1,q1-1]+1
    ELSE ss[q1,q2]:=ss[q1-q2,q2]+ss[q1,q2-1];
  braz:=ss[a,a];
END;
BEGIN
  WRITELN;
  a:=0;b:=0;
  READLN(a,b);
  WRITELN;
  WRITELN(combs(a,b));
  READLN;
END.