var
  F: Text;
  A,B,C,T: array[1..1000] of integer;
  N,k,i: integer;
  x1,y1,x2,y2,w: integer;
  L: integer;

begin
  Assign(F,'MANHAT2.INP');
  Reset(F);
  Readln(F,N);
  for i:=1 to N do
    begin
      Readln(F,x1,y1,x2,y2);
      if y1=y2 then
        begin
          A[i]:=x1;
          B[i]:=x2;
          C[i]:=y1;
          T[i]:=0;
        end
      else
        begin
          A[i]:=y1;
          B[i]:=y2;
          C[i]:=x1;
          T[i]:=1;
        end;
      if A[i] > B[i] then
        begin
          w:=A[i];  A[i]:=B[i];  B[i]:=w;
        end;
    end;
  Close(F);

  L:=0;
  for k:=1 to N do
    begin
      for i:=1 to k-1 do
        if (T[i]=T[k]) and (C[i]=C[k]) then
          if (A[i]<A[k]) and (A[k]<=B[i]) and (B[i]<=B[k]) then
            A[k]:=A[i]
          else if (B[k]<B[i]) and (A[k]<=A[i]) and (A[i]<=B[k]) then
            B[k]:=B[i];
      if L < B[k]-A[k] then L:=B[k]-A[k];
    end;

  Assign(F,'MANHAT.OUT');
  Rewrite(F);
    Writeln(F,L);
  Close(F);

end.

var
  F: text;
  s,t: string;
  x,i,m,n: integer;

begin
  Assign(F,'SEVEN1.INP');
  Reset(F);

  s:='0';  m:=1;
  repeat
    readln(F,t);
    while t[1]='0' do Delete(t,1,1);
    n:=Length(t);
    if (m < n) or ((m=n) and (s<t)) then
      begin
        x:=0;
        for i:=1 to n do
          x:=(x*10 + Ord(t[i])-48) mod 7;
        if x = 0 then
          begin
            s:=t;
            m:=n;
          end;
      end;
  until EoF(F);
  Close(F);

  Assign(F,'SEVEN.OUT');
  Rewrite(F);
    writeln(F,s);
  Close(F);
end.
const
  P: array[1..6,1..3] of integer = ((1,0,0),(-1,0,0),
                                    (0,1,0),(0,-1,0),
                                    (0,0,1),(0,0,-1));
  Inf=100;

var
  D: array[-1..21,-1..21,-1..21] of integer;
  A, B, C,
  x, y, z,
  x1,y1,z1,
  x2,y2,z2,
  x3,y3,z3: integer;
  i: integer;
  F: text;

begin
  Assign(F,'BOX.INP');
  Reset(F);
    Readln(F,A,B,C);
    Readln(F,x1,y1,z1);
    Readln(F,x2,y2,z2);
  Close(F);

  for x:=-1 to A+1 do
  for y:=-1 to B+1 do
  for z:=-1 to C+1 do
    D[x,y,z]:=Inf;

  D[x1,y1,z1]:=0;

  repeat
    for x:=0 to A do
    for y:=0 to B do
    for z:=0 to C do
      if (x=0) or (x=A) or (y=0) or (y=B) or (z=0) or (z=C) then
        if D[x,y,z]=Inf then
          for i:=1 to 6 do
            begin
              x3:=x+P[i,1];
              y3:=y+P[i,2];
              z3:=z+P[i,3];
              if D[x3,y3,z3] < Inf then
               if D[x,y,z] > D[x3,y3,z3] + 1 then
                 D[x,y,z]:=D[x3,y3,z3]+1;
            end;
  until D[x2,y2,z2]<Inf;

  Assign(F,'BOX.OUT');
  Rewrite(F);
    writeln(F,D[x2,y2,z2]);
  Close(F);

end.


