#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<string>
#include<vector>
#include<sstream>
#include<iostream>
#include<algorithm>

using namespace std;

#define VI vector < int >
#define VS vector < string >
#define pb push_back
#define sz size()
#define cs c_str()
#define ALL(a) (a).begin(),(a).end()
/////////////////////////

#define MOD 10000

class PermanentComputation
{public:
int compute(VS inp)
  {vector < VI > a;
  vector < VI > ss;
  int q1,q2,q3,c1,c2,c3,c4,c5,c=inp.sz;
  
  for(q1=0;q1<c;q1++)
    {
    VI row;
    istringstream e1(inp[q1]);
    
    for(q2=0;q2<c;q2++)
      {
      e1 >> c1;
      row.pb(c1);
      }
    a.pb(row);
    }
  ss.resize(c,VI(1<<c));
  
  for(q1=0;q1<c;q1++)ss[0][1<<q1]=a[0][q1]%MOD;
  
  for(q1=1;q1<c;q1++)for(q2=0;q2<(1<<c);q2++)
    {
    c1=0;
    for(q3=0;q3<c;q3++)if(q2&(1<<q3))c1++;
    if(c1!=q1+1)continue;
    
    c1=0;
    for(q3=0;q3<c;q3++)if(q2&(1<<q3))
      {
      c2=q2^(1<<q3);
      c1+=a[q1][q3]*ss[q1-1][c2];
      c1=c1%MOD;
      }
    ss[q1][q2]=c1;
    }
  
  
  return ss[c-1][(1<<c)-1];}

};

int comp(VS inp)
  {
  vector < VI > a;
  int q1,q2,c,c1,c2;
  c=inp.sz;
  
  for(q1=0;q1<c;q1++)
    {
    VI row;
    istringstream e1(inp[q1]);
    
    for(q2=0;q2<c;q2++)
      {
      e1 >> c1;
      row.pb(c1);
      }
    a.pb(row);
    }
  
  VI p;
  for(q1=0;q1<c;q1++)p.pb(q1);
  
  c1=0;
  
  do{
    c2=1;
    
    for(q1=0;q1<c;q1++)
      c2=(c2*a[q1][p[q1]])%MOD;
      
    c1=(c1+c2)%MOD;  
    }
  while(next_permutation(ALL(p)));
  
  return c1;}

VS generate(int a,int b)
  {
  int q1,q2,q3,c1,c2,c3,c=a;
  VS res;
  
  for(q1=0;q1<a;q1++)
    {
    VI row;
    string rw;
    for(q2=0;q2<a;q2++)
      row.pb( ( (rand()-1297343+a+b-(int)sqrt((double)a+b))%MOD+32443)%(MOD+1));
      
    char d[100];
    memset(d,0,sizeof(d));
    sprintf(d,"%d",row[0]);
    rw=d;
    for(q2=1;q2<c;q2++)
      {memset(d,0,sizeof(d));
      sprintf(d," %d",row[q2]);
      rw+=d;
      }
      
    res.pb(rw);
    }
  
  return res;}

int main()
  {
  PermanentComputation aa;
  
  for(int q1=0;q1<5;q1++)
    {
    VS mat=generate(9,q1+53243);
    int c1,c2;
    
    c1=aa.compute(mat);
    c2=comp(mat);
    
    if(c1!=c2)printf("ERROR\n");
    }
  
  return 0;}