#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<string>
#include<vector>
#include<sstream>
#include<iostream>
#include<algorithm>

using namespace std;

#define VI vector < long long >
#define VS vector < string >
#define pb push_back
#define sz size()
#define cs c_str()
#define ALL(a) (a).begin(),(a).end()
/////////////////////////
#define mx 128
#define type long long
type inf;

VI combine (VI a, VI b,type cost)
  {VI c=a;
  type q1,q2,c1,c2,c3;
  
  for(q1=0;q1<a.sz;q1++)for(q2=0;q2<b.sz;q2++)if(q1+q2<c.sz)
    {
    if(a[q1]+b[q2]+cost<c[q1+q2])
      c[q1+q2]=a[q1]+b[q2]+cost;
    }
  
  return c;}
  
type c;

vector < vector < pair < type , type > > > nei;

VI dfs(type a,type b)
  {type q1,q2,c1,c2;
  VI res(c+1,inf);
  res[1]=0;
  
  for(q1=0;q1<nei[a].sz;q1++)if(nei[a][q1].first!=b)
    {
    VI e1=dfs(nei[a][q1].first,a);
    
    res=combine(res,e1,nei[a][q1].second);
    }
    
  return res;}

class HighwayBuilding
{public:
int getMaxCities(int numCities, int capital, vector <string> h, int budget)
  {
  c=numCities;
  nei.resize(c);
  type q1,c1,c2,c3,q2;
  
  inf=1;
  for(q1=0;q1<50;q1++)inf=inf*2+1;
  
  for(q1=0;q1<h.sz;q1++)
    {
    string e2=h[q1],e3;
    while(e2.find(',')!=-1)
      {
      for(q2=0;e2[q2]!=',';q2++);
      e3=e2.substr(q2+1);
      e2[q2]=' ';
      sscanf(e2.cs,"%lld %lld %lld",&c1,&c2,&c3);
      nei[c1].pb(make_pair(c2,c3));
      nei[c2].pb(make_pair(c1,c3));
      e2=e3;
      }
    sscanf(e2.cs,"%lld %lld %lld",&c1,&c2,&c3);
    nei[c1].pb(make_pair(c2,c3));
    nei[c2].pb(make_pair(c1,c3));
    }
  
  VI e1=dfs(capital,-1);
  
  for(q1=e1.sz-1;q1>=0;q1--)if(e1[q1]<=(type)budget)break;
  
  return q1-1;}
};