/*
TASK: block
ID: swetko3
LANG: C++
*/ 
#include<cstdio>
#include<cmath>
#include<cstdlib>
#include<fstream>
#include<iostream>
#include<vector>
#include<queue>
#include<string>
#include<algorithm>
using namespace std;
 
#define VI vector < int >
#define VS vector < string >
#define pb push_back
#define cs c_str()
#define sz size()
#define ALL(a) (a).begin(),(a).end()

#define in "block.in"
#define ut "block.out"
#define maxx 999999999

vector < VI > nei;
vector < VI > cost;
int c,m;

VI update(VI a,int b,VI d)
  {
  VI c;
  c.resize(4);
  c[0]=min(d[0],a[0]+b);
  c[1]=min(d[1],a[1]+b);
  if(d[0]!=maxx)c[1]=min(d[1],a[0]+b);
  c[2]=maxx;
  if(d[0]!=c[0])   c[2]=min(c[2],d[0]);
  if(d[1]!=c[0])   c[2]=min(c[2],d[1]);
  if(d[2]!=c[0])   c[2]=min(c[2],d[2]);
  
  if(a[0]+b!=c[0]) c[2]=min(c[2],a[0]+b);
  if(a[1]+b!=c[0]) c[2]=min(c[2],a[1]+b);
  if(a[2]+b!=c[0]) c[2]=min(c[2],a[2]+b);
  
  return c;}

VI get(priority_queue < VI > & q)
  {
  VI e1=q.top();
  q.pop();
  for(int q1=0;q1<4;q1++)e1[q1]=-e1[q1];
  return e1;
  }

int put(priority_queue < VI > & q,VI e1)
  {
  for(int q1=0;q1<4;q1++)e1[q1]=-e1[q1];
  q.push(e1);
  return 0;}

int main()
  {
  ifstream fn(in);
  ofstream fnout(ut);
  
  fn >> c >> m;
  
  int q1,q2,q3,c1,c2,c3;
  
  nei.resize(c);
  cost.resize(c);
  
  for(q1=0;q1<m;q1++)
    {
    fn >> c1 >> c2 >> c3;
    c1--;
    c2--;
    nei[c1].pb(c2);
    nei[c2].pb(c1);
    cost[c1].pb(c3);
    cost[c2].pb(c3);
    }
  
  priority_queue < VI > q;
  VI e1,e2;
  vector < VI > d;
  
  e1.pb(maxx);
  e1.pb(maxx);
  e1.pb(maxx);
  e1.pb(0);
  
  for(q1=0;q1<c;q1++)
    {
    e1[3]=q1;
    d.pb(e1);
    }
  
  e1[3]=e1[0]=0;
  d[0]=e1;
  put(q,e1);
  
  while(!q.empty())
    {
    e1=get(q);
    
  //  for(q1=0;q1<4;q1++)cout << e1[q1] << " ";
  //  cout << endl;
    
    c1=e1[3];
    
    for(q1=0;q1<nei[c1].sz;q1++)
      {
      e2=update(e1,cost[c1][q1],d[nei[c1][q1]]);
      e2[3]=nei[c1][q1];
      
      if(e2<d[nei[c1][q1]])
        {
        put(q,e2);
        d[nei[c1][q1]]=e2;
        }
      }
    
    }
  
  fnout << d[c-1][2] << endl;
  
  return 0;
  }