#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#define mx 128
#define divide 3
#define ABS(a) ((a)<0?-(a):(a))
#define eps 0.00000001
#define inf 1e30
#define in stdin;//fopen("c:\\tp\\tests\\find.in","r")
FILE*fn;
typedef struct {double x,y;int n;}point;
typedef struct {point a,b;}line;
typedef struct {double a,b,c;}lineeq;
double det2(double a,double b,double c,double d)
  {double c1;
  c1=a*d-b*c;
  return c1;}
double det22(point a,point b,point c)
  {return det2(b.x-a.x,b.y-a.y,c.x-a.x,c.y-a.y);}
int eq(double a,double b){if(ABS(a-b)<eps)return 1;else return 0;}
int greater(double a,double b){if(a-b>eps)return 1;else return 0;}
int cross(line a,line b)
  {double c1,c2,c3,c4;
  c1=det22(a.a,a.b,b.a);
  c2=det22(a.a,a.b,b.b);
  c3=det22(b.a,b.b,a.a);
  c4=det22(b.a,b.b,a.b);
  if(c1!=0.0)c1/=ABS(c1);
  if(c2!=0.0)c2/=ABS(c2);
  if(c3!=0.0)c3/=ABS(c3);
  if(c4!=0.0)c4/=ABS(c4);
  if(c1*c2<=0.0)if(c3*c4<=0.0)return 1;
  return 0;}
double dist2(point a,point b)
  {return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));}
lineeq findeq2(double x1,double y1,double x2,double y2)
  {lineeq e1;
  e1.a=y2-y1;
  e1.b=x1-x2;
  e1.c=y1*x2-y2*x1;
  return e1;}
lineeq findeq(line a)
  {return findeq2(a.a.x,a.a.y,a.b.x,a.b.y);}
point findcross(line a,line b)
  {lineeq p1,p2;
  point e1;
  p2=findeq(a);
  p1=findeq(b);
  if(eq(p1.a*p2.b,p1.b*p2.a))
    {e1.x=-inf;
    e1.y=0.0;
    return e1;}
  e1.y=(p2.a*p1.c-p2.c*p1.a)/(p2.b*p1.a-p2.a*p1.b);
  e1.x=(p1.b*p2.c-p2.b*p1.c)/(p2.b*p1.a-p2.a*p1.b);
  return e1;}
int pointonline(point a,line b)
  {double c1=det22(b.a,b.b,a);
  double c2=dist2(a,b.a)+dist2(a,b.b);
  double c3=dist2(b.a,b.b);
  if(eq(c2,c3))if(eq(0.0,c1))return 1;
  return 0;}
int ponl(point a,point b,point c)
  {line g;
  g.a=b;
  g.b=c;
  return pointonline(a,g);}
int cmp(const void*aa,const void*bb)
  {point a=*((point*)aa);
  point b=*((point*)bb);
  if(a.x>b.x)return 1;
  if(a.x==b.x)if(a.y>b.y)return 1;
  return -1;}
int eqp(point a,point b)
  {return eq(a.x,b.x)&&eq(a.y,b.y);}
point rotate(point a,double ang)
  {point b;
  b.x=cos(ang)*a.x-sin(ang)*a.y;
  b.y=sin(ang)*a.x+cos(ang)*a.y;
  return b;}
double atan22(point a)
  {return atan2(a.x,a.y);}
point minus(point a,point b)
  {point c;
  c.x=a.x-b.x;
  c.y=a.y-b.y;
  return c;}
point findpoint(point a,point b,point c)
  {double c1;
  c1=atan22(minus(a,b));
  if(c1<0.0)
    return rotate(minus(c,b),M_PI+c1);
  else
    return rotate(minus(c,b),c1-M_PI);}
///////////////////end geometry
point pp[mx];
point p[mx*mx];
line lines[mx];
char ss[mx*mx/divide][mx*mx/divide];
short nei[mx*mx/divide][mx*mx/divide];
int ns[mx*mx/divide];
int pol[mx*mx][mx];
int lps[mx][mx*mx];
int bp[mx];
int c,cc,ps,q1,q2,q3,q4,c1,c2,c3;
point p1,p2,p3;
point ans[mx];
///////////////////////
point s[mx*mx];
int findit(int a,int b)
  {int q1,c1;
  double c2=-10.0,c3,c4=inf,c5;
  for(q1=0;q1<ns[b];q1++)
    if(nei[b][q1]!=a)
      s[q1]=findpoint(p[a],p[b],p[nei[b][q1]]);


  for(q1=0;q1<ns[b];q1++)if(nei[b][q1]!=a)
    {if(eq(det22(p[a],p[b],p[nei[b][q1]]),0.0)&&ponl(p[a],p[b],p[nei[b][q1]]))continue;
    c3=atan22(s[q1]);
    c5=dist2(p[b],p[nei[b][q1]]);
    if(greater(c3,c2)
       ||(eq(c2,c3)
       &&greater(c4,c5)))
         {c2=c3;
         c4=c5;
         c1=q1;}}

  return nei[b][c1];}
/////////////////
int main()
  {fn=in;
  fscanf(fn,"%d",&c);
  for(q1=0;q1<c;q1++)fscanf(fn,"%lf %lf",&pp[q1].x,&pp[q1].y);
  pp[c]=pp[0];
  fclose(fn);
  for(q1=0;q1<c;q1++){lines[q1].a=pp[q1];lines[q1].b=pp[q1+1];}
  for(ps=q1=0;q1<c;q1++)for(q2=q1+1;q2<c;q2++)
    {if(cross(lines[q1],lines[q2])==0)continue;
    p1=findcross(lines[q1],lines[q2]);
    p[ps++]=p1;}
  p[ps]=findcross(lines[0],lines[0]);
  qsort(p,ps+1,sizeof(p[0]),cmp);
  c1=++ps;
  ps=1;
  for(q1=1;q1<c1;q1++)if(!eqp(p[q1-1],p[q1]))p[ps++]=p[q1];
  for(q1=0;q1<ps;q1++)for(q2=0;q2<c;q2++)if(pointonline(p[q1],lines[q2]))pol[q1][q2]=1;
  for(q1=0;q1<ps;q1++)for(q2=0;q2<c;q2++)if(pol[q1][q2])lps[q2][bp[q2]++]=q1;
  for(q1=0;q1<c;q1++)
    for(q2=0;q2<bp[q1];q2++)
      for(q3=0;q3<bp[q1];q3++)if(q2!=q3)
        ss[lps[q1][q2]][lps[q1][q3]]=1;
  for(q1=0;q1<ps;q1++)for(q2=0;q2<ps;q2++)if(ss[q1][q2])
    nei[q1][ns[q1]++]=q2;
  c2=0;
  c1=1;
  while(1)
    {ans[cc++]=p[c1];
    c3=findit(c2,c1);
    c2=c1;
    c1=c3;
    if(c1==1)break;}
  printf("%d\n",cc);
  for(q1=0;q1<cc;q1++)printf("%.4lf %.4lf\n",ans[q1].x,ans[q1].y);
  return 0;}
