#include<cstdio>
#include<cstdlib>
#include<queue>
#include<cstring>
#include<cmath>
#include<map>
#include<string>
#include<vector>
#include<sstream>
#include<iostream>
#include<algorithm>

using namespace std;

#define VI vector < int >
#define VS vector < string >
#define pb push_back
#define sz size()
#define cs c_str()
#define ALL(a) (a).begin(),(a).end()
/////////////////////////
#define in stdin;//fopen("c:\\tp\\tests\\berk\\8.in","r")
FILE*fn;
#define maxx 1999999999

int cas,x,y,xs,xe,ys,ye,mv,md;

VS maze;
vector < vector < VI > > can;

int m[4][2]= { {-1,0},{0,1},{1,0},{0,-1} };

int left(int x1,int y1)
  {
  if(maze[x1][y1*2]=='|')return 0;
  return 1;
  }
  
int bottom(int x1,int y1)
  {
  if(maze[x1][y1*2+1]=='_')return 0;
  return 1;
  }
  
int cc(int x1,int y1,int  dir)
  {
  if(dir==1)if(y1==y-1)return 0;
  if(dir==0)if(x1==0)return 0;
  if(dir==2)if(x1==x-1)return 0;
  if(dir==3)if(y1==0)return 0;
  
  if(dir==3)return left(x1,y1);
  if(dir==2)return bottom(x1,y1);
  if(dir==1)return left(x1,y1+1);
  if(dir==0)return bottom(x1-1,y1);
  }

int readmaze(void)
  {int q1,q2,q3,x1,y1,c1;
  char d[300000];
  fscanf(fn,"%d %d %d %d %d %d",&y,&x,&ys,&xs,&ye,&xe);
  if(y==0 && x==0 && xs==0 && ys==0 && xe==0 && ye==0)return 0;
  fgets(d,300000,fn);
  for(q1=0;q1<x;q1++)
    {
    fgets(d,300000,fn);
    maze.pb(d);
    maze[maze.sz-1].resize(maze[maze.sz-1].sz-1);
    }
  can=vector < vector < VI > > (x,vector < VI > (y,VI(4,0)));
  for(q1=0;q1<x;q1++)for(q2=0;q2<y;q2++)for(q3=0;q3<4;q3++)
    {
    x1=q1;
    y1=q2;
    c1=0;
    
    while(cc(x1,y1,q3))
      {
      c1++;
      x1+=m[q3][0];
      y1+=m[q3][1];
      }
    can[q1][q2][q3]=c1;  
    } 
  
  c1=max(x,y)*10;
  for(mv=1;mv*mv<c1;mv++);
  md=4;
  return 1;}


struct pos {int x,y,v,d;};

int decode(int a,pos&b)
  {
  b.d=a%md;a/=md;
  b.v=a%mv;a/=mv;
  b.y=a%y;a/=y;
  b.x=a%x;
  return 0;
  }

int encode(pos&b)
  {int a=0;
  a+=b.x;a*=y;
  a+=b.y;a*=mv;
  a+=b.v;a*=md;
  a+=b.d;
  return a;
  }

queue < pos > q;

pos e1,e2,e3;
int q1,q2,q3,c1,c2,c3,start,end;
VI d;

int clear(void)
  {
  x=y=xs=xe=ye=ys=start=end=mv=md=q1=q2=q3=c1=c2=c3=0;
  maze.clear();
  can.clear();
  d.clear();
  while(!q.empty())q.pop();
  
  return 0;
  }
int main()
  {
  fn=in;
  
  while(1)
    {
    clear();
    cas++;
    
    if(readmaze()==0)break;
    
    e1.x=xs;
    e1.y=ys;
    e1.v=0;
    e1.d=0;
    
    d.resize(x*y*mv*md+1);
    
    start=encode(e1);
    
    q.push(e1);
    
    for(q1=0;q1<d.sz;q1++)d[q1]=maxx;
    d[start]=0;
    
    while(!q.empty())
      {
      e1=q.front();
      if(e1.x==xe && e1.y==ye)break;
      c1=encode(e1);
      c3=d[c1];
      q.pop();
      
      for(q1=1;q1<=e1.v+1;q1++)
        {
        if(can[e1.x][e1.y][e1.d]<q1)break;
        e2=e1;
        e2.x+=q1*m[e1.d][0];  
        e2.y+=q1*m[e1.d][1];
        e2.v=q1;
        c2=encode(e2);
        if(d[c2]!=maxx)continue;
        d[c2]=d[c1]+1;
        q.push(e2);
        }
      
      for(q1=0;q1<4;q1++)
        {
        if(can[e1.x][e1.y][q1]==0)continue;
        e2=e1;
        e2.x+=m[q1][0];  
        e2.y+=m[q1][1];
        e2.v=1;
        e2.d=q1;
        c2=encode(e2);
        if(d[c2]!=maxx)continue;
        d[c2]=d[c1]+1;
        q.push(e2);
        }
      }
    
    if(!q.empty())
      {
      printf("Maze %d. %d steps to the exit\n",cas,d[encode(e1)]);
      }
    else
      {
      printf("Maze %d. No escape possible\n",cas);
      }
    
    }
  fclose(fn);
  return 0;
  }