#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<math.h>
#define mx 100
#define pi M_PI
#define eps 1e-10
#define in stdin;//fopen("c:\\tp\\tests\\cut.in","r")
FILE*fn;
typedef struct {double x,y;}point;
typedef struct {double x,y,h,w;point p;}tree;
typedef struct {double when;int what;}event;
typedef struct {double x,y,r;point p;}circle;
double dist2(point p1,point p2)
  {return sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));}
double dist22(double a,double b)
  {return sqrt(a*a+b*b);}
int ifinter(tree a,circle b)
  {if(dist22(a.h,a.w/2.0)+b.r>dist2(a.p,b.p))return 1;
  return 0;}
double ABS(double a){if(a<0.0)return -a;else return a;}
point rot(point a,point b,double ang,double neww)
  {point p1,p2;
  double c1,cosa=cos(ang),sina=sin(ang);
  p1.x=b.x-a.x;
  p1.y=b.y-a.y;
  p2.x=p1.x*cosa-p1.y*sina;
  p2.y=p1.x*sina+p1.y*cosa;
  c1=dist2(a,b);
  if(neww<0.0)neww=c1;
  p2.x=p2.x*(neww/c1);
  p2.y=p2.y*(neww/c1);
  p2.x+=a.x;
  p2.y+=a.y;
  return p2;}
double anga(double a,double b,double c)
  {return acos((c*c+b*b-a*a)/2.0/b/c);}
double whereenter(tree a,circle b)
  {point p1,p2,p3,p4;
  double c1,c2,c3,c4;
  c1=dist2(a.p,b.p);
  c2=b.r+a.w/2.0;
  c3=acos(c2/c1);
  p1=rot(b.p,a.p,-c3,c2);
  if(dist2(p1,a.p)>a.h)
    {c4=dist22(a.h,a.w/2.0);
    c3=anga(c4,b.r,c1);
    p1=rot(b.p,a.p,-c3,b.r);
    p2=rot(a.p,p1,-anga(a.h,a.w/2.0,c4),a.w/2.0);
    return atan2(p1.x-p2.x,p1.y-p2.y);}
  else
    return atan2(p1.x-a.x,p1.y-a.y);}
double whereexit(tree a,circle b)
  {point p1,p2,p3,p4;
  double c1,c2,c3,c4;
  c1=dist2(a.p,b.p);
  c2=b.r+a.w/2.0;
  c3=acos(c2/c1);
  p1=rot(b.p,a.p,c3,c2);
  if(dist2(p1,a.p)>a.h)
    {c4=dist22(a.h,a.w/2.0);
    c3=anga(c4,b.r,c1);
    p1=rot(b.p,a.p,c3,b.r);
    p2=rot(a.p,p1,anga(a.h,a.w/2.0,c4),a.w/2.0);
    return atan2(p1.x-p2.x,p1.y-p2.y);}
  else
    return atan2(p1.x-a.x,p1.y-a.y);}
///////////////////////////////////////////////////
int inint,allnum;
event al[10];
int dotreebase(tree a,circle b)
  {event e1,e2,e3,e4;
  tree c=a;
  double c1,c2,c3;
  c.h=a.w/2.0;
  c.w=a.h*2.0;
  if(a.h<dist2(a.p,b.p)-b.r)
    {e1.when=whereenter(a,b);
    e1.what=1;
    e2.when=whereexit(c,b);
    e2.what=2;
    if(e1.when>e2.when)inint++;
    e3.when=whereenter(c,b);
    e3.what=1;
    e4.when=whereexit(a,b);
    e4.what=2;
    if(e3.when>e4.when)inint++;
    al[allnum++]=e1;
    al[allnum++]=e2;
    al[allnum++]=e3;
    al[allnum++]=e4;}
  else
    {e1.when=whereenter(a,b);
    e1.what=1;
    e2.when=whereexit(a,b);
    e2.what=2;
    if(e1.when>e2.when)inint++;
    al[allnum++]=e1;
    al[allnum++]=e2;}
  return 0;}
///////////////////////////////////////////////////
tree trees[mx];
circle bases[mx];
int fallen[mx];
int q1,c1,c;
double w1,w2,w3,w4,x1,yy11,x,y;


int cmp(const void*a,const void*b)
  {if(ABS(((event*)a)->when-((event*)b)->when)<eps)
    return ((event*)b)->what-((event*)a)->what;
  if(((event*)a)->when>((event*)b)->when)return 1;
  return -1;}
int doone(tree a,event*e1,event*e2)
  {double c1,c2,c3;
  c1=dist22(a.h,a.w/2.0);
  if(c1<a.y)return 0;
  c2=sqrt(c1*c1-a.y*a.y);
  c3=atan(c2/a.y);
  c3+=atan(a.w/2.0/a.h);

  e2->when=-pi+c3;
  e1->when=pi-c3;
  e1->what=1;
  e2->what=2;
  return 1;}
int doonee(tree a,event*ee1,event*ee2,event*ee3,event*ee4,int num)
  {event e1,e2;
  tree b;
  int c1;
  ////////////////////////this procedure not yet ready - do the special case
  if(num==0)
    {b=a;
    c1=doone(b,&e1,&e2);}
  if(num==1)
    {b.x=a.y;
    b.y=a.x;
    c1=doone(b,&e1,&e2);
    e1.when+=pi/2.0;
    e2.when+=pi/2.0;}
  if(num==2)
    {b.x=a.y;
    b.y=y-a.y;
    c1=doone(b,&e1,&e2);
    e1.when+=pi;
    e2.when+=pi;}
  if(num==3)
    {b.x=a.y;
    b.y=x-a.x;
    c1=doone(b,&e1,&e2);
    e1.when+=pi*3.0/2.0;
    e2.when+=pi*3.0/2.0;}
  if(c1==0)return 0;
  if(e1.when>pi)e1.when=-2.0*pi+e1.when;
  if(e1.when<-pi)e1.when=2.0*pi+e1.when;
  if(e2.when>pi)e2.when=-2.0*pi+e1.when;
  if(e2.when<-pi)e2.when=2.0*pi+e1.when;
  if(e1.when>pi)e1.when=-2.0*pi+e1.when;
  if(e1.when<-pi)e1.when=2.0*pi+e1.when;
  if(e2.when>pi)e2.when=-2.0*pi+e1.when;
  if(e2.when<-pi)e2.when=2.0*pi+e1.when;
  *ee1=e1;
  *ee2=e2;
  return 1;}
int canfall(int a)
  {event all[mx*2];
  event exit[mx];
  event enter[mx];
  int q1,sc=0,ac=0,c1,c2,iin=0,q2;
  event e1,e2,e3,e4;
  for(q1=0;q1<c;q1++)if(q1!=a)if(!fallen[q1])if(ifinter(trees[a],bases[q1]))
    {inint=allnum=0;
    dotreebase(trees[a],bases[q1]);
    iin+=inint;
    if(allnum==2)
      {enter[sc]=al[0];
      exit[sc]=al[1];
      sc++;}
    if(allnum==4)
      {enter[sc]=al[0];
      exit[sc]=al[1];
      sc++;
      enter[sc]=al[2];
      exit[sc]=al[3];
      sc++;}
    all[ac++]=al[0];
    all[ac++]=al[1];
    if(allnum>2)
      {all[ac++]=al[2];
      all[ac++]=al[3];}
      }
  allnum=0;c1=doonee(trees[a],&e1,&e2,&e3,&e4,0);if(c1){if(e2.when<e1.when)iin++;if(allnum>2)if(e4.when<e3.when)iin++;all[ac++]=e1;all[ac++]=e2;if(allnum>2){all[ac++]=e3;all[ac++]=e4;}}
  allnum=0;c1=doonee(trees[a],&e1,&e2,&e3,&e4,1);if(c1){if(e2.when<e1.when)iin++;if(allnum>2)if(e4.when<e3.when)iin++;all[ac++]=e1;all[ac++]=e2;if(allnum>2){all[ac++]=e3;all[ac++]=e4;}}
  allnum=0;c1=doonee(trees[a],&e1,&e2,&e3,&e4,2);if(c1){if(e2.when<e1.when)iin++;if(allnum>2)if(e4.when<e3.when)iin++;all[ac++]=e1;all[ac++]=e2;if(allnum>2){all[ac++]=e3;all[ac++]=e4;}}
  allnum=0;c1=doonee(trees[a],&e1,&e2,&e3,&e4,3);if(c1){if(e2.when<e1.when)iin++;if(allnum>2)if(e4.when<e3.when)iin++;all[ac++]=e1;all[ac++]=e2;if(allnum>2){all[ac++]=e3;all[ac++]=e4;}}

  qsort(all,ac,sizeof(all[0]),cmp);
  if(iin==0)return 1;
  for(q1=0;q1<ac;q1++)
    {if(iin==0)
      return 1;
    if(all[q1].what==2)iin--;
    else if(all[q1].what==1)iin++;}
  return 0;}

int clear(void);
int q;
int main()
  {fn=in;
  while(1){q++;clear();
  fscanf(fn,"%lf %lf %lf %lf %d",&x1,&yy11,&x,&y,&c);
  if(x1+x+y+yy11+c<0.5)break;
  x-=x1;
  y-=yy11;
  for(q1=0;q1<c;q1++)
    {fscanf(fn,"%lf %lf %lf %lf",&w1,&w2,&w3,&w4);
    w1-=x1;
    w2-=yy11;
    bases[q1].x=trees[q1].x=w1;
    bases[q1].y=trees[q1].y=w2;
    trees[q1].p.x=w1;
    trees[q1].p.y=w2;
    bases[q1].p=trees[q1].p;
    trees[q1].w=bases[q1].r=w3/2.0;
    trees[q1].w*=2.0;
    trees[q1].h=w4;}

  x=x;

  while(1)
    {
    for(q1=0;q1<c;q1++)
     if(!fallen[q1])
       if(canfall(q1))
      {fallen[q1]=1;
      break;}
    if(q1==c)break;
    }
  c1=0;
  for(q1=0;q1<c;q1++)c1+=fallen[q1];
  printf("Forest %d\n%d tree(s) can be cut\n",q,c1);

  }fclose(fn);
  return 0;}
int clear(void)
  {inint=allnum=q1=c1=c=0;
  w1=w2=w3=w4=x=y=x1=yy11=0.0;
  memset(al,0,sizeof(al));
  memset(trees,0,sizeof(trees));
  memset(bases,0,sizeof(bases));
  memset(fallen,0,sizeof(fallen));
  return 0;}
