#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<string>
#include<vector>
#include<sstream>
#include<iostream>
#include<algorithm>

using namespace std;

#define VI vector < int >
#define VS vector < string >
#define pb push_back
#define sz size()
#define cs c_str()
#define ALL(a) (a).begin(),(a).end()
/////////////////////////
#define in stdin;//fopen("c:\\tp\\tests\\sudoku.in","r")
FILE*fn;
int mxx=3;
int mx=(mxx*mxx);

vector < VI > ss,num;
vector < vector < VI > > wh;
vector < vector < vector < pair < int , int > > > > nei;
char d[1000];
int ok;


int precompute(void)
  {
  int q1,q2,q3,q4;
  
  for(q1=0;q1<mx;q1++)for(q2=0;q2<mx;q2++)for(q3=0;q3<mx;q3++)for(q4=0;q4<mx;q4++)
    if( (q1==q3) || (q2==q4) || (q1/3==q3/3 && q2/3==q4/3) )
      nei[q1][q2].pb(make_pair(q3,q4));
  
  return 0;}

int put(int x,int y,int n)
  {
  int q1,c1,x1,y1,ret=1;
  ss[x][y]=n;
  ok++;
  
  for(q1=0;q1<nei[x][y].sz;q1++)
    {
    x1=nei[x][y][q1].first;
    y1=nei[x][y][q1].second;
    c1=++wh[x1][y1][n];
    if(c1==1)num[x1][y1]--;
    if(ss[x1][y1]==0&& num[x1][y1]==0)ret=0;
    }
    
  return ret;}

int rem(int x,int y,int n)
  {
  int q1,c1,x1=0,y1=0;
  ss[x][y]=0;
  ok--;
  
  for(q1=0;q1<nei[x][y].sz;q1++)
    {
    x1=nei[x][y][q1].first;
    y1=nei[x][y][q1].second;
    c1=(--wh[x1][y1][n]);
    if(c1==0)num[x1][y1]++;
    }
  
  return 0;}

int mok;  
  
int dfs(void)
  {
  if(ok==mx*mx)return 1;
  int q1,q2,c1,c2,x1,y1;
  c1=99;
 /* 
  for(q1=0;q1<mx;q1++)for(q2=0;q2<mx;q2++)
    if(ss[q1][q2]==0)if(num[q1][q2]==0)
     {
     if(mok<=ok)
       {mok=ok;
       printf("%d\n",mok);}
     
     return 0;}*/
    
  for(q1=0;q1<mx;q1++)for(q2=0;q2<mx;q2++)
    if(num[q1][q2]<c1)if(num[q1][q2]!=0)if(ss[q1][q2]==0)
      {
      c1=num[q1][q2];
      x1=q1;
      y1=q2;
     // goto end;
      }

  for(q1=1;q1<=mx;q1++)if(wh[x1][y1][q1]==0)
    {
    if(put(x1,y1,q1)==1)
      {if(dfs())return 1;}
    else 
      {
     /* if(mok<=ok)
       {mok=ok;
       printf("%d\n",mok);}*/
      }  
    rem(x1,y1,q1);
    }
  
  return 0;}
 
int clear()
  {
  ok=mok=0;
  ss.clear();
  wh.clear();
  num.clear();
  memset(d,0,sizeof(d));
  return 0;}

int main()
  {
  fn=in;
  nei.resize(mx,vector < vector < pair < int , int > > > (mx));
  precompute();
  
  while(1)
  {
  clear();
  fscanf(fn,"%s",d);
  if(d[0]=='e')break;
  int q1,q2,q3,c1,c2,c3;
   
  ss.resize(mx,VI(mx,0));
  wh.resize(mx,vector < VI > (mx,VI(mx+1,0)));
  num.resize(mx,VI(mx,mx));
 
  for(q1=0;q1<mx;q1++)for(q2=0;q2<mx;q2++)
    if(d[q1*mx+q2]=='.')ss[q1][q2]=0;
    else put(q1,q2,d[q1*mx+q2]-48);

  dfs();
  
  for(q1=0;q1<mx;q1++)
    {
    for(q2=0;q2<mx;q2++)printf("%d",ss[q1][q2]);
  //  printf("\n");
    }
  printf("\n");
  }
  fclose(fn);  
  return 0;}
