/*
TASK:radio
LANG:C
*/
#include<stdio.h>
#include<stdlib.h>
#define mx 65536
#define maxx 2099999999
#define MAX(a,b) ((a)<(b)?(a):(b))
#define MIN(a,b) ((a)<(b)?(a):(b))
#define in stdin;//fopen("i:\\tp\\tests\\radio.in","r")
FILE*fn;
typedef struct {long long type,c1,c2;} input;
typedef struct {long long x,pow;} base;
typedef struct {long long l,r,m;long long sum;} node;
typedef struct {long long l,r,m,max,min;} node2;
input ip[mx*4];
base bases[mx];
long long ic;
////handling obstacles
node h[mx*2];
long long types[mx*2],tc;
long long build(long long where,long long l,long long r)
  {h[where].l=types[l];
  h[where].r=types[r];
  h[where].m=types[(l+r)/2];
  if(l==r)return 0;
  build(where*2,l,(l+r)/2);
  build(where*2+1,(l+r)/2+1,r);
  return 0;}
long long update(long long where,long long x,long long how)
  {if(where>=mx)
    {h[where].sum+=how;
    return h[where].sum;}
  if(x<=h[where].m)update(where*2,x,how);
  else update(where*2+1,x,how);
  h[where].sum+=how;
  return 0;}
long long find(long long where,long long how)
  {if(where>=mx)
    return h[where].m;
  if(h[where*2].sum<=how)
    return find(where*2+1,how-h[where*2].sum);
  else return find(where*2,how);}
/////////////////////end
node2 s[mx*2];
long long build2(long long where,long long l,long long r)
  {s[where].l=l;
  s[where].r=r;
  s[where].m=(l+r)/2;
  if(l==r)return 0;
  build2(where*2,l,(l+r)/2);
  build2(where*2+1,(l+r)/2+1,r);
  return 0;}
long long update2(long long where,long long who,long long pow)
  {if(where>=mx)
    {s[where].min=s[where].max=where-mx;
    return 0;}
  if(who<=s[where].m)update2(where*2,who,pow);
  else update2(where*2+1,who,pow);
  if(bases[s[where*2].min].pow<=bases[s[where*2+1].min].pow)
    s[where].min=s[where*2].min;
    else s[where].min=s[where*2+1].min;
  if(bases[s[where*2].max].pow>=bases[s[where*2+1].max].pow)
    s[where].max=s[where*2].max;
    else s[where].max=s[where*2+1].max;
  return 0;}
long long findmin(long long where,long long who)
  {long long c1,c2;
  if(where>=mx)return s[where].min;
  if(who<=s[where].m)return findmin(where*2,who);
  if(who==s[where].r)return s[where].min;
  c1=findmin(where*2+1,who);
  c2=s[where*2].min;
  if(bases[c2].pow<=bases[c1].pow)return c2;else return c1;}

long long findmax(long long where,long long who)
  {long long c1,c2;
  if(where>=mx)return s[where].max;
  if(who<=s[where].m)return findmax(where*2,who);
  if(who==s[where].r)return s[where].max;
  c1=findmax(where*2+1,who);
  c2=s[where*2].max;
  if(bases[c2].pow>=bases[c1].pow)return c2;else return c1;}
////////////////////sorting&searching
int cmp(const void*a,const void*b)
  {return ((base*)a)->x-((base*)b)->x;}
int cmp2(const void*a,const void*b)
  {return (*((long long*)a))-(*((long long*)b));}

///////////////////

long long q1,c1,c2,c3,c4,c5,c;
long long bs(long long a)
  {long long l=0,r=c-1,m;
  while(l!=r)
    {m=(l+r+1)/2;
    if(bases[m].x<a)l=m;
    else if(bases[m].x>a)r=m-1;
    else return m;}
  return l;}
int main()
  {fn=in;
  fscanf(fn,"%lld",&c);
  for(q1=0;q1<c;q1++)fscanf(fn,"%lld %lld",&bases[q1].x,&bases[q1].pow);
  qsort(bases,c,sizeof(bases[0]),cmp);
  build2(1,0,mx-1);
  for(q1=0;q1<c;q1++)
    update2(1,q1,bases[q1].pow);
  while(1)
    {fscanf(fn,"%lld %lld %lld",&c1,&c2,&c3);
    if(c1==0)break;
    if(c1==1||c1==2)
      types[tc++]=c2;
    ip[ic].type=c1;
    ip[ic].c1=c2;
    ip[ic++].c2=c3;}
  fclose(fn);
  qsort(types,tc,sizeof(types[0]),cmp2);
  c1=1;
  for(q1=1;q1<tc;q1++)
    {c2=types[q1];
    if(c2!=types[c1-1])
      types[c1++]=c2;}
  tc=c1;
//  printf("NEW\n");
  for(q1=tc;q1<mx;q1++)types[q1]=maxx+q1-mx;
  build(1,0,mx-1);
  for(q1=0;q1<ic;q1++)
    {if(ip[q1].type==1)
      update(1,ip[q1].c1,ip[q1].c2);
    if(ip[q1].type==2)
      update(1,ip[q1].c1,-ip[q1].c2);
    if(ip[q1].type==3)
      {c1=bs(ip[q1].c1);
      bases[c1].pow=ip[q1].c2;
      update2(1,c1,ip[q1].c2);}
    if(ip[q1].type==4&&ip[q1].c1==0)
      {c1=find(1,ip[q1].c2-1);
      if(c1<bases[0].x)
        {printf("-1\n");
        continue;}
      c2=bs(c1-1);
      c3=findmin(1,c2);
      printf("%d\n",bases[c3].x);}
    if(ip[q1].type==4&&ip[q1].c1==1)
      {c1=find(1,ip[q1].c2-1);
      if(c1<bases[0].x)
        {printf("-1\n");
        continue;}
      c2=bs(c1-1);
      c3=findmax(1,c2);
      printf("%d\n",bases[c3].x);}
    }
  return 0;}
