/*
TASK: coprime
LANG: C
*/
#include<stdio.h>
#define mx 16384
#define max 16777216
#define ml 16
#define in stdin;//fopen("i:\\tp\\tests\\coprime.in","r")
FILE*fn;
int n,c1,c2,c3;

//////////// number theory ///////////////
int er[mx];
int pr[mx],pc;
int del[ml],dc;
int eratosten(void)
  {int q1,q2;
  for(q1=2;q1<mx;q1++)er[q1]=1;
  for(q1=0;q1*q1<mx;q1++)if(er[q1]==1)
    for(q2=q1*q1;q2<mx;q2+=q1)
      er[q2]=0;
  for(q1=0;q1<mx;q1++)if(er[q1]==1)pr[pc++]=q1;
  return 0;}
int gcd(int a,int b){if(b==0)return a;else return gcd(b,a%b);}
int factorize(int c1)
  {int q1;
  for(q1=0;q1<pc;q1++)
    {if(c1<pr[q1]*pr[q1])break;
    if(c1%pr[q1])continue;
    del[dc++]=pr[q1];
    while(c1%pr[q1]==0)c1/=pr[q1];}
  if(c1!=1)
    del[dc++]=c1;
  return 0;}
//////////////////sol 1/////////////////
int var[ml];
int ans;
int doit(void)
  {int q1,c1,c2;
  c1=1;
  c2=0;
  for(q1=0;q1<dc;q1++)
    {c2+=var[q1];
    if(var[q1])c1*=del[q1];}
  if(c2%2==1)ans+=n/c1;
  else ans-=n/c1;
  return 0;}
int gen(int a)
  {if(a==dc)
    {doit();
    return 0;}
  var[a]=0;
  gen(a+1);
  var[a]=1;
  gen(a+1);
  var[a]=0;
  return 0;}
int sol1(void)
  {ans=0;
  gen(0);
  return -ans;}

/*

/////////////////////sol 2///////////////////
unsigned int table[max];
#define size (sizeof(int)*8)
unsigned int maxint=(unsigned int) (1<<(size-1)) -1+ (1<<(size-1)) ;
int change(int a,int b)
  {if(b==0)
    table[a/size]&=(maxint-(1<<(a%size)));
  if(b==1)
    table[a/size]|=1<<(a%size);
  return 0;}
int view(int a)
  {return (table[a/size]&(1<<(a%size)))!=0;}
int sol2(void)
  {int q1,c1,c2,q2;
  for(q1=0;q1<n;q1++)change(q1,1);
  for(q1=0;q1<dc;q1++)
    for(q2=del[q1];q2<n;q2+=del[q1])
      change(q2,0);
  c1=0;
  for(q1=1;q1<n;q1++)if(view(q1))c1++;
  return c1;}
////////////////////sol 3////////////////
int sol3(void)
  {int q1;
  for(q1=1;q1<n;q1++)if(gcd(q1,n)==1)c1++;
  return c1;}
/////////////////////end////////////

*/

int main()
  {fn=in;
  fscanf(fn,"%d",&n);
  fclose(fn);
//  printf("%u\n",maxint);
  eratosten();
  factorize(n);
 // printf("%d\n%d\n%d\n",sol1(),sol2(),sol3());
  printf("%d\n",sol1());
  return 0;}
