#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#define mx 10
#define inf 1e100
#define eps 1e-10
#define ABS(a) ((a)>0.0?(a):-(a))
#define in fopen("c:\\tp\\tests\\light.in","r")
FILE*fn;
typedef struct {double a,b,c;}lineeq;
typedef struct {double x,y;}point;
typedef struct {point p1,p2;}segment;
int eq(double a,double b)
  {double c1=ABS(a-b);
  if(c1<0.0)c1=-c1;
  if(c1<eps)
    return 1;
  return 0;}
double det22(double a,double b,double c,double d)
  {return a*d-b*c;}
double det2(point a,point b,point c)
  {return det22(b.x-a.x,b.y-a.y,c.x-a.x,c.y-a.y);}
lineeq findeq2(double x1,double y1,double x2,double y2)
  {lineeq e1;
  e1.a=y2-y1;
  e1.b=x1-x2;
  e1.c=y1*x2-y2*x1;
  return e1;}
lineeq findeq(segment a)
  {return findeq2(a.p1.x,a.p1.y,a.p2.x,a.p2.y);}
point findcross(segment e1,segment e2)
  {lineeq p1,p2;
  point e3;
  p1=findeq(e1);
  p2=findeq(e2);
  if(eq(p1.a*p2.b,p1.b*p2.a))
    {e3.x=e3.y=inf;
    return e3;}
  e3.y=(p2.a*p1.c-p2.c*p1.a)/(p2.b*p1.a-p2.a*p1.b);
  e3.x=(-p1.c-p1.b*e3.y)/p1.a;
  return e3;}
int cross(segment a,segment b)
  {double c1,c2,c3,c4;
  c1=det2(a.p1,a.p2,b.p1);
  c2=det2(a.p1,a.p2,b.p2);
  c3=det2(b.p1,b.p2,a.p1);
  c4=det2(b.p1,b.p2,a.p2);
  if(c1*c2<=0.0)return 1;
  return 0;}
double dist2(point a,point b)
  {return hypot(a.x-b.x,b.y-a.y);}
///////////////////////////////////////
int cmp(const void*a,const void*b)
  {if(((point*)a)->x>((point*)b)->x)return 1;else return -1;}
int c,cc,q1,q2,q3,c1,c2,c3,c5,m,n,c4;
double h,v1,v2,v3;
point ss[mx*mx];
point all[mx*mx];
int ok[mx*mx];
int used[mx];
point s[mx];
point l[mx];
segment e1,e2,e3;
point p1,p2,p3;
int main()
  {fn=in;
  fscanf(fn,"%d",&c);
  for(q1=0;q1<c;q1++)fscanf(fn,"%lf %lf",&s[q1].x,&s[q1].y);
  fscanf(fn,"%d %lf",&m,&h);
  for(q1=0;q1<m;q1++)fscanf(fn,"%lf",&l[q1].x);
  for(q1=0;q1<m;q1++)l[q1].y=h;
  fclose(fn);
  for(q1=0;q1<c;q1++)for(q2=0;q2<m;q2++)
    {e1.p1=s[q1];
    e1.p2=l[q2];
    for(q3=0;q3<c-1;q3++)
      {e2.p1=s[q3];
      e2.p2=s[q3+1];
      if(cross(e1,e2))
        {p1=findcross(e1,e2);
        if(p1.x>sqrt(inf))continue;
        v1=dist2(e1.p1,p1);
        v2=dist2(p1,e1.p2);
        v3=dist2(e1.p1,e1.p2);
        if(v1>eps&&v2>eps&&eq(v1+v2,v3))
          continue;
        ss[cc++]=p1;}}}
  qsort(ss,cc,sizeof(ss[0]),cmp);
  c1=1;
  for(q1=1;q1<cc;q1++)
    if(eq(ss[q1].x,ss[q1-1].x)==0)
      ss[c1++]=ss[q1];
  cc=c1;
  for(q1=0;q1<cc-1;q1++)
    {p1.x=(ss[q1].x+ss[q1+1].x)/2.0;
    p1.y=(ss[q1].y+ss[q1+1].y)/2.0;
    v1=-M_PI/2.0+eps;
    v2=M_PI/2.0-eps;
    for(q2=0;q2<c;q2++)
      {v3=atan2(s[q2].x-p1.x,s[q2].y-p1.y);
      if(v3>0.0)
        {if(v3<v2)v2=v3;}
      else
        {if(v3>v1)v1=v3;}}
    p2.x=p1.x+(h-p1.y)*tan(v1);
    p2.y=p1.x+(h-p1.y)*tan(v2);
    all[q1]=p2;}
  qsort(all,cc-1,sizeof(all[0]),cmp);
  for(q1=0;q1<cc;q1++)if(!ok[q1])
    {for(q2=m-1;q2>=0;q2--)if(!used[q2])if(l[q2].x>all[q1].x&&l[q2].x<all[q1].y)break;
    used[q2]=1;
    c4=q2;
    for(q2=0;q2<cc;q2++)if(l[c4].x>all[q2].x&&l[c4].x<all[q2].y)ok[q2]=1;}
  c1=0;
  for(q1=0;q1<m;q1++)c1+=used[q1];
  printf("%d\n",c1);
  for(q1=0;q1<m;q1++)if(used[q1])printf("%d ",q1+1);
  printf("\n");

  return 0;}