#include<cstdio>
#include<time.h>
#include<vector>
#include<algorithm>
using namespace std;
#define in stdin;//fopen("c:\\tp\\tests\\trip\\trip.g1.in","r")
#define maxx 2000000000
#define p(a) (((a)^(a-1))&(a))
FILE*fn;
struct bus
  {int a,b,c,d,from,to,n,id,w;
  bus(){a=b=c=d=from=to=n=id=w=0;}
  bus(int aa,int bb,int cc,int dd,int ee,int ff,int gg,int hh,int jj)
    {a=aa;b=bb;c=cc;d=dd;from=ee;to=ff;n=gg;id=hh;w=jj;}
  };
struct tree
  {vector<int> ss;
  vector<int> who;
  
  tree(int a)
    {int c1=1,q1;
    while(a){a/=2;c1=c1*2;}
    ss.resize(c1+1);
    who.resize(c1+1);
    for(q1=0;q1<ss.size();q1++)
      {ss[q1]=maxx;
      who[q1]=1;}}

  int update(int a,int b,int c)
    {while(a<ss.size())
      {if(ss[a]>b){ss[a]=b;who[a]=c;}
      a+=p(a);}
    return 0;}
    
  int query(int a)
    {int c1=maxx,b=-1;
    while(a)
      {if(c1>ss[a]){c1=ss[a];b=who[a];}
      a-=p(a);}
    return b;}
  };
///////////////////////////
bool operator<(bus a,bus b){return a.d<b.d;}

/*struct comp : public binary_function<bus,bus,bool>
  {bool operator() (const bus &a, const bus &b)
    {return a.d<b.d;};};*/
bool cmp(const bus &a, const bus &b)
  {
  return a < b;
  }



vector < vector < bus > > arr;
vector < bus > all;
vector < tree > tr;
int c,m,t,p;

  int pp[110000];
  int ip[110000];

int main()
  {clock();
  fn=in;
  fscanf(fn,"%d %d %d %d",&c,&m,&p,&t);
  for(int q1=0;q1<m;q1++)
    {bus e1;
    fscanf(fn,"%d %d %d %d %d %d\n",&e1.from,&e1.to,&e1.a,&e1.b,&e1.c,&e1.d);
    e1.from--;
    e1.to--;
    all.push_back(e1);}
  fclose(fn);
  printf("%lf\n",(double)clock()/CLOCKS_PER_SEC);
  all.push_back(bus(0,0,0,0,0,0,0,0,0));
  sort(all.begin(),all.end());
  
  arr.resize(c);
  printf("%lf\n",(double)clock()/CLOCKS_PER_SEC);


  for(int q1=0;q1<all.size();q1++)pp[all[q1].to]++;
  for(int q1=0;q1<c;q1++)arr[q1].resize(pp[q1]);

  for(int q1=0;q1<all.size();q1++)
    {all[q1].id=q1;
    all[q1].n=ip[all[q1].to];
 //   arr[all[q1].to].push_back(all[q1]);
    arr[all[q1].to][ip[all[q1].to]++]=all[q1];
    }


  printf("%lf\n",(double)clock()/CLOCKS_PER_SEC);  
  for(int q1=0;q1<arr.size();q1++)
    tr.push_back(tree(arr[q1].size()));
  printf("%lf\n",(double)clock()/CLOCKS_PER_SEC);
  tr[0].update(0+1,0,0);

  printf("%lf\n",(double)clock()/CLOCKS_PER_SEC);
  for(int q1=1;q1<=m;q1++)
    {bus e1=all[q1];
    bus e2;
    vector < bus > :: iterator e3;
    e2.d=e1.a;
    e3=upper_bound(arr[e1.from].begin(),arr[e1.from].end(),e2,cmp);
    if(e3==arr[e1.from].begin())continue;

    
    int c1,c2,c3;
    if(e3==arr[e1.from].end())c1=arr[e1.from].size();
    else c1=e3->n;
    if(c1==0)continue;
    c2=tr[e1.from].query(c1);

    e2=e1;
    e2.w=arr[e1.from][c2].w+e2.b-arr[e1.from][c2].c;
    arr[e1.to][e1.n].w=e2.w;
    
    tr[e2.to].update(e2.n+1,e2.w-e2.c,e2.n);

    }
  printf("%lf\n",(double)clock()/CLOCKS_PER_SEC);
  p--;
  int c1=maxx;
  int c2=maxx;
  int q1;
  for(q1=arr[p].size()-1;q1>=0;q1--)if(arr[p][q1].d<=t)break;
  if(q1==-1)
    {printf("-1\n");
    return 0;}
  c1=tr[p].query(q1+1);
  
  for(int q1=c1;q1<=c1;q1++)if(q1!=-1)
    {if(arr[p][q1].d<=t)
      {c2=arr[p][q1].w+t-arr[p][q1].c;
    //  if(c2<c1)c1=c2;
      }
    }
  if(c2==maxx)c2=-1;
  printf("%d\n",c2);
  printf("%lf\n",(double)clock()/CLOCKS_PER_SEC);
  return 0;}
