#include<stdio.h>
#include<vector>
#include<algorithm>
using namespace std;

#define mx 32768

int c1,c2,q1,c3,c,c4,c5,q2;

vector < int > ss,s,s1,ss1,real,line;

typedef struct {int m,l,r,ss;}node;

node h[2*mx];

int build(int where,int l,int r)
  {
  h[where].l=l;
  h[where].r=r;
  h[where].m=(l+r)/2;
  h[where].ss=0;
  if(where>=mx)return 0;
  build(where*2,l,h[where].m);
  build(where*2+1,h[where].m+1,r);
  return 0;}

int find(int where,int k)
  {
 // printf("%d %d\n",where,k);
  if(where>=mx)
    return where-mx;
  if(h[where*2].ss<=k)
    return find(where*2+1,k-h[where*2].ss);
  else 
    return find(where*2,k);
  return 0;
  }

int update(int where,int k)
  {
  h[where].ss++;
  if(where>=mx)
    return 0;
  if(k<=h[where].m)
    return update(where*2,k);
  else 
    return update(where*2+1,k);
  return 0;
  }

int main()
  {
  line.resize(mx);
  ss=s=s1=ss1=real=line;
  
  while(scanf("%d",&c1)==1)ss[c++]=c1;
  
  for(q1=0;q1<c;q1++)s[q1]=ss[q1];
  sort(&(s[0]),&(s[c]));  
  
  s1[0]=0;
  
  for(q1=1;q1<c;q1++)if(s[q1]==s[q1-1])s1[q1]=s1[q1-1];else s1[q1]=s1[q1-1]+1;
  for(q1=0;q1<c;q1++)ss1[s1[q1]]=s[q1];
  
  for(q1=0;q1<c;q1++)
    real[q1]=s1[lower_bound(&(s[0]),&(s[c]),ss[q1]) - &(s[0])];
  
  build(1,0,mx-1);
  
  for(q1=0;q1<c;q1++)
    {
    update(1,real[q1]);
    line[real[q1]]++;
    
    c1=find(1,q1/2);
    c2=find(1,(q1+1)/2);
    
    printf("%d\n",(ss1[c1]+ss1[c2])/2);
    }
 

  return 0;}