#include<stdio.h>
#include<stdlib.h>
#define mx 131072
#define MAX(aa,bb) ((aa).b>(bb).b?(aa):(bb))
#define MIN(aa,bb) ((aa).a<(bb).a?(aa):(bb))
#define in stdin;//fopen("c:\\tp\\tests\\aut\\aut3.in","r")
FILE*fn;
typedef struct {int a,b,n;}aut;
typedef struct {int l,m,r;aut ans;}node;
node h1[mx*2];
node h2[mx*2];

int build(int where,int l,int r,node*h,int ans)
  {h[where].l=l;
  h[where].r=r;
  h[where].m=(l+r)/2;
  if(ans==0){h[where].ans.a=where-mx;h[where].ans.b=ans;}
  if(ans==mx){h[where].ans.b=where-mx;h[where].ans.a=ans;}
  if(where>=mx)return 0;
  build(where*2,l,h[where].m,h,ans);
  build(where*2+1,h[where].m+1,r,h,ans);
  return 0;}

aut find1(int where,int l,int r,node*h)
  {if(h[where].r==r&&h[where].l==l)return h[where].ans;
  if(r<=h[where].m)return find1(where*2,l,r,h);
  if(l>h[where].m)return find1(where*2+1,l,r,h);
  return MAX( find1(where*2,l,h[where].m,h), find1(where*2+1,h[where].m+1,r,h));}

aut find2(int where,int l,int r,node*h)
  {if(h[where].r==r&&h[where].l==l)return h[where].ans;
  if(r<=h[where].m)return find2(where*2,l,r,h);
  if(l>h[where].m)return find2(where*2+1,l,r,h);
  return MIN( find2(where*2,l,h[where].m,h), find2(where*2+1,h[where].m+1,r,h));}

int update1(int where,aut n,node*h)
  {if(where>=mx)
    {h[where].ans=n;
    return 0;}
  if(n.a<=h[where].m)update1(where*2,n,h);
  else update1(where*2+1,n,h);
  h[where].ans=MAX(h[where*2].ans,h[where*2+1].ans);
  return 0;}

int update2(int where,aut n,node*h)
  {if(where>=mx)
    {h[where].ans=n;
    return 0;}
  if(n.b<=h[where].m)update2(where*2,n,h);
  else update2(where*2+1,n,h);
  h[where].ans=MIN(h[where*2].ans,h[where*2+1].ans);
  return 0;}

int cmp(const void*a,const void*b)
  {if(((aut*)a)->a==((aut*)b)->a)return ((aut*)a)->b-((aut*)b)->b;
  return ((aut*)a)->a-((aut*)b)->a;}
int cmp2(const void*a,const void*b)
  {if(((aut*)a)->b==((aut*)b)->b)return ((aut*)a)->a-((aut*)b)->a;
  return ((aut*)a)->b-((aut*)b)->b;}
int cmp3(const void*a,const void*b)
  {return *((int*)a)-*((int*)b);}

aut ss[mx];
aut s1[mx];
int c;
int t[mx];
int v[mx];
int aa[mx],ab[mx],ac;

int find(aut e2)
  {aut e1;
  int c1,a,b;
  a=e2.a;b=e2.b;
  if(a>b){c1=a;a=b;b=c1;}
  e1.a=a;
  e1.b=b;
  c1=(int)bsearch(&e1,ss,c,sizeof(ss[0]),cmp)-(int)ss;
  c1/=sizeof(aut);
  return c1;}

int q[mx],qin,qou;

int map[mx];

aut e1,e2,e3;
int q1,q2,q3,c1,c2,c3;
int main()
  {fn=in;
  fscanf(fn,"%d %d",&c1,&c);
  for(q1=0;q1<c;q1++)fscanf(fn,"%d %d",&ss[q1].a,&ss[q1].b);
  for(q1=0;q1<c;q1++){ss[q1].n=q1;s1[q1]=ss[q1];}
  fclose(fn);

  qsort(ss,c,sizeof(ss[0]),cmp);

  for(q1=0;q1<c;q1++){ss[q1].a*=c+2;ss[q1].b*=c+2;}

  for(q1=0;q1<c;q1++)
    {
    for(q2=q1;q2<c&&ss[q2].a==ss[q1].a;q2++);
    c2=q2;
    for(q2=q1;q2<c2;q2++)ss[q2].a+=c2-q2-1;
    }

  qsort(ss,c,sizeof(ss[0]),cmp2);

  for(q1=0;q1<c;q1++)
    {
    for(q2=q1;q2<c&&ss[q2].b==ss[q1].b;q2++);
    c2=q2;
    for(q2=q1;q2<c2;q2++)ss[q2].b-=q2-q1;
    }
  qsort(ss,c,sizeof(ss[0]),cmp);
  for(q1=0;q1<c;q1++){aa[ac++]=ss[q1].a;aa[ac++]=ss[q1].b;}
  qsort(aa,ac,sizeof(aa[0]),cmp3);


  for(q1=0;q1<c;q1++)
    {c1=(int)bsearch(&ss[q1].a,aa,ac,sizeof(aa[0]),cmp3)-(int)aa;
    c1/=sizeof(int);
    ss[q1].a=c1+1;
    c1=(int)bsearch(&ss[q1].b,aa,ac,sizeof(aa[0]),cmp3)-(int)aa;
    c1/=sizeof(int);
    ss[q1].b=c1+1;}

  for(q1=0;q1<c;q1++)
    {
//    printf("%d %d - %d %d %d\n",ss[q1].a,ss[q1].b,s1[ss[q1].n].a,s1[ss[q1].n].b,ss[q1].n);

    q1=q1;}



  build(1,0,mx-1,h1,0);
  build(1,0,mx-1,h2,mx);

  for(q1=0;q1<c;q1++)
    {update1(1,ss[q1],h1);
    update2(1,ss[q1],h2);}



  for(q1=0;q1<c;q1++)if(t[q1]==0)
  {
  e2.a=ss[q1].a;e2.b=0;update1(1,e2,h1);
  e2.b=ss[q1].b;e2.a=mx;update2(1,e2,h2);


  qin=qou=0;
  t[q1]=1;
  q[qin++]=q1;

  while(qin!=qou)
    {c1=q[qou++];
    while(ss[c1].a+1!=ss[c1].b)
      {e1=find1(1,ss[c1].a+1,ss[c1].b-1,h1);
      if(e1.b==0||e1.b<=ss[c1].b)break;
      c2=find(e1);
      t[c2]=3-t[c1];

      e2.a=ss[c2].a;e2.b=0;update1(1,e2,h1);
      e2.b=ss[c2].b;e2.a=mx;update2(1,e2,h2);

      q[qin++]=c2;}

    while(ss[c1].a+1!=ss[c1].b)
      {e1=find2(1,ss[c1].a+1,ss[c1].b-1,h2);
      if(e1.a==mx||e1.a>=ss[c1].a)break;
      c2=find(e1);
      t[c2]=3-t[c1];

      e2.a=ss[c2].a;e2.b=0;update1(1,e2,h1);
      e2.b=ss[c2].b;e2.a=mx;update2(1,e2,h2);

      q[qin++]=c2;}
    }
  }

  for(q1=0;q1<c;q1++)
    v[ss[q1].n]=t[q1];

  for(q1=0;q1<c;q1++)if(v[q1]==1)printf("N\n");else printf("S\n");


    for(q1=0;q1<c;q1++)for(q2=0;q2<c;q2++)if(q1!=q2)if(v[q1]==v[q2])
        if(s1[q1].a<s1[q2].a&&s1[q1].b>s1[q2].a&&s1[q1].b<s1[q2].b)
              printf("error %d %d\n",q1,q2);
  return 0;}
