/*
Purvo ste preobrazuvame dadenata rediva v edna permutacia na chislata ot 1 do N
tui kato chislata za vinagi razlichni tova e vinagi vyzmoshno. Na nai malkia
element se sypostavia 1 na sledvastia 2 i t.n.

Zadachata lesno se svezhda do namirane na broia na inversiite v permutaciata
Purvo triabva da otbelezhim che ste razmeniame sysedni elementi samo ako
levia e po goliam ot desnia.

permutaciata 1 2 3 4.........N ima 0 inversii i susto taka ni triabvat 0 raz-
meni na sysedni elementi za da ia sortirame. Pri edna razmiana na sysedni ele-
menti tochno edna inversia izchezva. Inversiata (zastoto takava sme se uveri-
li che ima - inache niamashe da razmeniame elementite) meshdu dvata elementa
izchezva i nikoia druga zastoto razpoloshenieto na tezi dva elementa spriamo
drugite se zapazva.

Sledovatelno na vsiaka stypka namaliavame broia na inversiite sys 1 i  ste ni
triabvat tochno tolkova razmeni na sysedni elementi, tyi kato premutaciata
1,2,3,4........N kum koiato se stremim ima 0 inversii.

S po malko ne moshem zastoto ne moshem i poveche ot edna inversia na hod da
neutralizirame. A vinagi moshem da namerim dva elementa koito da sa sysedni
i da sa vyv inversia inache stiahme da sme v permutaciata 1 2 3 4 5 .....N

Broia na inversiite v permutacia se namira sys izpolzvaneto na indexno dyrvo
Tova dyrvo ni kazva s logaritmichna sloshnost kolko elementa ima ot 1 do X.
systo taka dobavia element sys systata sloshnost.

Programata mi chete ot standartnia vhod kato purvo prochita broia na elementite
sle tova samite tiah kato niama znachenie novite redove.

Pechata otgovora na standartnia izhod.
Programata mi raboti do 1 milion elementa no moshe i da se promeni
chrez konstantata mx koiato triabva vinagi da e stepen na 2+1 - t.e. da ima
vida 2^n+1

Sloshnotta na algorituma mi e O(N*logN) tui kato programata mi se systoi ot 3
chasti vsiaka sys shoshnost O(N*logN)
1-sortiraneto
2-dvoichnoto tyrsene za syzdavane na permutaciata
3-indexnoto dyrvo

Ne moga da dokasha che moito reshenie e optimalno, no si mislia che po byrzo
ne moshe da stane dadenata zadacha.

Svetoslav Kolev
11 klas AG "Geo Milev" Rousse
*/
#include<stdio.h>
#include<stdlib.h>
#define mx 1048577
#define in stdin;//fopen("i:\\tp\\tests\\perm.in","r")
FILE*fn;
////////
int i1[mx],i2[mx];

////////
int c,q1,c1;
int p[mx];
int ss[mx];
int s[mx];
int update(int a)
  {while(a<=mx)
    {ss[a]++;
    a+=p[a];}
  return 0;}
int find(int a)
  {int c1=0;
  while(a)
    {c1+=ss[a];
    a-=p[a];}
  return c1;}
int cmp(const void*a,const void*b)
  {return *((int*)a)-*((int*)b);}
int main()
  {fn=in;
  fscanf(fn,"%d",&c);
  for(q1=0;q1<c;q1++)fscanf(fn,"%d",i1+q1);
  for(q1=0;q1<c;q1++)i2[q1]=i1[q1];
  qsort(i2,c,sizeof(i2[0]),cmp);
  for(q1=0;q1<c;q1++)s[q1]=(int)((int*)bsearch((const void*)(&i1[q1]),i2,c,sizeof(i2[0]),cmp)-(int*)i2)+1;
  fclose(fn);
  for(q1=1;q1<mx;q1++)p[q1]=q1%2?1:p[q1/2]*2;
  for(q1=0;q1<c;q1++)
    {c1+=find(s[q1]);
    update(s[q1]);}
  printf("%d\n",c*(c-1)/2-c1);
  return 0;}
