#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>
#define X 64
#define Y 64
#define ui unsigned int
#define arc (sizeof(ui)*8)
#define maxgentosave 327680
#define l ((X*Y+arc-1)/arc)
#define init(a) memset(&(a),0,sizeof((a)))

typedef struct {ui ss[l];} state;

int x,y,n,area;
int Born[16],Die[16],Stay[16];
int born[256],die[256],stay[256];
int neic[X*Y];
ui nei[X*Y][8];
ui mask[X*Y][8];
ui maskf[X*Y][8];

char file[1000];
char name[1000];
int maxgen;
state save[maxgentosave];
state start,e1,e2,final;

int doand(state*a,state*b,state*c)
  {
  int q1,c1,c2=0;
  for(q1=0;q1<l;q1++)c->ss[q1]=a->ss[q1]&b->ss[q1];
  for(q1=0;q1<l;q1++){c1=c->ss[q1];for(;c1;c2++)c1&=c1-1;}
  return c2;
  }
int doxor(state*a,state*b,state*c)
  {
  int q1,c1,c2=0;
  for(q1=0;q1<l;q1++)c->ss[q1]=a->ss[q1]^b->ss[q1];
  for(q1=0;q1<l;q1++){c1=c->ss[q1];for(;c1;c2++)c1&=c1-1;}
  return c2;
  }
  
int print(state*a)
  {
  int q1,q2;
  for(q1=0;q1<x;q1++)
    {
    for(q2=0;q2<y;q2++)
      printf("%d",(a->ss[(q1*y+q2)/arc]&(1<<((q1*y+q2)%arc)))/(1<<((q1*y+q2)%arc)));
    printf("\n");
    }
  printf("\n");
  return 0;}
state allone;
int next(state*a,state*b,state*d1)
  {
  register int q1,q2;
  register ui c1,c2,c3;
  state t2;
  init(*b);
  for(q1=0;q1<area;q1++)if(d1->ss[q1/arc]&(1<<(q1%arc)))
    {
    c1=neic[q1];
    c3=0;
    for(q2=0;q2<c1;q2++)
      {
      c2=(a->ss[nei[q1][q2]])&mask[q1][q2];
      for(;c2;c3++)c2&=c2-1;
      }
      
    if(a->ss[q1/arc]&(1<<(q1%arc))){if(Stay[c3])b->ss[q1/arc]|=(1<<(q1%arc));}
    else {if(Born[c3])b->ss[q1/arc]|=(1<<(q1%arc));}
    }
  else b->ss[q1/arc]|=a->ss[q1/arc]&(1<<(q1%arc));
  doxor(a,b,&t2);
 // print(&t2);
  init(*d1);
  for(q1=0;q1<area;q1++)if(t2.ss[q1/arc]&(1<<(q1%arc)))
    {
    c1=neic[q1];
    for(q2=0;q2<c1;q2++)
      d1->ss[nei[q1][q2]]|=maskf[q1][q2];
    }
  //print(d1);  
  *d1=allone;
  return 0;}



int simulate(int f)
  {
  int q1;
  state *p1,*p2,*p3,t1,t2;
  e1=start;
  p1=&e1;
  p2=&e2;
  
//  system("cls");  print(p1);
  t2=allone;
  
  for(q1=0;q1<f;q1++)
    {
    if(q1<maxgen)save[q1]=*p1;
    next(p1,p2,&t2);
   // if(q1%72==0){system("cls");print(p2);printf("%d    %d %d   %.3lf\n",q1,doxor(p1,p2,&t1),area,(double)doand(p1,p2,&t1)/area);system("pause");}
    p3=p2;p2=p1;p1=p3;
    }
  return 0;}



int precompute(void)
  {
  int q1,q2,q3,q4,x1,y1,x2,y2;
  ui c1,c2,c3,c4;
  state e1,e2;
  for(q1=0;q1<l;q1++)allone.ss[q1]=0xFFFFFFFFu;
  for(q1=0;q1<256;q1++)
    {
    c1=0;
    c2=q1;
    while(c2){c1+=c2%2;c2/=2;}
    if(Born[c1])born[q1]=1;
    if(Die[c1])die[q1]=1;
    if(Stay[c1])stay[q1]=1;
    }
  for(q1=0;q1<x*y;q1++)
    {
    x1=q1/y;
    y1=q1%y;
    init(e1);
    for(q2=-1;q2<=1;q2++)for(q3=-1;q3<=1;q3++)if(q2||q3)
      {
      x2=(x1+q2+x)%x;
      y2=(y1+q3+y)%y;
      c1=x2*y+y2;
      e1.ss[c1/arc]|=1<<(c1%arc);
      }
    for(q2=0;q2<l;q2++)if(e1.ss[q2])
      {
      nei[q1][neic[q1]]=q2;
      mask[q1][neic[q1]++]=e1.ss[q2];
      }
    e1.ss[q1/arc]|=1<<(q1%arc);
    neic[q1]=0;
    for(q2=0;q2<l;q2++)if(e1.ss[q2])maskf[q1][neic[q1]++]=e1.ss[q2];
    }
  return 0;}
  
  
state getrandom(void)
  {
  state e1;
  int q1;
  init(e1);
  for(q1=0;q1<x*y;q1++)e1.ss[q1/arc]|=(1<<(q1%arc))*(rand()%2);
  return e1;
  }

int readinput(void)
  {
  FILE*fn;
  fn=fopen("c:\\edu\\02\\in.txt","r");
  fscanf(fn,"%d %d",&x,&y);
  state e1;
  init(e1);
  int q1,q2;
  for(q1=0;q1<x;q1++)
    {
    char d[1000];
    fscanf(fn,"%s",d);
    for(q2=0;q2<y;q2++)e1.ss[(q1*y+q2)/arc]|=(1<<(q1*y+q2))*(d[q2]-48);
    }
  fclose(fn);
  Born[3]=1;
  Stay[2]=Stay[3]=1;
  n=1330;
 // x=y=64; area=x*y;start=getrandom();
  start=e1;
  area=x*y;
  return 0;}

int read2(int argc, char ** argv)
  {
  if(argc<5)
    {
    printf("USAGE: GOL <file> <bornRule> <dieRule> <max generations>\n");
    exit(0);
    return 0;
    }
  int q1,q2;
  strcpy(file,argv[1]);
  char d[100];
  strcpy(d,argv[2]);
  for(q1=0;d[q1];q1++)Born[d[q1]-48]=1;
  strcpy(d,argv[3]);
  for(q1=0;d[q1];q1++)Die[d[q1]-48]=1;
  for(q1=0;q1<9;q1++)Stay[q1]=1-Die[q1];
  strcpy(d,argv[4]);
  sscanf(d,"%d",&maxgen);
  n=maxgen+32;
  FILE*fn;
  fn=fopen(file,"r");
  fscanf(fn,"%s",name);
  fscanf(fn,"%d %d",&y,&x);
  area=x*y;
  init(start);
  for(q1=0;q1<x;q1++)for(q2=0;q2<y;q2++)
    {
    int c1,c2=q1*y+q2;
    fscanf(fn,"%d",&c1);
    start.ss[c2/arc]|=(1<<(c2%arc))*c1;
    }
 /* for(q1=0;q1<x;q1++)
    {
    char d1[10000];
    fscanf(fn,"%s",d1);
    for(q2=0;q2<y;q2++)
      {
      int c1,c2=q1*y+q2;
      c1=d1[q2]-48;
      start.ss[c2/arc]|=(1<<(c2%arc))*c1;
      }
    }*/

 // print(&start);
  fclose(fn);
  return 0;}

int output2(state*a,int b)
  {
  char filename[1100];
  strcpy(filename,file);
  sprintf(filename+strlen(filename)-4,"%d.pbm",b);
  FILE*fn=fopen(filename,"w");
  fprintf(fn,"%s %d %d ## Generation %d of Conway's Game of Life by cs61c-io\n",name,x,y,b);
  int q1,q2;
  for(q1=0;q1<x;q1++)
    {
    for(q2=0;q2<y;q2++)
      {
      int c1=q1*y+q2;
      if(a->ss[c1/arc]&(1<<(c1%arc)))fprintf(fn,"1");
      else fprintf(fn,"0");
      if(q2!=y)fprintf(fn," ");
      }
    fprintf(fn,"\n");}
  fclose(fn);
  return 0;}

int main(int argc,char** argv)
  {
  read2(argc,argv);
  clock();
  //readinput();
  //////////////////////////////////
  precompute();
  simulate(n);
 // printf("%lf\n",(double)clock()/CLOCKS_PER_SEC);
  int q1;
  for(q1=0;q1<=maxgen;q1++)output2(save+q1,q1);
  return 0;}
