(/ (+ 5 4 (- 2 (- 3 (+ 6 4/3)))) (* 3 (- 6 2) (- 2 7 )))

(define (two_larger a b c) 
   (cond ((and (<= a b) (<= a c)) (+ (* b b) (* c c)))
         ((and (<= b c) (<= b a)) (+ (* a a) (* c c)))
         ((and (<= c b) (<= c a)) (+ (* b b) (* a a)))
         (else -1)))

(define (aplusmodulb a b)
  ((if (> b 0) + -) a b))

(define (abs a)
  (if (< a 0) (- a) a))

(define (good a b) 
  (if (< (abs (- (* a a) b)) 0.000000001) #t #f ))

(define (avg a b) (/ (+ a b) 2.0))

(define (update a b) ( avg a (/ b a)))

(define (good2 a b)
  (if (< (abs (- 1 (/ a (update a b)))) 0.000000001) 
      #t 
      #f))

(define (sqr2 a b) 
  (if (good2 a b) 
      a 
      (sqr2 ( update a b) b)))

(define ( sqrt a ) ( sqr2 1 a) )



(define (update3 a b) 
  (/ (+ (/ b (* a a)) (* 2.0 a)) 3.0 ))

(define (good3 a b)
  (if (< (abs (- 1 (/ a (update3 a b)))) 0.0000001) 
      #t 
      #f))

(define (cbr2 a b)
  (if (good3 a b)
      a
      (cbr2 ( update3 a b) b)))

(define (cbrt a) (cbr2 1 a))

(define (cbr b) 
  (define (update3 a) 
     (/ (+ (/ b (* a a)) (* 2 a)) 3 ))
  (define (good3 a)
     (if (< (abs (- 1 (/ a (update3 a)))) 0.00000001) 
        #t 
        #f))
  (define (cbr2 a)
     (if (good3 a)
         a
         (cbr2 ( update3 a) )))
  (cbr2 1.0))
