/*
Zadachata e da se opredeli nai-golemiat pravoygylnik systaven samo ot '1' v
dadeniya pravoygylnik MxN:

		1101001011
		1010101111
		1110110111
		0011111111
		1111110111
		0111111111
		1111010110
		1111101111

Nai-elementarnoto reshenie e da se probvat vsichki pravoygylnici koeto obache
ima sloshnost M^3xN^3 i koeto e mnogo goliamo. Systesvuvat redica podobrenia
kato naprimer namaliava se broia na pravoygylnicite, koito razgleshdame -
koito tyrsim dali sa ednorodni. Drugo podobrenie e skorostta s koiato prove-
riavame dali daaden pravoygylnik e samo ot '1'. Taka se stiga do slednia al-
goritym koito e s minimalna sloshnost - MxN - i pamet M ili N.
  Izpolzva se stek, koito sydyrsha pravoygylnici zadadeni s debelinata
  (razlikata v y-cite na varhovete)si i x-koordinata na nachalnia si vrah.
  Razgleshdame vseki red po otdelno i napylno samostoiatelno. Pochvame ot nai
dolnia i prodylshavame nagore. Za vseki red pravim edin spisyk koito pokazva
za vsiaka kletka ot reda kolko kvadratcheta triabva da slezem nadolu za da
stignem 0. Ako stoinostta na kletkata e 0 togava istoinostta j v tozi spisyk
- ss[] - systo e 0. Da vzemem za primer red 4.

ss[] za nego izgleshda taka : {1,4,4,4,2,3,0,4,4,2}
Sega razgleshdame poletata ot liavo nadiasno.

Pyrvoto pole e '1'. Tui kato vse oste niamame pravoygylnici v steka to slagame
tozi koito ima goren liav ugul poleto v koeto sme v momenta. Za debelina
slagame syotvetnata stoinost ot ss[]. Za x koordinata slagame syotvetnia X na
koito sme v momenta - nomera na kvadratcheto v reda.

Stek(na debelinata): 1
stek(na x-koor.)   : 1

Vtoroto pole pak e '1'. Samo che tuk ss[] e 4. Pravougulnikyt koiot sloshihme
moshem da go prodylshim zastoto imame poveche '1'nadolu ot predi i => toi moshe
da se razshiri s edno kvadratche nadiasno. Tui kato ss[] e 4 togava slagame
i tozi pravougulnik.

Stek(debel.) : 1    4
stek(x-koor) : 1    2

Preminavame kym 3-tot pole

*/
#include<stdio.h>
#define mx 13
FILE*fn;
int ss[mx];
int stw[mx],sty[mx];
int st;
int s[mx];
int q1,q2,x,y,ww,yy,w;
int best,x1,y1,x2,y2;
int ats(int y,int w){stw[++st]=w;sty[st]=y;return 0;}
int gfs(int&y,int&w){y=sty[st];w=stw[st];stw[st]=sty[st]=0;st--;return 0;}
int main()
  {fn=fopen("c:\\tp\\tests\\rect.in","r");
  fscanf(fn,"%d %d",&y,&x);
  for(q1=0;q1<mx;q1++){stw[q1]=sty[q1]=ss[q1]=0;}
  st=-1;
  for(q1=0;q1<x;q1++)
    {for(q2=0;q2<y;q2++)fscanf(fn,"%d",&s[q2]);
    for(q2=0;q2<y;q2++)s[q2]=1-s[q2];
    for(q2=0;q2<y;q2++)if(s[q2])ss[q2]++;else ss[q2]=0;
    w=0;
    for(q2=0;q2<y;q2++)
      {if(ss[q2]>w)
	{w=ss[q2];
	ats(q2,w);}
      if(ss[q2]<w)
	{while((stw[st]>ss[q2])&&(st+1))
	  {gfs(yy,ww);
	  w=ww;
	  if((q2-yy)*ww>best)
	    {best=(q2-yy)*ww;x1=q1-w+1;y1=yy;x2=q1;y2=q2-1;}}
	w=ss[q2];
	if(w)ats(yy,w);}}}
  fclose(fn);
  printf("%d %d %d %d %d\n",best,x1,y1,x2,y2);
  return 0;}