#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<sstream>
#include<iostream>
#include<vector>
#include<map>
#include<string>
#include<algorithm>
using namespace std;

#define VI vector < int >
#define VVI vector < vector < int > >
#define VS vector < string >
#define pb push_back
#define cs c_str()
#define sz size()
/////////////////////////
#define mx 10000
#define eps 0.0000000001
struct edge{int to;double p;};
int ns[mx],c,cc=0;
edge nei[mx][16];
vector <double> able;
map < VI , int > encode;
map < int, VI > decode;
double calc(VI a,int wh)
  {double c1=1.0,c2;
  int q1;
  for(q1=1;q1<=wh;q1++)
    {c2=able[a[q1]]/(able[a[0]]+able[a[q1]]);
    c1=c1*(1.0-c2*c2);}
  if(wh!=c-1)
    {c2=able[a[wh+1]]/(able[a[0]]+able[a[wh+1]]);
    c1=c1*c2*c2;}
  return c1;}
double res=0.0;
double mem[mx][256];
int vis[mx][256];
int best;
double dfs(int a,int lev,double cur)
  {int q1;
  double c1,c2=0.0,c3;
  if(a==-1)
    {
    return 1.0;}
  if(a==-2)return 0.0;
  if(vis[a][lev])return mem[a][lev];
  vis[a][lev]=1;
  if(lev>250)return 0.0;
  for(q1=0;q1<ns[a];q1++)
    {
    c1=dfs(nei[a][q1].to,lev+1,cur*nei[a][q1].p);
    c2+=c1*nei[a][q1].p;}
  mem[a][lev]=c2;
  return mem[a][lev];}
class KingOfTheCourt
{public:
double chancesOfWinning(vector <int> ability)
  {encode.empty();
  decode.empty();
  VI perm;
  int q1,q2,q3,c1,c2;
  double c3,c4;
  c=ability.sz;
  for(q1=0;q1<c;q1++){perm.pb(q1);able.pb((double)ability[q1]);}
  encode[perm]=0;
  decode[0]=perm;
  while(next_permutation(perm.begin(),perm.end()))
    {cc++;
    encode[perm]=cc;
    decode[cc]=perm;}
  for(q1=0;q1<=cc;q1++)
    {perm=decode[q1];
    for(q2=0;q2<c;q2++)
      {c3=calc(perm,q2);
      VI perm2=perm;
      edge e1;
      if(q2==c-1)
        {if(perm[0]==0)e1.to=-1;
        else e1.to=-2;
        e1.p=c3;
        nei[q1][ns[q1]++]=e1;
        continue;}
      c2=perm2[0];
      perm2.erase(perm2.begin());
      for(q3=0;q3<q2;q3++)
        {c1=perm2[0];
        perm2.erase(perm2.begin());
        perm2.pb(c1);
        }
      perm2.pb(c2);
      e1.to=encode[perm2];
      e1.p=c3;
      nei[q1][ns[q1]++]=e1;}}
  res=dfs(0,0,1.0);
  return res;}
};