/*
TASK: cowski
LANG: C++
*/
#include<cstdio>
#include<cstdlib>
#include<queue>
using namespace std;

#define inf 1e100
#define mx 128
#define in fopen("cowski.in","r")
#define ou fopen("cowski.out","w");
FILE*fn;
typedef struct {int x,y;double time;} vert;;
bool operator < (const vert&a,const vert&b) { return a.time > b.time;}

priority_queue < vert > q;

int map[mx][mx];
double ss[mx][mx];
int vis[mx][mx];
int x,y,q1,q2;
double v;

double sp(double a,int dif)
  {int q1;
  double coef=1.0;
  for(q1=0;q1<abs(dif);q1++)coef*=2.0;
  if(dif<0)coef=1.0/coef;
  return a*coef;}
  
vert e1,e2;
  

int main()
  {fn=in;
  fscanf(fn,"%lf %d %d",&v,&x,&y);
  for(q1=0;q1<x;q1++)for(q2=0;q2<y;q2++)fscanf(fn,"%d",&map[q1][q2]);
  for(q1=0;q1<x;q1++)for(q2=0;q2<y;q2++)ss[q1][q2]=inf;
  ss[0][0]=0.0;
  e1.x=e1.y=0;
  e1.time=0.0;
  q.push(e1);
  
  while(!q.empty())
    {e1=q.top();
    q.pop();
    if(vis[e1.x][e1.y])continue;
    vis[e1.x][e1.y]=1;
    for(q1=-1;q1<=1;q1++)for(q2=-1;q2<=1;q2++)if(q1*q2==0)if(!(q1==0&&q2==0))
      if(e1.x+q1>=0&&e1.x+q1<x)if(e1.y+q2<y&&e1.y+q2>=0)
        {e2.x=e1.x+q1;
        e2.y=e1.y+q2;
        e2.time=e1.time+1.0/sp(v,-map[e1.x][e1.y]+map[0][0]);
        if(ss[e2.x][e2.y]<e2.time)continue;
  //      printf("%lf\n",e2.time);
        ss[e2.x][e2.y]=e2.time;
        q.push(e2);  
        }
    }
  
  fclose(fn);
  fn=ou;
  fprintf(fn,"%.2lf\n",ss[x-1][y-1]);
  fclose(fn);
  return 0;}
