/*
PROG: flight
LANG: C++
*/
#include<algorithm>
using namespace std;
#include<stdio.h>
#include<stdlib.h>
#define mx 32768
#define in fopen("flight.in","r")
#define out fopen("flight.out","w")
FILE*fn;
typedef struct{short l,r,m,sum,max;} node;
typedef struct{short from,to,broi;}flight;

int MAX(int a,int b){return a>b?a:b;}


node h[mx*2];
int build(int where,int l,int r)
  {if(where>=mx)
    {h[where].l=h[where].m=h[where].r=l;
    h[where].sum=h[where].max=0;
    return 0;}
  h[where].m=(l+r)/2;
  h[where].l=l;
  h[where].r=r;
  h[where].sum=h[where].max=0;
  build(where*2,l,h[where].m);
  build(where*2+1,h[where].m+1,r);
  return 0;}

int update(int where,int l,int r,int n)
  {if(h[where].l==l&&h[where].r==r)
    {h[where].sum+=n;
    return h[where].max+h[where].sum;}
  if(r<=h[where].m)h[where].max=MAX(h[where].max,update(where*2,l,r,n));
  else
  if(l>h[where].m)h[where].max=MAX(h[where].max,update(where*2+1,l,r,n));
  else
  h[where].max=MAX(update(where*2,l,h[where].m,n),update(where*2+1,h[where].m+1,r,n));
  return h[where].max+h[where].sum;}

int findmax(int where,int l,int r,int n)
  {if(h[where].l==l&&h[where].r==r)
    return h[where].max+n+h[where].sum;
  if(r<=h[where].m)return findmax(where*2,l,r,n+h[where].sum);
  if(l>h[where].m)return findmax(where*2+1,l,r,n+h[where].sum);
  return MAX(findmax(where*2,l,h[where].m,n+h[where].sum),findmax(where*2+1,h[where].m+1,r,n+h[where].sum));}


/*int cmp(flight*aa,flight*bb)
  {return aa->to-bb->to;}*/

int q1,q2,c1,c2,c3,c4,c5,c6;
flight e1,e2,e3;

flight forward[mx*4];
flight backward[mx*4];
int fc,bc;

int c,m,cap,ans;


bool operator < (flight a, flight b) {return a.to <b.to;}

int main()
  {fn=in;
  fscanf(fn,"%d %d %d",&m,&c,&cap);
  for(q1=0;q1<m;q1++)
    {fscanf(fn,"%d %d %d",&c1,&c2,&c3);
    c1--;c2--;
    e1.from=c1;
    e1.to=c2;
    e1.broi=c3;
    if(e1.from<e1.to)forward[fc++]=e1;
    else
      {e1.to=c-1-e1.to;
      e1.from=c-1-e1.from;
      backward[bc++]=e1;}}
 // qsort(forward,fc,sizeof(forward[0]),cmp);
 // qsort(backward,bc,sizeof(backward[0]),cmp);
  sort(forward,forward+fc);
  sort(backward,backward+bc);
  fclose(fn);

  build(1,0,mx-1);

  for(q1=0;q1<fc;q1++)
    {e1=forward[q1];
    c1=findmax(1,e1.from,e1.to-1,0);
    if(cap-c1<e1.broi)c2=cap-c1;
    else c2=e1.broi;
    if(c2==0)continue;
    update(1,e1.from,e1.to-1,c2);
    ans+=c2;}

  build(1,0,mx-1);

  for(q1=0;q1<bc;q1++)
    {e1=backward[q1];
    c1=findmax(1,e1.from,e1.to-1,0);
    if(cap-c1<e1.broi)c2=cap-c1;
    else c2=e1.broi;
    if(c2==0)continue;
    update(1,e1.from,e1.to-1,c2);
    ans+=c2;}

  fn=out;
  fprintf(fn,"%d\n",ans);
  fclose(fn);
  return 0;}
