/*
PROG: camelot
ID: swetko1
*/
#include<stdio.h>
#include<math.h>
#define mcol 42
#define mrow 42
#define mx 200000
FILE*fn;
long knc[mcol*mrow*8/7];
long knr[mcol*mrow*8/7];
long kd[mcol][mrow];
long kndwk[mcol][mrow];
long knd[mcol][mrow];
long all[mcol][mrow];
long knm[mcol][mrow];
long q1,q2;
long col,row,nk;
long kc,kr;
long c,r;
long c1,c2;
char cc[2];
long m(long gc,long gr){if(gc<col)if(gc>=0)if(gr<row)if(gr>=0)return 1;return 0;}
long mk(long v1,long v2,long d,long&f){if(m(v1,v2))if(knd[v1][v2]>d+1){knd[v1][v2]=d+1;f=1;}return 0;}
long mkwk(long v1,long v2,long d,long&f){if(m(v1,v2))if(kndwk[v1][v2]>d+1){kndwk[v1][v2]=d+1;f=1;}return 0;}
long move(long cc,long rr)
  {long f=0,d=knd[cc][rr],v1,v2;
  v1=cc+1;v2=rr+2;mk(v1,v2,d,f);
  v1=cc+1;v2=rr-2;mk(v1,v2,d,f);
  v1=cc-1;v2=rr+2;mk(v1,v2,d,f);
  v1=cc-1;v2=rr-2;mk(v1,v2,d,f);
  v1=cc+2;v2=rr+1;mk(v1,v2,d,f);
  v1=cc+2;v2=rr-1;mk(v1,v2,d,f);
  v1=cc-2;v2=rr+1;mk(v1,v2,d,f);
  v1=cc-2;v2=rr-1;mk(v1,v2,d,f);
  if(kndwk[cc][rr]>d+kd[cc][rr]){kndwk[cc][rr]=d+kd[cc][rr];if(kd[cc][rr]>f)f=kd[cc][rr];}
  return f;}
long movewk(long cc,long rr)
  {long f=0,d=kndwk[cc][rr],v1,v2;
  v1=cc+1;v2=rr+2;mkwk(v1,v2,d,f);
  v1=cc+1;v2=rr-2;mkwk(v1,v2,d,f);
  v1=cc-1;v2=rr+2;mkwk(v1,v2,d,f);
  v1=cc-1;v2=rr-2;mkwk(v1,v2,d,f);
  v1=cc+2;v2=rr+1;mkwk(v1,v2,d,f);
  v1=cc+2;v2=rr-1;mkwk(v1,v2,d,f);
  v1=cc-2;v2=rr+1;mkwk(v1,v2,d,f);
  v1=cc-2;v2=rr-1;mkwk(v1,v2,d,f);
  return f;}
long cdist(long cl,long rw)
  {long qr,ql;
  long d,f,max;
  for(qr=0;qr<row;qr++)for(ql=0;ql<col;ql++)knd[ql][qr]=kndwk[ql][qr]=mx;
  knd[cl][rw]=0;
  max=kndwk[cl][rw]=kd[cl][rw];
  for(d=0;d<=max;d++)for(ql=0;ql<col;ql++)for(qr=0;qr<row;qr++)
  {if(knd[ql][qr]==d)
    {f=move(ql,qr);
    if(max<d+f)max=d+f;}
  if(kndwk[ql][qr]==d)
    {f=movewk(ql,qr);
    if(max<d+f)max=d+f;}}
  return 0;}
int main()
  {fn=fopen("camelot.in","r");
  fscanf(fn,"%d %D\n",&row,&col);
  fscanf(fn,"%s %D",cc,&c2);
  c1=cc[0]-65;c2--;
  kc=c1;kr=c2;
  q1=-1;
  while(fscanf(fn,"%s %D",cc,&c2)!=EOF){c1=cc[0]-65;c2--;q1++;knc[q1]=c1;knr[q1]=c2;}
  nk=q1+1;
  fclose(fn);
  fn=fopen("camelot.out","w");
  for(c=0;c<col;c++)for(r=0;r<row;r++)
    {c1=abs(kc-c);
    c2=abs(kr-r);
    if(c1<c2)c1=c2;
    kd[c][r]=knm[c][r]=c1;}
  for(q1=0;q1<mcol;q1++)for(q2=0;q2<mrow;q2++)all[q1][q2]=0;
  for(q1=0;q1<nk;q1++)
    {c1=knc[q1];
    c2=knr[q1];
    cdist(c1,c2);

    for(c=0;c<col;c++)for(r=0;r<row;r++)
      {all[c][r]+=knd[c][r];
      if(kndwk[c][r]-knd[c][r]<knm[c][r])knm[c][r]=kndwk[c][r]-knd[c][r];}}
  c1=mx;
  for(q1=0;q1<col;q1++)
    for(q2=0;q2<row;q2++)
      if(c1>all[q1][q2]+knm[q1][q2])
        c1=all[q1][q2]+knm[q1][q2];
  fprintf(fn,"%d\n",c1);
  fclose(fn);
  return 0;}